/** Klasa reprezentuje element grafu aktywnosci (wezel lub tranzycje */
public class GraphObject //extends GameObject
{
	//PUBLICZNE 
    /** nazwa elementu grafu*/
	String m_sName;
    // dane o fizyce, jesli obietk jest animacja
	boolean m_bPhysic;
	int m_nPhysicType;
	/** czas morfowania	 */
	float m_fMorphTime;
	
	/**  Lista dziewkow zwiazanych z tym obiektem grafu*/	 
	MediaList m_sounds;

	
	//KONSTRUKTORY
	GraphObject()
	{
        m_bPhysic = false;
		m_nPhysicType= EPhysics._NONE;
		m_fMorphTime= 0.0f;
	}
	//INTERFEJS
	/** nadaje nazwe
	 */
	public void SetName(String sName)
	{
		m_sName = sName;
	}
	public String GetName()
	{
	   return m_sName;					
	}
	public boolean IsName(String sName)
	{
	  return m_sName.equals(sName)	;
	}
	/** Dodaje liste dzwiekow*/
	public void SetSounds(MediaList soundList)
	{
	   m_sounds = soundList;	
	}
	/** Dodaje 1 dzwiek  do konca listy dzwiekow */
	public void AddSound(Sound sound)
	{
		if( m_sounds ==null)
				m_sounds= new MediaList();
		
		m_sounds.AddObject(sound);
	}
	/** Zwraca dzwiek nIndex */
	public Sound GetSound(int nIndex)
	{
	  return (Sound)m_sounds.GetObject(nIndex);	
	}
	/** Zwraca liczbe dzwiekow w obiekcie	 */
	public int GetSoundCount()
	{
	   if(m_sounds==null)
		   return 0;
	   else
		return m_sounds.GetSize();
	}
	 
	/** Wlacza/wylacza fizyke dla obiektu */
	public void SetPhysic(boolean bActive)
	{
		m_bPhysic = bActive;
	}
	/** Ustawia typ fizyki */
	public void SetPhysicType(int nPhysicType)
	{
	   m_nPhysicType = nPhysicType;	
	}
	/** Ustawia cza morphingu */
	public void SetMorphTime(float fMorphTime)
	{
		m_fMorphTime = fMorphTime;
	}
	
	/** wyswietla sie w logu 	 */
	void Show()
	{
		GameObject.LogLine("    Sounds: ");
		if(m_sounds!=null)
		     m_sounds.Show();	
	}
    
    void delete()
    {
        if (m_sounds != null)
            m_sounds.delete();        
        m_sounds = null;
    }
}
