/** Okresla mozliwe ustawienia typu kolizji z promieniami, czyli dla metod Trace...
 */
public class ECollTraceFlags
{
    // kolizja ze zgrubnym boxem dla calego obiektu, ustawione defaultowo
    final static int _COARSE_BOX       = 0x00000001;
    
    // kolizja z elipsoida dla calego obiektu
    final static int _COARSE_ELIPSOID  = 0x00000002;
    
    // kolizja z boxem dla kazdego elementu mesha, po kolizji jest zwracany numer elementu kolidujacego
    final static int _ELEMENT_BOX      = 0x00000003;
    
    // kolizja z elipsoida dla kazdego elementu mesha, po kolizji jest zwracany numer elementu kolidujacego
    final static int _ELEMENT_ELIPSOID = 0x00000004;
    
    // kolizja per face z obiektem, ale dziala tylko jak jest wygenerowane luztree dla obiektu
    final static int _HULL             = 0x00000005;

    // kolizja z extentami obiektu
    final static int _EXTENTS       = 0x00000006;
    
    static String GetFlagName(int nFlag)
    {
        String sRet = "__UNKNOWN FLAG____";
        switch (nFlag)
        {
            case _COARSE_BOX:
                sRet = "_COARSE_BOX";
                break;
            case _COARSE_ELIPSOID:
                sRet = "_COARSE_ELIPSOID";
                break;                
            case _ELEMENT_BOX:
                sRet = "_ELEMENT_BOX";
                break;                
            case _ELEMENT_ELIPSOID:
                sRet = "_ELEMENT_ELIPSOID";
                break;                
            case _HULL:
                sRet = "_HULL";
                break;                
            case _EXTENTS:
                sRet = "_EXTENTS";
                break;

        }
        return sRet;
    }
}
