/** Kolejnosc rysowania efektow. UWAGA: powinny sie zgadzac z 
CFXManager::EPolyDrawingPriority z pliku FXManager.hpp .
Roznice pomiedzy priorytetami rysowania poszczegolnych efektow sa na tyle duze
by mozna bylo "wcisnac" cos pomiedzy nie np. grzebienie strzalu
sa rysowane z priorytetem (_DRAW_LENS_FLARE - 1) czyli moga je zaslaniac 
tylko lensflary i oslepiacz.
*/
public class EFXDrawPriority
{
    final static int _DRAW_FIRST        = 0x00; ///< raczej nie uzywac
    final static int _DRAW_TRACES       = 0x01; ///< slady na ziemi
    final static int _DRAW_DECALS       = 0x02; ///< nalepki
    final static int _DRAW_SEQUENCES    = 0x05; ///< sekwencje
    final static int _DRAW_NORMAL       = 0x08; ///< deszcz, particle, szklo
    final static int _DRAW_LENS_FLARE   = 0x0D; ///< lensflara
    final static int _DRAW_BLINDER      = 0x0E; ///< oslepiacz
    final static int _DRAW_LAST         = 0x0F; ///< raczej nie uzywac

    static String GetFlagName(int nFlag)
    {
        switch( nFlag )
        {
            case _DRAW_FIRST:
                return "_DRAW_DIRECTED_QUADS";
            case _DRAW_TRACES:
                return "_DRAW_SQUARE_SPRITES";
            case _DRAW_DECALS:
                return "_DRAW_DECALS";
            case _DRAW_SEQUENCES:
                return "_DRAW_SEQUENCES";
            case _DRAW_NORMAL:
                return "_DRAW_NORMAL";
            case _DRAW_LENS_FLARE:
                return "_DRAW_LENS_FLARE";
            case _DRAW_BLINDER:
                return "_DRAW_BLINDER";
            case _DRAW_LAST:
                return "_DRAW_LAST";
            default:
                return "__UNKNOWN DRAW FLAG____";
        }
    }

}
