/** Definicja trybow morfingu dla meshy. 
    definicja MUSI byc zgodna z definicja EMorphType w RendererGlobals.h
    
    NONE : mesh nie bierze udzialu w morfingu;
    TARGET : mesh jest celem do ktorego nastepuje morfing;
    SOURCE : mesh jest zrodlem z ktorego morfujemy;

    ogolny wzor na morfing
    MeshWynikowy = MeshSOURCE * (1-WAGA) + MeshTARGET * WAGA;
*/
public class EMorphType
{
    final static int NONE   =   0;
    final static int TARGET =   1;
    final static int SOURCE =   2;

    static String GetFlagName( int nFlag )
    {
        switch( nFlag )
        {
            case NONE:
                return "NONE";
            case TARGET:
                return "TARGET";
            case SOURCE:
                return "SOURCE";
            default:
                return "__UNKNOWN MORPH____";
        }
    }
}

