/** Sposoby reakcji bryly sztywnej ODE w momencie kolizji.
    UWAGA: wartosci musza byc zgodne z enumem CODEPhysics::ECollisionResponse
    zdefiniowanym w pliku "ODEPhysics.h".
*/
public class EODECollisionResponse
{
    final static int _ODE_COLLISION_IGNORE     =   0;               // brak reakcji na kolizje (penetracja)
    final static int _ODE_COLLISION_AUTO       =   1;               // reakcja jest automatycznie ustalana na podstawie materialow kolidujacych obiektow
    final static int _ODE_COLLISION_BOUNCE     =   2;               // odbicie
    final static int _ODE_COLLISION_SLIDE      =   3;               // slizganie sie po powierzchni kontaktu
    final static int _ODE_COLLISION_STICK      =   4;               // przyklejenie sie do siebie
    final static int _ODE_COLLISION_USER       =   5;               // uzytkownik definiuje wszystkie parametry reakcji na kolizje

    static String GetFlagName( int nFlag )
    {
        switch( nFlag )
        {
            case _ODE_COLLISION_IGNORE:
                return "_ODE_COLLISION_IGNORE";
            case _ODE_COLLISION_BOUNCE:
                return "_ODE_COLLISION_BOUNCE";
            case _ODE_COLLISION_SLIDE:
                return "_ODE_COLLISION_SLIDE";
            case _ODE_COLLISION_STICK:
                return "_ODE_COLLISION_STICK";
            case _ODE_COLLISION_USER:
                return "_ODE_COLLISION_USER";
            default:
                return "_ODE_COLLISION_UNKNOWN";
        }
    }
}

