/** Sposob w jaki ODE kontroluje pozycje podleglego CControlObject-u.
UWAGA: Musi byc synchronizowane z enumem ODEPhysics::EControlMode w pliku ODEPhysics.h
*/
public class EODEControlMode
{
	final static int _NONE              = 0;            // Brak kontroli ODE nad ControlObjectem - uzytkownik sam steruje ControlObjectem
    final static int _CENTER_BODY       = 1;            // ODE ustawia pozycje i obrot na podstawie pozycji i obrotu 
                                                        // Wybranej bryly 'centrum'
    final static int _CENTER_OF_MASS    = 2;            // Ustawia pozycje na podstawie pozycji srodka masy wszystkich bryl
                                                        // zdefiniowanych w obiekcie
    
    static String GetFlagName(int nFlag)
    {
        String sRet = "__UNKNOWN FLAG____";
        switch (nFlag)
        {
            case _NONE:
                return "_NONE";
            case _CENTER_BODY:
                return "_CENTER_BODY";
            case _CENTER_OF_MASS:
                sRet = "_CENTER_OF_MASS";
            default:
                return "__UNKNOWN FLAG____";
        }
    }
}

