public class FXEmitter extends EditorRenderableObject implements iact_StartStop
{
    public String sFXName = null;//#FXEmitter;
    public String sParticleSystemName = null;//#FXEmitter;
    
    public FileName sSound = null;//#FXEmitter;
    
    public float fMinSound = 10000.f;//#FXEmitter;
    public float fMaxSound = 15000.f;//#FXEmitter;
    
    public float fUpdateInterval = -1;//#FXEmitter;Time between fx execution (when <0 - executes fx once)
    
    protected boolean m_bIsStarted = false;
    
    public boolean m_bAutoStart = false;//#FXEmitter;If true, emitter starts upon creation
    
    int METHOD_ExecuteFXs = 0;
    
    FXEmitter()
	{		
		iRenderType = EEditorRenderType._MESH;
		EditorMeshName = "data\\interface\\Glow.3DA";
	}
    
    
    public void OnCreate()
    {
        METHOD_ExecuteFXs = RegisterCallMethod("ExecuteFXs");
		bSG = true;
        if (m_bAutoStart)
            Start();
    }
	
    
    // wolane gdy edytor dodaje ten obiekt
    public void OnEditorObjectAdd(ControlObject[] aSelectedObject)
    {
    }
    
    // wolane gdy edytor kasuje ten obiekt
    public void OnEditorObjectDel()
    {
    }
    
    //
    public boolean UpdateDataByMatrix(){ return false;}
    
    //
	public boolean UpdateMatrixByData(){ return false;}
    

    
    
    public void Start()
    {
        CrashLog(this + " Start");
        if (fUpdateInterval < 0)
            ExecuteFXs();
        else
        {
            CallMethodIn(METHOD_ExecuteFXs, 0);
            CallMethodEvery (METHOD_ExecuteFXs, fUpdateInterval);
        }
        m_bIsStarted = true;
    }

    public void Stop()
    {
        DisableCallMethod(METHOD_ExecuteFXs);
        m_bIsStarted = false;
    }
    
    public void ToggleStartStop()
    {
        if (m_bIsStarted)
            Stop();
        else
            Start();
    }
    
    protected void ExecuteFXs()
    {
        Vector vPos = GetPosition();
        Vector vUp = GetUpVector();
        
        if (sFXName != null)
            ExecuteFX(sFXName, vPos, vUp);
        if (sParticleSystemName != null)
            ExecuteParticleSystem(sParticleSystemName, vPos, vUp);
        if (sSound != null)
            AttachOneShotSound( sSound.toString(), fMinSound, fMaxSound );
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[FXEmitter.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunks._CHK_FX_EMITTER)
        {
			super.SGLoadChunk(cFC);
			
			m_bIsStarted = cFC.LoadBool();				
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[FXEmitter.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunks._CHK_FX_EMITTER, cFCParent);
		
		super.SGSaveChunk(cFC);
	
		cFC.SaveBool(m_bIsStarted);
					
		cFC.delete(); 
	}					
}
