/**Klasa opisuje macierz 4x4, wykorzystywana jest w operacjach dotyczacych
 * swiata 3d (np. macierze obrotow)
 */
class Matrix
{
	/**Dane zawarte w macierzy.
	 */
	float aMatrix[]=new float[16];

	/**Kasuje macierz do macierzy jednostkowej.*/
	void Identity()
	{
	  for(int i=0; i<4; i++)
		for(int j=0; j<4; j++)
			if(i==j) 
				aMatrix[4*i+j]=1.0f;
			else
				aMatrix[4*i+j]=0.0f;
	}

	/**Zwraca wektor bazowy x.
	 * @return wektor bazowy x (<code>Vector</code>)*/
	Vector GetBaseX() { return new Vector(aMatrix[0], aMatrix[1], aMatrix[2]); }
	
	/**Zwraca wektor bazowy y.
	 * @return wektor bazowy y (<code>Vector</code>)*/
	Vector GetBaseY() { return new Vector(aMatrix[4], aMatrix[5], aMatrix[6]); }

	/**Zwraca wektor bazowy z.
	 * @return wektor bazowy z (<code>Vector</code>)*/
	Vector GetBaseZ() { return new Vector(aMatrix[8], aMatrix[9], aMatrix[10]); }
	
	/**Zwraca pozycje zapisana w macierzy
	 * @return pozycja (znaczenie zalezne od uzycia macierzy) (<code>Vector</code>)*/
	Vector GetPos() { return new Vector(aMatrix[12], aMatrix[13], aMatrix[14]); }

	/**Ustawia wektor bazowy x.
	 * @param Base nowy wektor bazowy x.*/
	void SetBaseX(Vector Base) { aMatrix[0]=Base.fX; aMatrix[1]=Base.fY; aMatrix[2]=Base.fZ; }
	
	/**Ustawia wektor bazowy y.
	 * @param Base nowy wektor bazowy y.*/
	void SetBaseY(Vector Base) { aMatrix[4]=Base.fX; aMatrix[5]=Base.fY; aMatrix[6]=Base.fZ; }
	/**Ustawia wektor bazowy z.
	 * @param Base nowy wektor bazowy z.*/
	void SetBaseZ(Vector Base) { aMatrix[8]=Base.fX; aMatrix[9]=Base.fY; aMatrix[10]=Base.fZ; }

	/**Ustawia pozycje zapisana w macierzy.
	 * @param Base nowa pozycja.*/
	void SetPos(Vector Base) { aMatrix[12]=Base.fX; aMatrix[13]=Base.fY; aMatrix[14]=Base.fZ; }

	// teraz najgorsze ! TODO obroty, from vector and pos, inversja, mnozenie przez wektor, macierz razy macierz

}