class Edit extends Button
{
    final static int EDIT_OK = 1;
    final static int EDIT_CANCEL = 2;
    boolean bLCtrl = false;
    boolean bRCtrl = false;
    boolean bLAlt = false;
    boolean bRAlt = false;
    boolean bLShift = false;
    boolean bRShift = false;
    String sOldText = "";
    String sPassText = "";
    
    int m_nTextPosFlags =  ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_LEFT;
    Sprite m_cCursorSprite = null;
    String m_sCursorSign = "_";
    float m_fCursorBlinkPeriod = 0.5f;
    
    /**limit znakow w edicie, jesli = -1 to mozna wpisac tyle ile sie zmiesci*/
    int nCharsLimit = -1;
    
	boolean m_bSetUpper = false;     // Ustawienie, czyh maja byc wpisywane tylko wielkie litery
	boolean m_bIsPassword = false;   // Znacznik, ze zamiast wpisywanego tekstu maja sie pojawiac gwiazdki
    
    
    void Init(UIElement data, Module module)
    {
        super.Init(data, module);
        InitCursorSprite();
    }
    
    void InitCursorSprite()
    {
        if (m_cCursorSprite != null)
            return;
        m_cCursorSprite = (Sprite)CreateObject("Sprite");
        AddChild(m_cCursorSprite);
        m_cCursorSprite.SetSize(new Vector(20,20,0));
        m_cCursorSprite.Hide();
    }
    
    /**Przeciazona metoda Buttona, gdy edit jest zaczekowany, mozna w nim pisac*/
    void SetCheck(boolean bCheck)
    {
        nIDExtra = -1;
        if (nBtnState == EButtonFlags.BTN_STATE_DISABLED) return;
        if (bCheck)
        {
            if (nCheckedTex != 0)
				SetTexture(nCheckedTex, rCheckedTex);
            sOldText = new String(sText);
            nBtnState = EButtonFlags.BTN_STATE_CHECKED;
            ProcessKb(true);
            UpdateText();
            CaptureMouse();
        }
        else
        {
            if (nUncheckedTex != 0)
				SetTexture(nUncheckedTex, rUncheckedTex);
            nBtnState = EButtonFlags.BTN_STATE_UNCHECKED;
            UpdateText();
            ProcessKb(false);
            ClearCaptureMouse();
        }
    }
    
    public void SetTextPosFlags(int nFlags)
    {
        m_nTextPosFlags = nFlags;
        super.SetTextPosFlags(nFlags);
        m_cCursorSprite.SetTextPosFlags(nFlags);
    }
    

    public boolean SetFont(String sFont)
    {
        boolean bRet = super.SetFont(sFont);
        if (m_cCursorSprite == null)
            InitCursorSprite();
        m_cCursorSprite.SetFont(sFont);
        m_cCursorSprite.DisplayTextFitSize(m_sCursorSign);
        return bRet;
    }
    
    void OnKeyPressed(int nKey, char nAsci)
    {
        switch(nKey)
        {
            case EKey._LCONTROL :
                bLCtrl = true;
                break;
            case EKey._RCONTROL :
                bRCtrl = true;
                break;
            case EKey._LSHIFT :
                bLShift = true;
                break;
            case EKey._RSHIFT :
                bRShift = true;
                break;
            case EKey._LMENU :
                bLAlt = true;
                break;
            case EKey._RMENU :
                bRAlt = true;
                break;
        }
    }
    
    void OnKeyReleased(int nKey, char nAsci)
	{
        //LogLine("nKey: " + nKey + " nAsci: "+ nAsci);
        String sChr = "";
        char chr = ' ';
        switch(nKey)
        {
            case EKey._LCONTROL :
                bLCtrl = false;
                break;
            case EKey._RCONTROL :
                bRCtrl = false;
                break;
            case EKey._LSHIFT :
                bLShift = false;
                break;
            case EKey._RSHIFT :
                bRShift = false;
                break;
            case EKey._LMENU :
                bLAlt = false;
                break;
            case EKey._RMENU :
                bRAlt = false;
                break;
            case EKey._BACK:OnKeyBackspace();break;
            case EKey._RETURN:OnKeyEnter();break;
            case EKey._ESCAPE:OnKeyEscape();break;                                          
            default: 
				chr = (char)nAsci;		
                sChr += chr;
                if (!bLAlt && !bRAlt && !bRCtrl && !bLCtrl)
                {
                         /*if (bLShift || bRShift)
                            sChr = sChr.toUpperCase();
                         else 
                            sChr = sChr.toLowerCase();*/
                    if (CheckExtent(sText+chr))
                       sText += sChr;						 
                }					 						 
                
				//LogLine("bSetUpper: " + m_bSetUpper);
				
				if (m_bSetUpper)
					sText = TextToUpperCase(sText);
        }
//        sText = sText.toLowerCase();
        UpdateText();
	}
    
    /**Sprawdza, czy tekst miesci sie na szerokosc w edicie, bierze pod uwage maksymalna 
     * ilosc znakow.
     */
    boolean CheckExtent(String sText)
    {
        if (nCharsLimit != -1)
        {
            //TODO ewentualnie sprawdzac jeszcze czy sie miesci w edicie
            return sText.length() <= nCharsLimit;
        }
        else
        {
            String sTest = new String(sText) + "   ";
            Vector vText = GetTextExtent(sTest);
        
                
            if (vText.fX >= GetSize().fX) 
                return false;
            else
                return true;
        }
    }
    
    void OnKeyBackspace()
    {
        int nSLen = sText.length();
        if (nSLen > 0) sText = sText.substring(0, nSLen - 1);
        UpdateText();
        //SetCheck(true);
    }

    String sTextToDisplay = "";
    void UpdateText()
    {
       
        if (m_bIsPassword) // wygeneruj haslo
        {
            int nCharsToGenerate = sText.length() - sPassText.length();
            while (nCharsToGenerate-- > 0)
                sPassText+='*';
            sTextToDisplay = sPassText.substring(0, sText.length());    
        }
        else
            sTextToDisplay = sText;
        
        SetTextPosFlags(m_nTextPosFlags);
        DisplayText(sTextToDisplay);
        if (GetCheck())
        {
            ShowTextCursor(true);
            UpdateTextCursorPos();
            //DisplayText("  " + sTextToDisplay + "|");
        }
        else
        {
            ShowTextCursor(false);
            
            //DisplayText("  " + sTextToDisplay);
        }
        
    }
    
    void ShowTextCursor(boolean bShow)
    {
        DisableCallMethod("BlinkCursor");
        if (bShow)
        {
            m_cCursorSprite.Show();
            CallMethodEvery("BlinkCursor", m_fCursorBlinkPeriod);
        }
        else
        {
            m_cCursorSprite.Hide();
        }
    }
    
    void UpdateTextCursorPos()
    {
        Vector vCursorPos = new Vector();
        if (sTextToDisplay.length() != 0)
        {
            vCursorPos = GetTextExtent(sTextToDisplay);
            vCursorPos.fY = 0;
            vCursorPos.Add(GetTextPos());
            
        }
        else
        {
            Vector vLetterSize = GetTextExtent("N");
            //TODO przetestowac
            if ((m_nTextPosFlags & ESpriteText.HORIZ_LEFT) == ESpriteText.HORIZ_LEFT)
            {
                vCursorPos.fX = 0;
            }
            if ((m_nTextPosFlags & ESpriteText.HORIZ_MIDDLE) == ESpriteText.HORIZ_MIDDLE)
            {
                vCursorPos.fX = GetSize().fX/2f;
            }
            if ((m_nTextPosFlags & ESpriteText.HORIZ_RIGHT) == ESpriteText.HORIZ_RIGHT)
            {
                vCursorPos.fX = GetSize().fX;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_TOP) == ESpriteText.VERT_TOP)
            {
                vCursorPos.fY = 0;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_MIDDLE) == ESpriteText.VERT_MIDDLE)
            {
                vCursorPos.fY = GetSize().fY/2f - vLetterSize.fY/2f;
            }
            if ((m_nTextPosFlags & ESpriteText.VERT_BOTTOM) == ESpriteText.VERT_BOTTOM)
            {
                vCursorPos.fY = GetSize().fY - vLetterSize.fY;
            }
        }
        m_cCursorSprite.SetRelativePos(vCursorPos);
    }
    
    void BlinkCursor()
    {
        if (m_cCursorSprite.IsVisible())
        {
            m_cCursorSprite.Hide();
        }
        else
        {
            m_cCursorSprite.Show();
        }
    }
    
    void OnKeyEnter()
    {
        SetCheck(false);
        SetHighlight(false, false);
        nIDExtra = EDIT_OK;
        CallOnButton(this);
    }
    
    void OnKeyEscape()
    {
        SetText(sOldText);
        //sText = sOldText;        
        UpdateText();
        nIDExtra = EDIT_CANCEL;
        SetCheck(false);
        SetHighlight(false, false);
        CallOnButton(this);
    }
    
    /**Wpisuje do edita dany tekst.
     */
    void SetText(String sNewText)
    {
        sOldText = new String(sNewText);
        super.SetText(sNewText);
        UpdateText();            
    }
    
    void OnRBDownOut(float fMouseX, float fMouseY)
    {
        OnKeyEnter();
    }
    
    void OnLBDownOut(float fMouseX, float fMouseY)
    {
        OnKeyEnter();
    }
    
    public void DumpHeader(ScriptWriter cWriter)
    {
        cWriter.Write("Button(\"" + "UIEdit" /*getClass().getName()*/ + "\"" + ", \"ID_" + String.valueOf(nID) + "\", \"" + sText + "\", \"Specific\")");
    }
    
    public void DumpData(ScriptWriter cWriter)
    {
        super.DumpData(cWriter);
    }
}
