/**Tutaj musza byc przechowywane wszystkie fonty, jesli chcesz uzyc fonta, ktorego tu
 * nie ma, to nalezy go dopisac. Przy tworzeniu modulu nalezy utworzyc obiekt tej
 * klasy i wywolac funkcje Init(..)
 * UWAGA nie wszystkie rozmiary fonta MS Sans Serif "dzialaja"!!!!*/
public class Fonts
{
    final static String FONT_MSSANSSERIF_08 = "MSSansSerif8";
    final static String FONT_MSSANSSERIF_10 = "MSSansSerif10";
    final static String FONT_MSSANSSERIF_12 = "MSSansSerif12";
    
    // klasa opisu jednego fonta(u)
	static class Font
	{
		String m_sFontID = null;
		String m_sTTFName = null;
		int m_iHeight = -1;
        int m_nStyle = 0;
        String m_sFormatFile = null;
        boolean m_bOldHeightMeasurement = false;
	}
	
    //wektor opisow fontow
	static java.util.Vector m_vFonts = new java.util.Vector();
	
	//domyslny font
	static int m_nDefaultFont = -1;
	
	Fonts()
	{
	    AddFont(FONT_MSSANSSERIF_08, "Microsoft Sans Serif", 8);
        //AddFont(FONT_MSSANSSERIF_10, "Microsoft Sans Serif", 10);  
        //AddFont(FONT_MSSANSSERIF_12, "Microsoft Sans Serif", 12);
        
		SetDefaultFont(FONT_MSSANSSERIF_08);
	}
	
    Module m_cModule = null;
    
    void Init(Module module)
    {
        //jesli juz zainicjowane dla danego modulu to wychodzimy
        if (m_cModule == module)
            return;
        else
            m_cModule = module;
        //module.LogLine("Fonts.Init");
		
	   if(m_cModule==null)
	   {
		   GameObject.CrashLog("[Font:AddFont] error: m_cModule==null");
		   return;
	   }
	   for(int i=0;i<m_vFonts.size();i++)
       {
		   Font cFont = (Font)m_vFonts.elementAt(i);
		   m_cModule.LoadFont(cFont.m_sFontID,cFont.m_sTTFName,cFont.m_iHeight, cFont.m_nStyle, cFont.m_sFormatFile, cFont.m_bOldHeightMeasurement);		
	   }
    }
	
    /** dodanie fonta oraz storzenie jego opisu, by byl dostepny 
     * w edytorze UI     */ 
	static void AddFont(String sFontID, String sTTFName, int iHeight)
	{
	   AddFont(sFontID, sTTFName, iHeight, 0);
	}
    
    static void AddFont(String sFontID, String sTTFName, int iHeight, int nStyle)
    {
        AddFont(sFontID, sTTFName, iHeight, nStyle, null, false);
    }
    
    static void AddFont(String sFontID, String sTTFName, int iHeight, int nStyle, String sFormatFile, boolean bOldHeightMeasurement)
	{
	   Font cFont = new Font();
	   cFont.m_sFontID = sFontID;
	   cFont.m_sTTFName = sTTFName;
	   cFont.m_iHeight = iHeight;
       cFont.m_nStyle = nStyle;
       cFont.m_sFormatFile = sFormatFile;
       cFont.m_bOldHeightMeasurement = bOldHeightMeasurement;
       m_vFonts.addElement(cFont);	   
	}
    
    void RemoveFont(String sFontID)
    {
        ((GameObject)m_cModule).ReleaseFont(sFontID);
        m_vFonts.removeElementAt(GetFontVectorInd(sFontID));
    }
    
	/** ustawia font domyslny	 */
	void SetDefaultFont(String sFontId)
	{
       for(int i=0;i<m_vFonts.size();i++)
       {
		   Font cFont = (Font)m_vFonts.elementAt(i);		
		   if(cFont.m_sFontID.equals(sFontId)) 
		   {
			   m_nDefaultFont = i;
		       break;
		   }			   
	   }
	}
	/** zwraca identyfikator domyslnego font,lub jesli nie jest ustawiony to pierwszy w 
	 * z wektora fontow (jesli jest, p.p null)
	 */
	static String GetDefaultFont()
	{
		int nFont = m_nDefaultFont;
		if( nFont <0 ||nFont>=m_vFonts.size())
			nFont=0;
	   if(m_vFonts.size()>0)	
		   return ((Font)m_vFonts.elementAt(nFont)).m_sFontID;
	   else
		   return null;
	}
	/** zwraca numer w wektorze fontow
	 */
	static int GetFontVectorInd(String sFontInd)	
	{
       for(int i=0;i<m_vFonts.size();i++)
       {
		   Font cFont = (Font)m_vFonts.elementAt(i);		
		   if(cFont.m_sFontID.equals(sFontInd)) 
              return i;
	   }		
	   return -1;
	}
    
    /**Narzedzie do odgornego sterowania wielkoscia fontu w zaleznosci od rozdzielczosci*/
    void UIStaticSetFont(UIStatic cStatic, String sFontID)
    {
        //TODO pokryc w klasie potomnej i uzywac zmodyfikowanych sFontID
        cStatic._SetFont(GetProperFont(sFontID));
    }
    
    String GetProperFont(String sFontID)
    {
        return sFontID;
    }
}
