//import javax.swing.*; 

public class UIButton extends UIControlObject
{
	/*tekstura w stanie wcisnietym/zaznaczonym*/
    UITexture m_cCheckedTex = null;
    float m_fCheckedTextureAlpha = 1.0f;
    float m_fCheckedTextAlpha = 1.0f;    
	// kolor
	Vector  m_vCheckedTxtColor =null;
	/**tekstura wyszarzona (przycisk nieaktywny)*/
    UITexture m_cDisabledTex= null;
    float m_fDisabledTextureAlpha = 1.0f;
    float m_fDisabledTextAlpha = 1.0f;        
	// kolor
	Vector  m_vDisabledTxtColor =null;	

	/**tekstura  zaznaczona z focusem*/
    UITexture m_cFocusCheckTex = null;
    float m_fFocusCheckTextureAlpha = 1.0f;
    float m_fFocusCheckTextAlpha = 1.0f;        
	// kolor
	Vector  m_vHighLigthCheckTxtColor =null;	
	/** czy przycisk mozna zaznaczac*/
	boolean m_bCanCheck=false;
	boolean m_bCanCallPress=false;
	

	boolean m_bChecked=false;
	
	boolean m_bDisabled=false;
	
	boolean m_bDoubleClick = false;
	/**Pamieta czas ostatniego klikniecia przycisku, potrzebne przy dblclicku*/
	float m_fClickTime = 0.0f;
	/** Czas po ktorym przepada sznasa na double click*/
	float m_fDoubleClickTime = EUIConst.DOUBLE_CLICK_TIME;
	/** seryjne akcje przy wcisnietym przyciku*/  	
	boolean m_bCallingPressButton = false;
	float m_fCallPressPeriod = 0.1f; //TODO EUIConst.CALL_PRESS_PERIOD & Parser
	
	/** Czy ma wylaczac focus po zjechaniu mysza z kontrolki */
	boolean m_bMouseLeaveDestroyFocus = true;	
	
	/** muzyka odgrywana przy zaznaczeniu	 */
	String m_sCheckSound = null;
    /**Jesli true to odegra sie dzwiek, ustawiane przy zaznaczaniu i checkowaniu
     * przyciskow mysza, jesli wymusimy zaznaczenie programowo, to dzwiek sie nie odpali*/
	boolean m_bPlayCheckSound = false;
    
	
    

	void OnCreate()
	{
		ProcessMouse(true);   
		((Sprite)this).SetTextPosFlags(ESpriteText.HORIZ_MIDDLE | ESpriteText.VERT_MIDDLE);
		super.OnCreate();
	}
	
	UIWindow GetSupervisor()
	{
		return m_cSupervisor;  
	}
   //=================== STEROWANIE ODSWIEZANIEM 	   	
	/** odswiezanie ctl-a     */	
	public void OnFrame()
	{
		if(!m_bInited)
			return;		
		super.OnFrame();	
	}
    
    
	public void OnTextureChange()
	{
		if(m_bChecked)
		{
			if(m_cCheckedTex != null)
				SetTexture(m_cCheckedTex);
            SetTextAlpha(m_fCheckedTextAlpha);
			if(m_vCheckedTxtColor != null)
			{
				SetTextColor(m_vCheckedTxtColor.fX,m_vCheckedTxtColor.fY,m_vCheckedTxtColor.fZ,m_fCurTextAlpha);  
			}		   
            SetAlpha(m_fCheckedTextureAlpha);
		}
		else
		{
			if(m_bDisabled)
			{
				if(m_cDisabledTex!= null)
					SetTexture(m_cDisabledTex);
                else
                    SetNoTexture();
                SetTextAlpha(m_fDisabledTextAlpha);
				if(m_vDisabledTxtColor != null)
				{
    				SetTextColor(m_vDisabledTxtColor.fX, m_vDisabledTxtColor.fY, m_vDisabledTxtColor.fZ,m_fCurTextAlpha);  
				}
                SetAlpha(m_fDisabledTextureAlpha);
			}
			else
            { 
                SetTextAlpha(m_fTextAlpha);
                SetTextColor(m_vTextColor.fX, m_vTextColor.fY, m_vTextColor.fZ, m_fCurTextAlpha);
				super.OnTextureChange();
                SetAlpha(m_fTextureAlpha);
            }
		}
	}
    
	public void OnFocusDisplay()
	{
		if(m_bDisabled)
			return;
		if(m_bChecked)
		{
			if(m_bFocus)	
			{
				if(m_cFocusCheckTex!=null)
				{
					SetTexture(m_cFocusCheckTex);
				}
				else //moze zwykly focustetxuture
				{
					if(m_cFocusTexture!= null)
						SetTexture(m_cFocusTexture);
                    else
                        SetNoTexture();
				}
                SetTextAlpha(m_fFocusCheckTextAlpha);
				if(m_vHighLigthCheckTxtColor != null)
				{
					SetTextColor(m_vHighLigthCheckTxtColor.fX, m_vHighLigthCheckTxtColor.fY, m_vHighLigthCheckTxtColor.fZ, m_fCurTextAlpha);  
				}
				else  //moze kolor tekstu dla zwyklego focusa
				{
					if(m_vHighLigthTxtColor!=null)
					{
						SetTextColor(m_vHighLigthTxtColor.fX, m_vHighLigthTxtColor.fY, m_vHighLigthTxtColor.fZ, m_fCurTextAlpha);  
					}	
				}
                SetAlpha(m_fFocusCheckTextureAlpha);
			}
			else
			{
				m_bFocus=false;  // klasa nadrzedna nie bedzie juz zmieniala tekstury			   
				OnTextureChange();
                SetAlpha(m_fCheckedTextureAlpha);
			}			
		}
		else
			super.OnFocusDisplay();
	}
    
    public void SetTextAllColors(float r, float g, float b)
    {
        super.SetTextAllColors(r, g, b);
        if (m_vDisabledTxtColor != null)
        {
            m_vDisabledTxtColor.Set(r, g, b);
        }
        if (m_vCheckedTxtColor != null)
        {
            m_vCheckedTxtColor.Set(r, g, b);
        }
        if (m_vHighLigthCheckTxtColor != null)
        {
            m_vHighLigthCheckTxtColor.Set(r, g, b);
        }
        
    }
    
    public void SetTextAllAlpha(float fAlpha)
    {
        super.SetTextAllAlpha(fAlpha);
        m_fDisabledTextAlpha = m_fCheckedTextAlpha = m_fFocusCheckTextAlpha = fAlpha;
    }
    
    /** ustwia alfe dla textury z zaznaczeniem*/
    void SetCheckedTextureAlpha(float fTextureAlpha)
    {
        m_fCheckedTextureAlpha = fTextureAlpha;
    }
    /** ustwia alfe dla textury z zaznaczeniem*/
    void SetCheckedTextAlpha(float fTextAlpha)
    {
        m_fCheckedTextAlpha = fTextAlpha;
    }    
    void SetDisabledTextureAlpha(float fTextureAlpha)
    {
        m_fDisabledTextureAlpha = fTextureAlpha;
    }        
    void SetDisabledTextAlpha(float fTextAlpha)
    {
        m_fDisabledTextAlpha = fTextAlpha;
    }            
    void SetFocusCheckTextureAlpha(float fTextureAlpha)
    {
        m_fFocusCheckTextureAlpha = fTextureAlpha;
    }
    void SetFocusCheckTextAlpha(float fTextAlpha)
    {
        m_fFocusCheckTextAlpha = fTextAlpha;
    }                
    
	boolean Load(ParseKeyword key)
	{
		ParseKeyword  paramKey;	  
		for(paramKey=key.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
		  if(paramKey.Equals("TextureChecked"))						 
			{	
				m_cCheckedTex = new UITexture(this);
				m_cCheckedTex.m_sFileName = paramKey.GetSParam(0);
				m_cCheckedTex.m_rRect = null;
				LoadTexture(m_cCheckedTex);				
			}
			if (paramKey.Equals("TextureCheckedRect"))  // tekstura wycieta 
            {
                
				m_cCheckedTex = new UITexture(this);
				m_cCheckedTex.m_sFileName = paramKey.GetSParam(0);
				m_cCheckedTex.SetRect(paramKey.GetFParam(1),
										 paramKey.GetFParam(2),
										 paramKey.GetFParam(3),
										 paramKey.GetFParam(4),
										 paramKey.GetFParam(5),
										 paramKey.GetFParam(6));										 
				LoadTexture(m_cCheckedTex);				
            }          

		  if(paramKey.Equals("TextureDisabled"))						 
			{	
				m_cDisabledTex = new UITexture(this);
				m_cDisabledTex.m_sFileName = paramKey.GetSParam(0);
				m_cDisabledTex.m_rRect = null;
				LoadTexture(m_cDisabledTex);				
			}
			if (paramKey.Equals("TextureDisabledRect"))  // tekstura wycieta 
            {
				m_cDisabledTex = new UITexture(this);
				m_cDisabledTex.m_sFileName = paramKey.GetSParam(0);
				m_cDisabledTex.SetRect(paramKey.GetFParam(1),
										 paramKey.GetFParam(2),
										 paramKey.GetFParam(3),
										 paramKey.GetFParam(4),
										 paramKey.GetFParam(5),
										 paramKey.GetFParam(6));										 
				LoadTexture(m_cDisabledTex);				
            }                      

		  if(paramKey.Equals("TextureHightlightCheck"))						 
			{	
				m_cFocusCheckTex = new UITexture(this);
				m_cFocusCheckTex.m_sFileName = paramKey.GetSParam(0);
				m_cFocusCheckTex.m_rRect = null;
				LoadTexture(m_cFocusCheckTex);				
			}
			if (paramKey.Equals("TextureHightlightCheckRect"))  // tekstura wycieta 
            {
				m_cFocusCheckTex = new UITexture(this);
				m_cFocusCheckTex.m_sFileName = paramKey.GetSParam(0);
				m_cFocusCheckTex.SetRect(paramKey.GetFParam(1),
										 paramKey.GetFParam(2),
										 paramKey.GetFParam(3),
										 paramKey.GetFParam(4),
										 paramKey.GetFParam(5),
										 paramKey.GetFParam(6));										 
				LoadTexture(m_cFocusCheckTex);				
            }                      
			if(paramKey.Equals("TextDisableColor"))
			{
				float r,g,b;
				r = paramKey.GetFParam(0);
				g = paramKey.GetFParam(1);
				b = paramKey.GetFParam(2);
				m_vDisabledTxtColor = new Vector(r,g,b);
			}
			if(paramKey.Equals("TextCheckedColor"))	
			{
				float r,g,b;
				r = paramKey.GetFParam(0);
				g = paramKey.GetFParam(1);
				b = paramKey.GetFParam(2);
				m_vCheckedTxtColor = new Vector(r,g,b);		  
				
			}
			if(paramKey.Equals("TextHighLightColor"))	
			{
				float r,g,b;
				r = paramKey.GetFParam(0);
				g = paramKey.GetFParam(1);
				b = paramKey.GetFParam(2);
				m_vHighLigthTxtColor = new Vector(r,g,b);		  
			}		  		  
			if(paramKey.Equals("TextHighLightCheckColor"))	
			{
				float r,g,b;
				r = paramKey.GetFParam(0);
				g = paramKey.GetFParam(1);
				b = paramKey.GetFParam(2);
				m_vHighLigthCheckTxtColor = new Vector(r,g,b);		  
			}		 

            if(paramKey.Equals("TextureCheckedAlpha"))
            {
                SetCheckedTextureAlpha(paramKey.GetFParam(0));   
            }
            if(paramKey.Equals("TextCheckedAlpha"))
            {
                SetCheckedTextAlpha(paramKey.GetFParam(0));   
            }            
            if(paramKey.Equals("TextureDisabledAlpha"))
            {
                SetDisabledTextureAlpha(paramKey.GetFParam(0));   
            }
            if(paramKey.Equals("TextDisabledAlpha"))
            {
                SetDisabledTextAlpha(paramKey.GetFParam(0));   
            }            
            if(paramKey.Equals("TextureFocusCheckAlpha"))
            {
                SetFocusCheckTextureAlpha(paramKey.GetFParam(0));   
            }
            if(paramKey.Equals("TextFocusCheckAlpha"))
            {
                SetFocusCheckTextAlpha(paramKey.GetFParam(0));   
            }                        
            
			if(paramKey.Equals("Checked"))	
			{
				int nVal = paramKey.GetIParam(0);
				if (nVal==1)
					m_bChecked=true;
				if (nVal==0)			  
					m_bChecked=false;
			}
			if(paramKey.Equals("Disabled"))	
			{
				int nVal = paramKey.GetIParam(0);
				if (nVal==1)
					m_bDisabled = true;
				if (nVal==0)			  
					m_bDisabled = false;
			}
			if(paramKey.Equals("DoubleClickTime"))	
			{
				m_fDoubleClickTime = paramKey.GetFParam(0);
			}
			if(paramKey.Equals("CallPressPeriod"))	
			{
				m_fCallPressPeriod = paramKey.GetFParam(0);
			}
			if(paramKey.Equals("DoubleClick"))	
			{
				m_fDoubleClickTime = paramKey.GetFParam(0);
			}		
			if(paramKey.Equals("MouseLeaveDestroyFocus"))	
			{
				if(paramKey.GetIParam(0) == 1)
					m_bMouseLeaveDestroyFocus=true;
				else
					m_bMouseLeaveDestroyFocus=false;;
			}
			if(paramKey.Equals("CanCheck"))	
			{
				int nVal = paramKey.GetIParam(0);
				if (nVal==1)
					m_bCanCheck = true;
				if (nVal==0)			  
					m_bCanCheck = false;
			}
			if(paramKey.Equals("CanCallPress"))	
			{
				int nVal = paramKey.GetIParam(0);			
				if (nVal==1)
					m_bCanCallPress = true;
				if (nVal==0)			  
					m_bCanCallPress = false;
			}
			if(paramKey.Equals("CheckSound"))						 
			{			 
				m_sCheckSound = paramKey.GetSParam(0);
				//LogLine("Sound"+   m_sCheckSound);
			}		 		 			
		}
		super.Load(key);
		return true;
	}

	public void OnInit()
	{
	   super.OnInit();
  	   SetState("Idle");		
	   
	}
	void SetCheck(boolean bChecked)
	{			   
		if(!m_bActive)
			return;			
		if(bChecked)
		{
			OnCheckSound();
			m_bChecked = true;
		}
		else
        {
            //odznaczenie checkboxa tez musi miec dzwiek            
            if (m_bCanCheck)
                OnCheckSound();
			m_bChecked = false;
        }
        OnTextureChange();
	}			   
	
    boolean GetCheck()
    {
        return m_bChecked;
    }
    
	void SetDisabled(boolean bDisabled)
	{
		if(!m_bActive)
			return;
		if(m_bDisabled == bDisabled)
			return;
        if (bDisabled)
            SetFocus(false);
        //CrashLog(this + "SetDisabled " + bDisabled);
		m_bDisabled = bDisabled;
		OnTextureChange();	
		if(bDisabled)
    		SetState("Disabled");
		else
    		SetState("Idle");		
	}
	void SetFocus(boolean bActive)
	{
		if(!m_bActive)
			return;			
		if(!m_bCanFocus || m_bDisabled )
			return;
		super.SetFocus(bActive);
	}
	void OnCheckSound()	
	{
        if (m_bPlayCheckSound)
		    if(m_sCheckSound!=null)
			    PlaySound(m_sCheckSound);
        m_bPlayCheckSound = false;
	}
	/** odgrywanie muzyki  - pokryta metoda z UIControlO..*/
	public void OnFocusSound()
	{
		if(m_bDisabled)
			return;		
		//LogLine(" OnFocusSound: m_bPlayFocusSound "+m_bPlayFocusSound);		
		if(m_bFocus)	
			if(m_bPlayFocusSound)
				if(m_sFocusSound!=null)
				{
					PlaySound(m_sFocusSound);
				}
        m_bPlayFocusSound = false;  // natepne ustawienie focusa normalnie odtworzy dzwiek	
	}	

	void OnMouseEnter(float fMouseX, float fMouseY)
	{
		if(!m_bActive || m_bDisabled)
			return;			
		if(m_bEditState)
		{
			//LogLine("Omijam mouse enter");
			super.OnMouseEnter(fMouseX, fMouseY);
			return;
		}
		if(m_bDisabled)
			return;	   
   		if(!m_bFocus)
        {
            m_bPlayFocusSound = true;
			SetFocus(true);
        }        
	}
	
    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
    {
      	if(!m_bFocus)
        {
            m_bPlayFocusSound = true;
			SetFocus(true);
        }    
    }
    
	void OnMouseLeave(float fMouseX, float fMouseY)
	{
		if(!m_bActive || m_bDisabled)
			return;			
		if(m_bEditState)
		{
			//LogLine("Omijam mouse leave");
			super.OnMouseLeave(fMouseX, fMouseY);
			return;
		}
		if(m_bDisabled)
			return;
        //super.OnMouseLeave(fMouseX,fMouseY);
        if(m_bMouseLeaveDestroyFocus)
			SetFocus(false);        
		SetState("Idle");
	}

	/**Metoda wywolywana po nacisnieciu przycisku lub checkboxa. 
	 * Wywoluje handlera ktory odpala {@link Window#OnButton(Button btnSender)} lub 
	 * {@link Window#OnButtonDoubleClick(Button btnSender)}
	 *@param btnSender wcisniety przycisk potomny
	 */
	void ButtonPushed(UIButton btnSender)
	{
		float fPrevTime = m_fClickTime;
		m_fClickTime = GetTime();
		

		if (btnSender == null) 
		{
			btnSender = this;
		}
		
		if (m_fClickTime - fPrevTime < m_fDoubleClickTime)
		{
			if (GetTime() > fPrevTime)
			{
				m_bDoubleClick = true;
				CallOnUIButtonDoubleClick(btnSender);
				m_fClickTime = 0.0f;
			}
			else
			{
				//czas zostal cofniety (np przez save/load)
				m_fClickTime = -m_fDoubleClickTime;
				CallOnUIButton(btnSender);
			}
		}
		else
		{
			CallOnUIButton(btnSender);
		}
	}
	
	/** wywoywana podczas trzymania wcisnietego przycisku*/
	void PressButton()
	{
		if (m_bDoubleClick)
		{
			m_bDoubleClick = false;
		}
		else
		{
			CallOnUIButton(this);
		}
	}

	void OnUIButton(UIButton btnSender)
	{
		if(!m_bActive || m_bDisabled)
			return;			
		if(m_bEditState)
			return;
		Command(this, EUIConst.CM_CLICK);
	}
	void OnUIButtonDoubleClick(UIButton btnSender)
	{
		if(!m_bActive || m_bDisabled)
			return;			
		if(m_bEditState)
			return;		
		//Command(this, EUIConst.BTN_DBCLICK);
		Command(this, EUIConst.CM_DBCLICK);

	} 
/*    void OnLBUp(float fMouseX, float fMouseY)
	{
        //super.OnLBUp(fMouseX, fMouseY);
//            JOptionPane.showMessageDialog(null, "Idle:OnLBUP");	                    
        LogLine(this + " OnLbUp - raw");
    }
    void OnLBDown(float fMouseX, float fMouseY)
    {
        LogLine(this + " OnLbDown-raw");
    }*/

	
	/**Stan neutralny (np. gdy zaden z klawiszy nie jest wcisniety)*/
	public class Idle extends State 
	{
		public void OnEnter()
		{
			if(!m_bActive)
				return;				
			if (m_bCanCallPress)
			{
				if (m_bCallingPressButton) DisableCallMethod("PressButton");
				m_bCallingPressButton = false;
			}
			//LogLine("Idle onenter");
		}
        
        /** obsluga reaksji na klawiature, jesli jest aktywny focus
         */
        void OnKeyPressed(int nKey, char nAsci)
        {
            if(!m_bActive || m_bDisabled)
                return;			
            if(m_bEditState)
            {
                //super.OnKeyReleased(nKey,nAsci);
                return;
            }
            if(!m_bFocus)
                return;
            if(nKey==EKey._RETURN)
            {
                //Command(this, EUIConst.CM_RETURN);
                OnLBDown(0,0);
                //Command(this, EUIConst.CM_CLICK);
            }
        }
		
        void OnLBDown(float fMouseX, float fMouseY)
        {
            LogLine(this + " OnLbDown:Idle");
            if(!m_bActive || m_bDisabled)
                return;				
            
            if (!CanProcessMouse())return;
            
            SetState("LMBDown");
        }
		void OnLBUp(float fMouseX, float fMouseY)
		{
//            JOptionPane.showMessageDialog(null, "Idle:OnLBUP");	            
            LogLine(this + " OnLbUp:Idle");
			if(!m_bActive || m_bDisabled)
				return;				
			if (!CanProcessMouse())return;
			ButtonPushed(UIButton.this);		  
			if(m_bCanFocus)
			{
				m_bFocus = false; //wymuszenie zmiany tekstury
				SetFocus(true);
			}
			else
			{
				OnTextureChange();
			}
		}
	}
    
	/**Stan po wcisnieciu lewego klawisza myszy.*/
	public class LMBDown extends State 
	{
		//zmienna potrzebna gdy przycisk jest pressbuttonem
		float fLastOnButtonTime;
		public void OnEnter()
		{
            LogLine(this + " Set LBDown State ");
			if (!CanProcessMouse())return;
			if(m_bCanCheck)
			{
				if(m_bChecked)
                {
                    m_bPlayCheckSound = true;
					SetCheck(false);
                }
				else
                {
                    m_bPlayCheckSound = true;
					SetCheck(true);
                }
			}
			else
            {
                m_bPlayCheckSound = true;
				SetCheck(true);
            }
			if (m_bCanCallPress)
			{
				CallMethodEvery("PressButton", m_fCallPressPeriod);
				m_bCallingPressButton = true;
			}
			//LogLine("LMBDown onenter");
		}
        
		void OnLBUp(float fMouseX, float fMouseY)
		{
			if(!m_bActive)
				return;         
            
			if (!CanProcessMouse())
                return;
			
            ButtonPushed(UIButton.this);
			
            if(m_bChecked)
				if(!m_bCanCheck)
					SetCheck(false);	
            
			if(m_bCanFocus)
			{
				m_bFocus = false; //wymuszenie zmiany tekstury				
				SetFocus(true);
			}
			else
			{
				OnTextureChange();
			}
			SetState("Idle");
		}   
		
		
		void OnMouseEnter(float fMouseX, float fMouseY)
		{
			if(!m_bActive)
				return;				

			if(!m_bFocus)
            {
                m_bPlayFocusSound = true;
				SetFocus(true);
            }
			SetState("Idle");
		}
		
		void OnMouseLeave(float fMouseX, float fMouseY)
		{
			if(!m_bActive)
				return;				
			
			if(m_bChecked)
				SetCheck(false);
            else
                if (m_bCanCheck)
                    SetCheck(true);
            
			if(m_bMouseLeaveDestroyFocus)
				SetFocus(false);			
			else
			{
				m_bFocus = false; //wymuszenie zmiany tekstury
				SetFocus(true);			
			}
			SetState("Idle");
		}
	    /** obsluga reaksji na klawiature, jesli jest aktywny focus
	    */
	    void OnKeyReleased(int nKey, char nAsci)
	    {
    		if(!m_bActive || m_bDisabled)
	    		return;			
    		if(m_bEditState)
	    	{
		    	//super.OnKeyReleased(nKey,nAsci);
			    return;
		    }
		    if(!m_bFocus)
			    return;
		    if(nKey==EKey._RETURN)
		    {
			    //Command(this, EUIConst.CM_RETURN);
                OnLBUp(0,0);
       		    //Command(this, EUIConst.CM_CLICK);
		    }
	    }                    
	}
	
	/**Stan po zdeaktywowaniu przycisku*/
	public class Disabled extends State
	{
		public void OnEnter()
		{
		}
		void OnLBDown(float fMouseX, float fMouseY) {};
		void OnRBDown(float fMouseX, float fMouseY) {};
		void OnMouseEnter(float fMouseX, float fMouseY) {};
		void OnMouseLeave(float fMouseX, float fMouseY) {};
		void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags){};//LogLine("Disabled.OnMouseMove");}
	}

    void ReleaseTexture(UITexture cTex)
	{
        //rozpoznanie ktora to tekstura
        if(cTex == m_cCheckedTex)
            m_cCheckedTex = null;  // zerowanie zwyklej tekstury
        if(cTex == m_cDisabledTex)
            m_cDisabledTex = null;  // zerowanie zwyklej tekstury
        if(cTex == m_cFocusCheckTex)
            m_cFocusCheckTex = null;  // zerowanie zwyklej tekstury        
        super.ReleaseTexture(cTex);
    }
	public void ReleaseTextures()
	{
		super.ReleaseTextures();
        if(m_cCheckedTex!=null)
		   ReleaseTexture(m_cCheckedTex);
        if(m_cDisabledTex!=null)
		    ReleaseTexture(m_cDisabledTex);
        if(m_cFocusCheckTex!=null)
		    ReleaseTexture(m_cFocusCheckTex);        
	}
	
	/** Kopiuje dane z jednogo przycisku do drugiego	 */
	void Copy(UIWindow cWndDest, UIWindow cWndSrc)
	{
		UIButton cDest = (UIButton)cWndDest;
		UIButton cSrc = (UIButton)cWndSrc;
		super.Copy(cDest,cSrc);
		
        
                
	   if(cSrc.m_cCheckedTex !=null)
	   {
			cDest.m_cCheckedTex = new UITexture(cDest);
			cDest.m_cCheckedTex.CopyTexture(cSrc.m_cCheckedTex);
       }
	   else
          cDest.m_cCheckedTex=null;

		if(cSrc.m_vCheckedTxtColor!=null)
			cDest.m_vCheckedTxtColor = new Vector(cSrc.m_vCheckedTxtColor);
		else
			cDest.m_vCheckedTxtColor=null;
		
	   if(cSrc.m_cDisabledTex !=null)
	   {
			cDest.m_cDisabledTex = new UITexture(this);
			cDest.m_cDisabledTex.CopyTexture(cSrc.m_cDisabledTex);
	   }
	   else
          cDest.m_cDisabledTex=null;
		
		if(cSrc.m_vDisabledTxtColor!=null)
			cDest.m_vDisabledTxtColor = new Vector(cSrc.m_vDisabledTxtColor); 	 	
		else
			cDest.m_vDisabledTxtColor = null;
		
		
	   if(cSrc.m_cFocusCheckTex !=null)
	   {
			cDest.m_cFocusCheckTex = new UITexture(cDest);
			cDest.m_cFocusCheckTex.CopyTexture(cSrc.m_cFocusCheckTex);
	   }
	   else
          cDest.m_cFocusCheckTex=null;
		
		if(cSrc.m_vHighLigthCheckTxtColor!=null)
			cDest.m_vHighLigthCheckTxtColor = new Vector(cSrc.m_vHighLigthCheckTxtColor);
		else
			cDest.m_vHighLigthCheckTxtColor = null;
        
        cDest.SetCheckedTextureAlpha(cSrc.m_fCheckedTextureAlpha);
        cDest.SetCheckedTextAlpha(cSrc.m_fCheckedTextureAlpha);
        cDest.SetDisabledTextureAlpha(cSrc.m_fDisabledTextureAlpha);
        cDest.SetDisabledTextAlpha(cSrc.m_fDisabledTextAlpha);        
        cDest.SetFocusCheckTextureAlpha(cSrc.m_fFocusCheckTextureAlpha);        
        cDest.SetFocusCheckTextAlpha(cSrc.m_fFocusCheckTextAlpha);        

		cDest.m_bCanFocus = cSrc.m_bCanFocus;
		cDest.m_bCanCheck = cSrc.m_bCanCheck;
		cDest.m_bCanCallPress = cSrc.m_bCanCallPress;
		cDest.m_bChecked = cSrc.m_bChecked;
		cDest.m_bDisabled = cSrc.m_bDisabled; 
		cDest.m_bDoubleClick = cSrc.m_bDoubleClick;
		cDest.m_fClickTime = cSrc.m_fClickTime;
		cDest.m_fDoubleClickTime = cSrc.m_fDoubleClickTime;
		cDest.m_fCallPressPeriod = cSrc.m_fCallPressPeriod;  
		cDest.m_bMouseLeaveDestroyFocus= cSrc.m_bMouseLeaveDestroyFocus;
		cDest.m_sCheckSound = cSrc.m_sCheckSound;
	}
    
    public void SetTextColor(float r, float g, float b, float a)
    {
        super.SetTextColor(r, g, b, a);
        //Log("SetTextColor " + r + ","  + g +"," +b +","+ a);            
    }
}
 
 
 