/**
 * 
 *   okno symulujace przelatujacy tekst po innym oknie
 * 
 * 
 */
public class UIFlyText extends UIStatic
{
    final static int _TOP_TO_BOTTOM = 0;
    final static int _BOTTOM_TO_TOP = 1; 
    final static int _LEFT_TO_RIGHT = 2; 
    final static int _RIGHT_TO_LEFT = 3;
    final static int _VERTICAL_SWING = 4;
    final static int _HORIZONTAL_SWING = 5;             
    
    // stan wahadlowego ruchu
    final static int _SWING_LEFT = 0;
    final static int _SWING_RIGHT = 1;

    final static int _SWING_TOP = 0;
    final static int _SWING_BOTTOM = 1;            
    
    /** czy ma cyklicznie przelatywac okno     */    
    int m_nFlyTextMode = _RIGHT_TO_LEFT;    
    boolean m_bFlyWrap = true;
    float m_fFlyWrapTime = 1f;    
    float m_fFlyTextTime = 3;    
    boolean m_bFlying = false;
    int m_nSwingMode = -1; 
    
    void OnCreate()
    {
        super.OnCreate();
        m_bParentPositionig = true;            
        m_bParentSizingX = true;
        m_bParentSizingY = true;                            
        m_sFontId = "MSSansSerif10";
        ActivateOnModule();
    }
    
    void Fly()
    {
        LogLine(" FlyText in Fly() "+m_sText);         
        m_bFlying = true;
        Vector vStartPos = null;
        Vector vEndPos = null;       
        Vector vParentPos = m_wndParent.GetLogicPos();
        Vector vParentSize = m_wndParent.GetLogicSize();        
        Vector vMySize = GetLogicSize();
        
        if(m_nFlyTextMode == _VERTICAL_SWING && m_nSwingMode == -1)
            m_nSwingMode = _SWING_TOP;
        if(m_nFlyTextMode == _HORIZONTAL_SWING && m_nSwingMode == -1)
            m_nSwingMode = _SWING_LEFT;
        
        switch(m_nFlyTextMode)
        {
        case _TOP_TO_BOTTOM:
            vStartPos = new Vector(0.5f - vMySize.fX/2,0,0);
            vEndPos = new Vector(0.5f - vMySize.fX/2,1 - vMySize.fY,1);
            break;
        case _BOTTOM_TO_TOP: 
            vStartPos = new Vector(0.5f - vMySize.fX/2,1 - vMySize.fY,0);         
            vEndPos = new Vector(0.5f - vMySize.fX/2,0,0);
            break;            
        case _LEFT_TO_RIGHT: 
            vStartPos = new Vector(0, 0.5f - vMySize.fY/2,0);
            vEndPos = new Vector(1-vMySize.fX,0.5f - vMySize.fY/2,0);        
            break;            
        case _RIGHT_TO_LEFT:  
            vStartPos = new Vector(1-vMySize.fX,0.5f - vMySize.fY/2,0);
            vEndPos = new Vector(0,0.5f - vMySize.fY/2,1);           
            break;            
        case _VERTICAL_SWING:
            if(m_nSwingMode == _SWING_TOP)
            {
                vStartPos = new Vector(0.5f - vMySize.fX/2,1 - vMySize.fY,0);         
                vEndPos = new Vector(0.5f - vMySize.fX/2,0,0);                
            }
            else
            {
                vStartPos = new Vector(0.5f - vMySize.fX/2,0,0);
                vEndPos = new Vector(0.5f - vMySize.fX/2,1 - vMySize.fY,1);                
            }
            break;
        case _HORIZONTAL_SWING:
            if(m_nSwingMode == _SWING_LEFT)
            {
                vStartPos = new Vector(0, 0.5f - vMySize.fY/2,0);
                vEndPos = new Vector(1-vMySize.fX,0.5f - vMySize.fY/2,0);                        
            }
            else
            {
                vStartPos = new Vector(1-vMySize.fX,0.5f - vMySize.fY/2,0);
                vEndPos = new Vector(0,0.5f - vMySize.fY/2,1);                           
            }            
            break;            
            
        }
        SetLogicPos(vStartPos);
        OnSizeAndPos();
        Show();
//        DisplayText();
        SetEffectDestPos(vEndPos, m_fFlyTextTime);                            
        
    }
    void StopFly()
    {
        m_bFlying = false;
        Hide();
        DisableCallMethod("NextFly");
    }
    
    public void OnEffectPosEnd()    
    {
        // ukrywa text tylko jesli nie jest to ruch wahadlowy
        if(m_nFlyTextMode != _VERTICAL_SWING && m_nFlyTextMode != _HORIZONTAL_SWING)
            Hide();
        if(m_bFlyWrap && m_bFlying)
            CallMethodIn("NextFly",m_fFlyWrapTime);
    }
    public void NextFly()
    {
        if(m_nFlyTextMode == _VERTICAL_SWING)
            m_nSwingMode  = (m_nSwingMode == _SWING_TOP)?_SWING_BOTTOM:_SWING_TOP;           
        if(m_nFlyTextMode == _HORIZONTAL_SWING)
            m_nSwingMode  = (m_nSwingMode == _SWING_LEFT)?_SWING_RIGHT:_SWING_LEFT;           
        Fly();
    }
}
