public class UIListBox extends UIControlObject
{
    UIButton m_btnUp = null, m_btnDown = null, m_btnThumb = null, m_btnMember = null;
    UIControlObject m_ctrlList = null, m_ctrlScroll = null;  
    
    /**Wektor elementow listboxa*/
    java.util.Vector vItems = new java.util.Vector();
    /**Indeks elementu, ktory jest na poczatku listy*/
    int nFirstVisible = 0;
    /**Pojemnosc listy (Liczba widocznych elementow)*/
    int m_nCapacity = 3;
    /**Wielkosc elementow listy*/
    Vector vElemSize = new Vector();
    /**Rozmiar pola listy (bez scrollbara)*/
    Vector vClientSize = new Vector();
    /**Ilosc elementow na liscie*/
    int nItemCount = 0;
    /**Ustala, czy lista ma automatycznie pokazywac i chowac scrollbar zaleznie od ilosci elementow*/
    boolean bAutoShowScroll = false;
    /**Jesli zmieni sie ten vektor to Itemy beda przesuniety o podany vektor*/
    Vector vItemsFirstPos = new Vector();
    
    /**Czy istnieje suwak*/
    boolean m_bNoScroll = false;
    
    /**Jesli true, to po ukryciu scrollbara lista sie rozszzerzy na miejsce po nim */
    boolean m_bResizeOnHideScroll = true;
    
    boolean m_bCapacityUpdated = false;
    
    boolean bScrollVisible = true;
    
    /**Ustala, czy scrollbar ma sie pokazywac i chowac automatycznie zaleznie od ilosci elementow na liscie
     */
    void SetAutoShowScroll(boolean bAuto)
    {
        bAutoShowScroll = bAuto;
    }
    
    /**Zwraca ilosc elementow w liscie.*/
    int GetItemCount()
    {
        return nItemCount;
    }
    
    /**Ustala ilosc widocznych elementow. Na jej podstawie i 
     * na podstawie rozmiaru okna wyliczany jest rozmiar elementu*/
    void SetCapacity(int nNewCapacity)
    {
        m_nCapacity = nNewCapacity;
        m_bCapacityUpdated = true;
        
    }

    void OnSetCapacity()
    {
        if (!WasLoadedOk())
            return;
        
        Vector vNewSize = GetSize();
        vNewSize.fY = m_nCapacity * m_btnMember.GetSize().fY;
      
        UpdateLogicSizeAndPos(vNewSize, GetPos());
    }
    
    public void OnCreate()
    {
        ActivateOnModule();
        super.OnCreate();
    }
    
    /** odswiezanie ctl-a     */	
	public void OnFrame()
	{
		if( !m_bInited )
			return;		
		super.OnFrame();
		
		if(m_bCapacityUpdated)
		{
		   OnSetCapacity();		   
		}
		m_bCapacityUpdated = false;
	}
    
    void OnRBUp(float fMouseX, float fMouseY){}
    void OnRBDown(float fMouseX, float fMouseY){}
   
        
    /**Dodaje do listboxa element.
     * @return indeks dodanego elementu*/
    int AddItem(UIButton btnItem)
    {
        if (btnItem == null) return -1;
        vItems.addElement((Object)btnItem);
        m_ctrlList.AddElement(btnItem);
        Reload();
        nItemCount = vItems.size();
        CallOnFrameEnd("UpdateList");
        return vItems.indexOf((Object)btnItem);            
    }
    
    int AddItem(String sText, Object data)
    {
        UIMenuButton btnNew = CreateButton();
        btnNew.m_sId = "ID_BUTTON";
        m_btnMember.Copy(btnNew, m_btnMember);
        btnNew.m_cSupervisor = m_btnMember.m_cSupervisor;	
        btnNew.m_bProcessNotify = true;
        btnNew.SetActive(true);
        btnNew.SetText(sText);
        btnNew.m_cData = data;
        //btnNew.OnSizeAndPos();
        btnNew.m_bVisible = true;
        return (AddItem(btnNew));
    }
    
    /**Tworzy przycisk na podstawie wzorca m_btnMember, mozna przeciazyc w celu tworzenia
     * innych klas przyciskow*/
    UIMenuButton CreateButton()
    {
        return (UIMenuButton)CreateObject("UIMenuButton");
    }    
    /**Wstawia dany element na podana pozycje
     * @param btnItem wstawiany element
     * @param nIndex pozycja do wstawienia
     * @return pozycja na ktora byl wstawiony*/
    int InsertItem(UIButton btnItem, int nIndex)
    {
        if ((btnItem == null)||(nIndex < 0)) 
            return -1;
        vItems.insertElementAt((Object)btnItem, nIndex);
        m_ctrlList.AddElement(btnItem);
        Reload();
        nItemCount = vItems.size();
        CallOnFrameEnd("UpdateList");
        return vItems.indexOf(btnItem);  
    }
    
    int InsertItem(String sText, Object data, int nIndex)
    {
        UIMenuButton btnNew = CreateButton();
        btnNew.m_sId = "ID_BUTTON";
        m_btnMember.Copy(btnNew, m_btnMember);
        btnNew.m_cSupervisor = m_btnMember.m_cSupervisor;	
        btnNew.m_bProcessNotify = true;
        btnNew.SetActive(true);
        btnNew.SetText(sText);
        btnNew.m_cData = data;
        //btnNew.OnSizeAndPos();
        btnNew.m_bVisible = true;
        return (InsertItem(btnNew,nIndex));
    }
    
    /**Usuwa element o indeksie <code>nIndex</code>*/
    void RemoveItem(int nIndex)
    {
        //TODO poprawic
        if ((nIndex < 0) || (nIndex >= nItemCount)) return;
        UIWindow wnd = (UIWindow)vItems.elementAt(nIndex);
        wnd.Hide();
        m_ctrlList.RemoveChild(wnd);
        wnd.Remove();
        vItems.removeElementAt(nIndex);
        nItemCount = vItems.size();
        wnd.CallMethodIn("delete",0);
        int nLastFirstVisible = nItemCount - m_nCapacity;
        if ((nIndex == nFirstVisible) || (nFirstVisible > nLastFirstVisible))
        {
            if (nFirstVisible > 0) nFirstVisible--;
        }
		
        CallOnFrameEnd("UpdateList");
    }
    
    /**Zaznacza wybrany element, kasuje zaznaczenie pozostalych.
     * @param nIndex indeks parametru do zaznaczenia, jesli -1, nic
     * nie zaznaczone*/
    void SetSelection(int nIndex)
    {
        int i;
        for(i = 0; i < nItemCount; i++)
        {
            SetButtonCheck(((UIButton)vItems.elementAt(i)),false);
        }
        if ((nIndex > -1) && (nIndex < nItemCount))
        {
            SetButtonCheck((UIButton)vItems.elementAt(nIndex),true);
        }
    }

    /**ukryte przyciski listy sa nieaktywne, trzeba je na chwile aktywowac
     * przy zmianie zaznaczenia, zeby zmienily teksture (zazn/niezanzn)*/
    void SetButtonCheck(UIButton cBtn, boolean bCheck)
    {
        boolean bActive = cBtn.m_bActive;
        //aktywujemy przycisk
        cBtn.SetActive(true);
        //ustawiamy zaznaczenie
        cBtn.SetCheck(bCheck);
        //forsujemy zmiane wygladu
        cBtn.Reload();
        //przywracamy poprzednia aktywnosc
        cBtn.SetActive(bActive);
    }
    
    void SetSelection(UIButton btnSel)
    {
        int i;
        for(i = 0; i < nItemCount; i++)
        {
            UIButton btn = (UIButton)vItems.elementAt(i);
            
            if (btn == btnSel)
            {
                
                if (!btn.GetCheck())
                {
                    SetButtonCheck(btn, true);
                }
            }
            else
            {
                if (btn.GetCheck())
                {
                    SetButtonCheck(btn, false);
                }
            }
        }
        
    }
    
    /**Zwraca indeks zaznaczonego elementu, -1 jesli nic nie zaznaczone.*/
    int GetSelection()
    {
        int i;
        boolean bCheck = false;
        for(i = 0; i < nItemCount; i++)
        {
            bCheck = ((UIButton)vItems.elementAt(i)).m_bChecked;
            if (bCheck) return i;
        }
        return -1;
    }
    
    UIButton GetSelected()
    {
        int i;
        boolean bCheck = false;
        for(i = 0; i < nItemCount; i++)
        {
            bCheck = ((UIButton)vItems.elementAt(i)).m_bChecked;
            if (bCheck) 
                return (UIButton)vItems.elementAt(i);
        }
        return null;
    }
    
    /**Zwraca indeks szukanego elementu.
     * @param btnToFind szukany element
     * @return indeks pierwszego wystapienia <code>btnToFind</code> lub
     * -1 jesli nie znajdzie*/
    int FindItem(UIButton btnToFind)
    {
        return (vItems.indexOf((Object)btnToFind));
    }
    
    final static int ID_UP = 0;
    final static int ID_DOWN = 1;
    final static int ID_THUMB = 2;
    final static int ID_BUTTON = 3;
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		
		if(nCommand == EUIConst.CM_DBCLICK)
        {
			if (cSender.m_sId.equals("ID_BUTTON"))
            {
                SetSelection(GetIndexOf((UIButton)cSender));
                //SetSelection((UIButton)cSender);
            }
                
        }
		if(nCommand == EUIConst.CM_CLICK)
        {
            int nID = -1;
            //CrashLog("ListBox.OnUICommand from " + cSender.m_sId + " text " + ((UIButton)cSender).m_sText+"\n");
            if (cSender.m_sId.equals("ID_UP"))
            {
                nID = ID_UP;
            } 
            
            if (cSender.m_sId.equals("ID_DOWN"))
            {
                nID = ID_DOWN;
            }
            
            if (cSender.m_sId.equals("ID_THUMB"))
            {
                nID = ID_THUMB;
            }
            
            if (cSender.m_sId.equals("ID_BUTTON"))
            {
                nID = ID_BUTTON;
                OnListButton((UIButton)cSender);
            }
            
            switch(nID)
            {
                case ID_UP:
                    OnScrollUp();
                    break;
                case ID_DOWN:
                    OnScrollDown();
                    break;
                case ID_THUMB:
                    OnThumb();
                    break;
                case ID_BUTTON:
                    
                    break;
            }
                
        }
		/*if(nCommand == EUIConst.CM_SEL)
			LogLine("-i--  Sel -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		
		if(nCommand == EUIConst.CM_SEL_DBCLICK)
						LogLine("-i--  Sel_dbClick -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		*/
        super.OnUICommand(cSender,nCommand);		
	}
    
    void OnThumb()
    {
    }
    
    void OnListButton(UIButton button)
    {
        SetSelection(GetIndexOf(button));
    }
    
    void OnScrollDown()
    {
        m_fMouseAxisDelta = 0.f;
        //ostatni element ktory moze byc na szczycie listy
        int nLastFirstVisible = nItemCount - m_nCapacity;
        if (nFirstVisible < nLastFirstVisible) 
        {
            nFirstVisible++;
            CallOnFrameEnd("UpdateList");
        }
    }
    
    void OnScrollUp()
    {
        m_fMouseAxisDelta = 0.f;
        if (nFirstVisible > 0) 
        {
            nFirstVisible--;
            CallOnFrameEnd("UpdateList");
        }
    }
    
    float m_fMouseAxisDelta = 0;
    boolean m_bScrolingInProgress = false;
    
    void OnScrollUp(float fDelta)
    {
        m_fMouseAxisDelta+=fDelta;
        Vector vThumbSize = m_btnThumb.GetSize();
         
        if(vThumbSize.fY / m_nCapacity < m_fMouseAxisDelta)
            OnScrollUp();   
    }
    
    void OnScrollDown(float fDelta)
    {
        m_fMouseAxisDelta+=fDelta;
        Vector vThumbSize = m_btnThumb.GetSize();
         
        if(vThumbSize.fY / m_nCapacity < -m_fMouseAxisDelta)            
            OnScrollDown();
    }

    /**Uklada elementy listy w oknie i wyswietla te ktore powinny byc widoczne*/
    void UpdateList()
    {
        int i, j;
        //CrashLog("UpdateList " + nFirstVisible);
        //najpierw chowamy niewidoczne
        UIWindow wndTmp;
        for (i = 0; i < nFirstVisible; i++)
        {
            wndTmp = ((UIWindow)vItems.elementAt(i));
            wndTmp.Hide();
            wndTmp.SetActive(false);
        }
        for (i = nFirstVisible + m_nCapacity; i < nItemCount;i++)
        {
            wndTmp = ((UIWindow)vItems.elementAt(i));
            wndTmp.Hide();
            wndTmp.SetActive(false);
        }
        if (bAutoShowScroll)
        {
		    if ( nItemCount <= m_nCapacity) ShowScroll(false);
		    else ShowScroll(true);
        }
        //potem pozycjonujemy widoczne
        //Vector pos = GetPos();
        ChangeScrollBarPos();
        Vector pos = new Vector(vItemsFirstPos);
        
        if (nItemCount == 0) 
            return;
        
        for (i = nFirstVisible, j = 0; i < nFirstVisible + m_nCapacity; i++, j++)
        {
            if (i == nItemCount) break;
            wndTmp = ((UIWindow)vItems.elementAt(i));
            wndTmp.SetRelativePos(pos);
            wndTmp.UpdateLogicSizeAndPos(wndTmp.GetSize(), wndTmp.GetPos());
            wndTmp.ReloadSizeAndPos();
            wndTmp.Reload();
            pos.fY = pos.fY + wndTmp.GetSize().fY;
            if (IsVisible()) 
            {
                wndTmp.Show();
                wndTmp.SetActive(true);
            }
            else 
            {
                wndTmp.Hide();
                wndTmp.SetActive(false);
            }
                
        }
    }
    
    /**Zmienia pozycje ScrollBara*/
    void ChangeScrollBarPos()
    {
        if ( !m_bNoScroll )
		{
            //if (m_nCapacity < nItemCount)
            {
				Vector vThumbSize = m_btnThumb.GetSize();
				float fScrollRange = m_ctrlScroll.GetSize().fY - m_btnDown.GetSize().fY - m_btnUp.GetSize().fY;
				if (GetItemCount() < m_nCapacity)
					vThumbSize.fY = fScrollRange;
				else
					vThumbSize.fY = fScrollRange * ((float)m_nCapacity)/((float)GetItemCount());
				m_btnThumb.SetSize(vThumbSize);
				
                Vector vScrollSize = m_ctrlScroll.GetSize();
                Vector vUpSize = m_btnUp.GetSize();
                //Vector vThumbSize = m_btnThumb.GetSize();
                Vector vDownSize = m_btnDown.GetSize();
                Vector vThumbPos = new Vector();
                float fThumbMinPos = vUpSize.fY;
                float fThumbMaxPos = vScrollSize.fY - vDownSize.fY - vThumbSize.fY;
                vThumbPos.fX = vScrollSize.fX/2f - vThumbSize.fX/2f;
                if (nItemCount - m_nCapacity > 0)
                    vThumbPos.fY = fThumbMinPos + (nFirstVisible)*(fThumbMaxPos - fThumbMinPos)/(nItemCount - m_nCapacity);//arrowSize.fY + ((nFirstVisible) * ((size.fY - (2.0f * arrowSize.fY + vScrollSize.fY))/(nItemCount - m_nCapacity)))
                else
                    vThumbPos.fY = fThumbMinPos;
                m_btnThumb.SetRelativePos(vThumbPos);
                //CrashLog("thumb setting relpos " + vThumbPos);
                m_btnThumb.UpdateLogicSizeAndPos( m_btnThumb.GetSize(), m_btnThumb.GetPos());
                m_btnThumb.OnSizeAndPos();
            }
            //else
            {
                //m_ctrlScroll.Hide();
            }
		}
    }
    
    /**Umieszcza element o podanym indeksie w widocznej czesci listy*/
    void EnsureVisible(int nPos)
    {
        if ((nPos < 0)||(nPos >= nItemCount)) return;
        int nLastFirstVisible = nItemCount - m_nCapacity;
        if (nPos < nFirstVisible) 
        {
            nFirstVisible = nPos;
            CallOnFrameEnd("UpdateList");
        } else
        if (nPos >= nFirstVisible + m_nCapacity)
        {
            if (nPos > nLastFirstVisible) nFirstVisible = nLastFirstVisible;
            else nFirstVisible = nPos;
            CallOnFrameEnd("UpdateList");
        }
    }
    
    /**Pokazuje lub ukrywa scrollbar w listboxie*/
    void ShowScroll(boolean bShow)
    {
        //TODO dostosowac do nowego scrolla jak powstanie
        //TODO zmienic
        //CrashLog(this + " ShowScroll " + bShow); 
        if (m_bNoScroll)        
            return; 
        
        if (bShow)
        {
            bScrollVisible = true;
			if (m_btnUp != null)
			{
				m_btnUp.SetActive(true);
				m_btnUp.Show();
			}
			if (m_btnDown  != null)
			{
				m_btnDown.SetActive(true);
				m_btnDown.Show();
			}
			if ( m_ctrlScroll != null )
			{
				m_ctrlScroll.Hide();
				m_ctrlScroll.SetActive(true);
			}
            if (m_btnThumb != null)
            {
                m_btnThumb.Hide();
				m_btnThumb.SetActive(true);
            }
            
        }
        else
        {
            bScrollVisible = false;
			if (m_btnUp != null)
			{
				m_btnUp.SetActive(false);
				m_btnUp.Hide();
			}
			if (m_btnDown != null)
			{
				m_btnDown.SetActive(false);
				m_btnDown.Hide();
			}
			if ( m_ctrlScroll != null )
			{
				m_ctrlScroll.SetActive(false);
				m_ctrlScroll.Hide();
			}
            if (m_btnThumb != null)
            {
                m_btnThumb.SetActive(false);
				m_btnThumb.Hide();
			}
        }
        if (m_bResizeOnHideScroll)
        {
            ForceUpdateSize();
        }
    }
    
	void ForceUpdateSize()
    {
        vPrevSize = null;
        SetSize(GetSize());
    }
    
    /**Usuwa wszystkie elementy listy*/
    void Clear()
    {
        while (nItemCount > 0) RemoveItem(0);
    }
    
    /**Zwraca referencje na przycisk bedacy elementem listy o indeksie nIndex.
     */
    UIButton GetItem(int nIndex)
    {
        if ((nIndex < 0) || (nIndex >= vItems.size()))
            return null;
        else
            return (UIButton)vItems.elementAt(nIndex);
    }

    int GetIndexOf(UIButton cButton)
    {
        return vItems.indexOf((Object)cButton);
    }
    
    boolean Load(ParseKeyword key)
	{
		ParseKeyword  paramKey;
		for(paramKey=key.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
		  if(paramKey.Equals("ListBoxCapacity"))
              m_nCapacity = paramKey.GetIParam(0);
		}
        super.Load(key);	
        
		return true;
	}

    public void OnInit()
    {
        
        m_btnUp = (UIButton)GetElem("ID_UP");
        m_btnDown = (UIButton)GetElem("ID_DOWN");
        m_btnThumb = (UIButton)GetElem("ID_THUMB");
        m_btnMember = (UIButton)GetElem("ID_BUTTON");
		m_ctrlList = (UIControlObject)GetElem("ID_LIST");
        m_ctrlScroll = (UIControlObject)GetElem("ID_SCROLL");
        if (!WasLoadedOk())
        {
            Tools.CrashLogWarning(this + " nie zaladowano wszystkich komponentow!!!");
            return;
        }
        m_btnMember.SetVisible(false);
        m_btnMember.SetActive(false);
        m_btnMember.m_bProcessNotify = false;
        m_bNoScroll = (m_ctrlScroll == null);
        
        super.OnInit();
        
        SetCapacity(m_nCapacity);
    }
    
    boolean WasLoadedOk()
    {
        //czy wszystko jest, lub nie ma calego scrolla
        return (m_btnMember != null &&
                m_ctrlList != null &&
                ((m_btnUp != null &&
                m_btnDown != null &&
                m_btnThumb != null &&
                m_ctrlScroll != null)||
                 (m_btnUp == null &&
                m_btnDown == null &&
                m_btnThumb == null &&
                m_ctrlScroll == null) ));
    }
    
    public void Reload()
    {
        m_bCapacityUpdated = true;
        super.Reload();
        SetFocus(false);
    }
    
    Vector vPrevSize = null;
    
    /**Funkcja umozliwiajaca wywolanie super.setsize
     * bez wolania setsize tej klasy
     */
    public void SuperSetSize(Vector vSize)
    {
        super.SetSize(vSize);
    }
     
    public void SetSize(Vector vSize)
    {
        if (!m_bInited)
            return;
        
        if (vPrevSize != null)
        {
            if (vPrevSize.IsEqual(vSize))
                return;
        }
        vPrevSize = new Vector(vSize);
        super.SetSize(vSize);
        if (!WasLoadedOk())
            return;
        Vector vScrollSize = null;
        if (!m_bNoScroll)
        {
            vScrollSize = m_ctrlScroll.GetSize();
            if (vScrollSize.Len() == 0)
            {
                m_ctrlScroll.OnSizeAndPos();
                vScrollSize = m_ctrlScroll.GetSize();
            }
        }
        else
        {
            vScrollSize = new Vector();
        }
        
        vScrollSize.fY = vSize.fY;
        Vector vListSize = new Vector (vSize);
        
        if (m_bResizeOnHideScroll && !bScrollVisible)
            vListSize.fX -= 0;
        else
            vListSize.fX -= vScrollSize.fX;
        
        Vector vBtnSize = m_btnMember.GetSize();
        if (vBtnSize.Len() == 0)
        {
            m_btnMember.OnSizeAndPos();
            vBtnSize = m_btnMember.GetSize();
        }
        
        vBtnSize.fX = vListSize.fX;
        
        m_ctrlList.SetSize(vListSize);
        m_ctrlList.SetRelativePos(new Vector());
        m_ctrlList.UpdateLogicSizeAndPos(vListSize, m_ctrlList.GetPos());
        
        if (!m_bNoScroll)
        {
            m_ctrlScroll.SetSize(vScrollSize);
            m_ctrlScroll.SetRelativePos(new Vector(vListSize.fX, 0,0));
            m_ctrlScroll.UpdateLogicSizeAndPos(vScrollSize, m_ctrlScroll.GetPos());
        }
        
        //TODO przeskalowac wszystkie przyciski
        m_btnMember.SetSize(vBtnSize);
        m_btnMember.SetRelativePos(new Vector());
        m_btnMember.UpdateLogicSizeAndPos(vBtnSize, m_btnMember.GetPos());
        
        if (!m_bNoScroll)
        {
            if (m_btnUp.GetSize().Len() == 0)
                m_btnUp.OnSizeAndPos();
            m_btnUp.SetRelativePos(new Vector());
            m_btnUp.UpdateLogicSizeAndPos(m_btnUp.GetSize(), m_btnUp.GetPos());
            m_btnUp.OnSizeAndPos();
            if (m_btnThumb.GetSize().Len() == 0)
                m_btnThumb.OnSizeAndPos();
            m_btnThumb.SetRelativePos(new Vector(0, m_btnUp.GetSize().fY, 0));
            m_btnThumb.UpdateLogicSizeAndPos(m_btnThumb.GetSize(), m_btnThumb.GetPos());

            if (m_btnDown.GetSize().Len() == 0)
                m_btnDown.OnSizeAndPos();
            m_btnDown.SetRelativePos(new Vector(0, vScrollSize.fY - m_btnDown.GetSize().fY,0));
            m_btnDown.UpdateLogicSizeAndPos(m_btnDown.GetSize(), m_btnDown.GetPos());
        }
        CallOnFrameEnd("UpdateList");
        //CrashLog("UIlistbox.setsize " + vSize);
        
    }
    
        
    public void SetPos(Vector v)
    {
        vPrevSize = null;
        super.SetPos(v);
    }
    
    void ConfirmEdit()
    {
        super.ConfirmEdit();
        m_ctrlList.ConfirmEdit();
        m_btnMember.ConfirmEdit();
        if (!m_bNoScroll)        
        {
            m_ctrlScroll.ConfirmEdit();
            m_btnUp.ConfirmEdit();
            m_btnThumb.ConfirmEdit();
            m_btnDown.ConfirmEdit();
        }
    }
    
    void SetActive(boolean bActive)
    {
        super.SetActive(bActive);
        
        if (!WasLoadedOk())
            return;
        
        if (bActive)
        {
            //nie chcemy, by przycisk wzorcowy byl aktywny wiec go deaktywujemy (ta metoda
            //go zaktywuje bo jest dzieckiem listy
            m_btnMember.SetActive(false);
        }
    }

    public void OnInputMouseButton(int nButton, int nState)
        {
            if(nState==0)
                m_bScrolingInProgress = false;            
        }
    
    void OnInputMouseAxis(int nAxis, int nDelta)
    {
        if (!((UIWindow)this).IsCursorInUIWindow() ||
            (!IsActuallyVisible()))
            return;
        
        switch (nAxis)
        {
        case EMouse._AXIS_Z:
            {
                if (nDelta < 0)
                    OnScrollUp();
                else
                    OnScrollDown();
            }
            break;
            
        case EMouse._AXIS_Y:
            if (!m_bNoScroll)
            {
                //if (GetKeyState(EMouse._BUTTON_1))
                {
                    if (m_btnThumb.IsCursorInUIWindow() && m_btnThumb.GetCheck() || m_bScrolingInProgress)
                    {
                        m_bScrolingInProgress = true;
                        if (nDelta > 0)
                            OnScrollUp(nDelta);
                        else
                            OnScrollDown(nDelta);
                    }
                }
            }
            break;
        }
    }
    
    void MoveSelectedDown()
    {
         int nSelect = GetSelection();
         if (nSelect < 0)
            return;
         
         UIButton cItem = GetItem(nSelect);
         UIButton cNextItem = GetItem(nSelect+1);
         
         if(cNextItem == null)
             return;
         
          String sTempString = cItem.GetText();
          Object cTempObject = cItem.m_cData;
          
          cItem.SetText(cNextItem.GetText());
          cItem.m_cData = cNextItem.m_cData;
          
          cNextItem.SetText(sTempString);
          cNextItem.m_cData = cTempObject;
          
          SetSelection(nSelect+1);
    }
    
    void MoveSelectedUp()
    {
         int nSelect = GetSelection();
         if (nSelect <= 0)
            return;
         
         UIButton cItem = GetItem(nSelect);
         UIButton cPrevItem = GetItem(nSelect-1);
         
         if(cPrevItem == null)
             return;
         
          String sTempString = cItem.GetText();
          Object cTempObject = cItem.m_cData;
          
          cItem.SetText(cPrevItem.GetText());
          cItem.m_cData = cPrevItem.m_cData;
          
          cPrevItem.SetText(sTempString);
          cPrevItem.m_cData = cTempObject;
          
          SetSelection(nSelect-1);
    }
    
    /*void ForceRefresh()
    {
        super.ForceRefresh();
        for (int i = 0; i < vItems.size(); i++)
        {
            ((UIWindow)vItems.elementAt(i)).ForceRefresh();
        }
    }*/
    
}
