public class UITexture
{
    
   /** identyfikator    */
	int m_nId = 0;
	/** nazwa pliku	 */
	String m_sFileName = null;

	/** wycinek z pliku,(jesli null to caly plik )
	 * wartosci rzczywiste w pikselach
	 * */
	float m_fWidth = 0.0f;
	float m_fHeight = 0.0f;
	
    Rect m_rRect = null;	
	/** okno dla ktorego jest ladowana	 */
	UIWindow m_cWindow = null;
	
	UITexture(UIWindow cWnd)
	{
		m_cWindow = cWnd;
	}
	
    UITexture(String sFileName, float fWidth, float fHeight, float fLeft, float fTop,float fRight, float fBottom)
    {
        m_sFileName = sFileName;
        m_fWidth = fWidth;
		m_fHeight = fHeight;
		m_rRect = new Rect(fLeft,fTop,fRight,fBottom);
    }
    
	void SetRect(float fWidth, float fHeight, float fLeft, float fTop,float fRight, float fBottom)
	{
		m_fWidth = fWidth;
		m_fHeight = fHeight;
		m_rRect = new Rect(fLeft,fTop,fRight,fBottom);
	}
	void SetRect(float fWidth, float fHeight, Rect cRect)
	{
		m_fWidth = fWidth;
		m_fHeight = fHeight;
		m_rRect = new Rect(cRect.fLeft,cRect.fTop,cRect.fRight,cRect.fBottom);
	}	
	/** zwraca parametry wycinka logiczne (0..1)
	 */
	Rect GetLogicRect()
	{
	  if(m_rRect==null)
		  return null;
	  float fLeft= m_rRect.fLeft / m_fWidth;
      float fTop = m_rRect.fTop / m_fHeight;
      float fRight = fLeft + (m_rRect.fRight - m_rRect.fLeft)/m_fWidth;
      float fBottom = fTop + (m_rRect.fBottom - m_rRect.fTop)/m_fHeight;				  
	  
	  return new Rect(fLeft, fTop, fRight, fBottom);
	}
	
	void CopyTexture(UITexture cTex)
	{

      if(cTex.m_sFileName!= null)
 	  {
		m_sFileName = new String(cTex.m_sFileName);
		m_nId = m_cWindow.AddTexture(m_sFileName);
		CopyParams(cTex);
	  }
	}
	void CopyParams(UITexture cTex)	
	{
		if(cTex.m_rRect!=null)
		{
	       m_fWidth = cTex.m_fWidth;
	       m_fHeight = cTex.m_fHeight;
	
           Rect m_rRect = new Rect();
	       SetRect(cTex.m_fWidth, cTex.m_fHeight, cTex.m_rRect); 
	    }
	}
	
    /** porownuje teksture z inna*/
	boolean Equal(UITexture cTex)
	{
        if(cTex==null)
            return false;   
		//GameObject.LogLine("UITexture: Porownuje "+cTex.m_sFileName);
		if(!m_sFileName.equals(cTex.m_sFileName))
		   return false;
		if( (m_rRect!=null && cTex.m_rRect==null)
		     || (cTex.m_rRect!=null && m_rRect==null))
			return false;
       if( m_rRect!=null && cTex.m_rRect!=null)		
	   {
	       if( m_fWidth != cTex.m_fWidth ||  m_fHeight != cTex.m_fHeight
			   || m_rRect.fLeft!= cTex.m_rRect.fLeft
			   ||  m_rRect.fTop!= cTex.m_rRect.fTop
			   ||  m_rRect.fRight!= cTex.m_rRect.fRight
			   ||  m_rRect.fBottom!= cTex.m_rRect.fBottom )
			 return false;
	   }
		//GameObject.LogLine("UITexture: sa rowne "+cTex.m_sFileName);	   
	   return true;
			  
   }
	
}

