public class UIWindow extends Sprite
{
    final static int 
        _CENTER = 1,//wnetrze okna
        _BOTTOM_RIGHT = 3,        
        _BOTTOM_LEFT = 5,        
        _TOP_LEFT = 7,
        _TOP_RIGHT = 8;
    
	String m_sPatternFile = null;
    boolean m_bSavePatternFile = false;
	boolean m_bPatternFileElem = false;
    
    UIWindow m_cPattern = null;
    
    String m_sPatternName = null;
    
    String m_sSpriteMaterial = null;
    
    /**Aktualnie uzywana tekstura*/
    UITexture m_cCurTexture = null;
    
    /**Rozmiar ramki ladowany ze skryptu, jesli jest wiekszy od zera to mamy do czynienia
     * z oknem z ramka, jego tekstura jest ustawiana w inny sposob (engine mapuje ja tak, ze
     * rogi sie nie skaluja, a boki skaluja sie w jednej plaszczyznie), 
     * fX to szerokosc rogu, fY wysokosc rogu*/
    Vector m_vFrameCornerSize = null;
    
    // alpha dla textury
    float m_fTextureAlpha = 1;
    
    /** czy maska ma stac w miejscu a sprite ma sie ruszac
     * Jest to 'male oszustwo' - w momencie obrotu sprite'a maska obraca sie razem z nim
     * jezeli flaga bedzie ustawiona na 'true', to bedziemy ja obracac przeciwnie do
     * obrotu sprite'a uzyskujac w ten sposob efekt wspomniany na poczatku
     */
    boolean m_bDoNotRotateMask = false;
    
    boolean m_bDoNotMoveMask = false;
    /** tekstura maski */
    UITexture m_cMaskTexture = null;

    /*****************************/

    /**wlacza lub wylacza logowanie "wszystkiego" :)*/
    boolean m_bLogging = true;
    /**Referencja do dowolnych danych, moga one np. definiowac semantyke przycisku*/
    Object m_cData = null;
    
    int m_i = 0;
    /** identyfikator  */
    String m_sId;
    /** typ definicji wczytywanej z parsera	 */
    String m_sDefType = EUIConst.strSPECIFIC;
    /** nazwa klasy*/
    String m_sClassName = null;
    /**Aktywne okno modalne - klikniecia myszy obsluguja tylko
    * okna ktore sa potomkami tego okna, jesli null to 
    * wszystkie okna przetwarzaja klikniecia.*/
    //static UIWindow m_wndCurrentModal = null;
    /**Wskaznik na okno rodzica (nadrzedne).*/
    UIWindow m_wndParent = null;
    
    /**Wektor okien potomnych.*/
    java.util.Vector m_vChildWindows = new java.util.Vector();
    //--- dla elementu podrzednego 
    UIControlObject m_cSupervisor = null;
    // PARAMETRY USTAWIANE W EDYTORZE
    /**Stan przetwarzania myszy */
    boolean m_bProcessingMouse = false;
    /**Stan przetwarzania klawiatury*/
    boolean m_bProcessingKb = false;
    /**Stan przetwarzania joysticka */
    boolean m_bProcessingJoy = false;
    /** czy widoczne */
    boolean m_bVisible = true;
    /** tekstura okna 	 */
    /*	int m_nNormalTexture = 0;
    String m_sNormalTextureName = null;
    Rect m_rNormalTexRect = null;*/
    UITexture m_cNormalTexture = null;
    /** tekstura dla kursora po wjechaniu myszka na okno */
    String m_sCursorTex = null;
    UICursor m_currCursor = null;
    boolean m_bCursorVisible = true;
    
    //  Pozycja i rozmiar -----------------------------------------------------
    // logic 
    Vector m_vLogicPos=null;
    Vector m_vLogicSize=null;
    // real
    Vector m_vParentPos=null;
    Vector m_vParentSize=null;	
    /** czy wspolrzedne logiczne sa wzgledem rodzica */
    boolean m_bParentPositionig = false;	
    boolean m_bParentCenteringX = false;
    boolean m_bParentCenteringY = false;		    
    
    /**czy rozmiary logiczne sa wzgledem rodzica*/
    boolean m_bParentSizingX = false;
    boolean m_bParentSizingY = false;
    
    // rodzielczosc
    static float m_fDimX;
    static float m_fDimY;
    
    //FLAGI (wykorzystywane przy odrysowywaniu)
    /** czy wogole ma byc rysowany	 */
    boolean m_bActive = true;
    /** czy okno zainicjowane  */
    boolean m_bInited = false;
    
    //------------  EDYCJA ----------------------------
    /** czy okno w stanie edycji*/
    boolean m_bEditStateOnInit=false;
    boolean m_bEditState=false;
    Sprite m_cEditBorder=null;
    int m_nEditTexture = EUIConst.NO_DEFINED;
    String m_sEditTexName = null;
    /** wizusalna grubosc raku*/
    float m_fEditBorderWidth = 2.0f;
    /** efektywna grubosc ramki (czulowsc myszy	 */
    float m_fEditBorderSens = 3.0f;
    // czy ramka podlaczona do jakiegos rodzica
    boolean m_bInitBorder = false;
    //	String m_sCursorSizeVertTex = null;
    String m_sCursorOutsideEditTex = null;
    String m_sCursorSizeTex = null;	
    String m_sCursorMoveTex = null;
    // tryb edycji 
    int m_nEditMode = EUIConst.EDIT_NONE;
    /** kursor przed wejsciem do edycji   */
    String m_sOldCursorTex=null;		
    //STATEString m_cOldStateName = null;
    /** krawedz przy zmianie rozmiaru   */
    int m_nResizeEdge=-1;	
    /** biezacy kursor edycji		 */
    String m_sEditCursorTex=null;			
    /** czy cos w onie zostalo zmienione	 */
    boolean m_bWasDataUpdate = false;

    
    //pt:.------------  EFEKTY -------
    /** docelowa pozycja  okna EFFECT    */
    Vector m_vEffectDestPos = null;
    Vector  m_vEffectStartPos       = null;
    Vector  m_vPosEffectOut         = null;
    boolean m_bEffectPos = false;    
    float m_fEffectPosTime = 0.0f;
    float m_fEffectPosTolerance = 0.1f;
    Vector m_vEffectPosDiff = null; // wektor roznicy pozycji docelowej od okna
    float m_fEffectPosSpeed = 0.0f;  // predkosc transformacji
    boolean m_bEffectFirstPos = false;  // znacznik , ze pierwszy Update pozycji (w ktorym nic nie robi)
    float   m_fPosEffectLastDiff    = 0.0f;

    /** docelowy rozmiar  okna Effect    */
    Vector m_vEffectDestSize = null;    
    boolean m_bEffectSize = false;        
    float m_fEffectSizeTime = 0.0f; 
    float m_fEffectSizeTolerance = 0.03f;   
    Vector m_vEffectSizeDiff = null; // wektor roznicy pozycji docelowej od okna    
    float m_fEffectSizeSpeed = 0.0f;  //     
    boolean m_bEffectFirstSize = false;    
    int m_nReferPoint = _TOP_LEFT;
    /** docelowa alpha     */
    float m_fEffectDestAlpha = 0.0f;
    boolean m_bEffectAlpha = false;        
    float m_fEffectAlphaTime = 0.0f;    
    float m_fEffectAlphaTolerance = 0.05f; 
    float m_fEffectAlphaSpeed = 0.0f;  //     
    boolean m_bEffectFirstAlpha = false;    
    /** docelowy kat     */
    float m_fEffectDestAngle = 0.0f;
    boolean m_bEffectAngle = false;        
    float m_fEffectAngleTime = 0.0f;    
    float m_fEffectAngleTolerance = 5;  
    float m_fEffectAngleSpeed = 0.0f;  //     
    boolean m_bEffectFirstAngle = false;    
    boolean m_bContinuous = false;
    //---
    float m_fLastEffectTime = 0.0f; // dla odliczania czasu odswiezania
    float m_fEffectGrain = 0.03f; // czestotliwosc odswiezania efektow Effect
    
    //-----------   ROZWIJANIE OKIEN
    float  m_fRollShowTime = 1f;
    int m_nRollShowMode = _BOTTOM_RIGHT;
    float m_fRollShowChildTime = 0.1f;  // w jakich odstepach maja pojawiac sie dzieci
    int m_fRollShowChildCount = -1; // licznik pojawiania sie dzeci po rozwinieciu
//    boolean m_bRollHide = false; // czy okno ma sie zwjac w trybie Effect
    int m_nRollHideMode = -1;
    float  m_fRollHideTime = 1f;
    boolean m_bRollingState = false;     // czy okno w stanie zwijania
    boolean m_bChildToEffectShow = false;     // czy okna dzieci w stanie rozwijania
    boolean m_bAlphaHidingState = false;
    boolean m_bRolling = true;// czy okno ma sie zwijac
    boolean m_bUnrolling = false;// czy okno ma sie rozwijac  
    boolean m_bUnrollingChild = false;// czy okna-dzieci ma sie rozwijac  
    
    // pokazuje okno przez zmiane alphy
    float m_fEffectAlphaShowTime = -1;
    // ukrywanie okna przez zmiane alfy
    float m_fEffectAlphaHideTime = -1;
    float m_fEffectHideAlphaAfter = 0.0f; // alfa jaka ma byc przywrocona po zniknieciu okna
    
    boolean m_bEffectShowStartPos = true; // czy okno ma wlatywac z poczatkowej pozycji
    Vector m_vEffectShowStartPos = new Vector(0,0,0);    
    float m_fEffectShowStartPosTime = 1f;
    boolean m_bEffectStartPosState = false;
    //-- robocze
    Vector m_vRollEndPos = null;  // pozycja do ktorej przesuwane jest okno po zwinieciu
    Vector m_vRollEndSize = null; // rozmiar jaki przyjmie ukryte okno po zwinieciu

    //-------------
    /** czas efektow     */
    //    float m_fEffectStartTime = 0.0f;
    //    float m_fEffectTime = 0.0f;
    /** odstepy odswiezania efektow   */
    //    float m_fEffectPeriod = 0.0f;
    //    float m_fEffectStartPeriod = 0.0f;
    /** czy koniec efektow ma byc wyznaczany po osiagnieciu docelowej pozycji i romiaru 
    * zamiast po okreslonym czesie     */
    //    boolean m_bEffectEndAfterFix = false; 
    /** jak blisko kno musi byc punktu docelowego zeby zakonczyc efekty   */
    //    float m_fEffectDestTolerance = 0.0f;
    /** cze ma sie skalowac wzgledem swojego srodka (true) , czy wzgledem swojego lewego,
    * gornego rogu */
    //    boolean m_bEffectCenterSizing = false;
    
    void OnCreate()
    {
        m_vLogicPos = new Vector(0.1f,0.1f,0);
        m_vLogicSize = new Vector(0.2f,0.2f,0);		
        m_vParentPos = new Vector(0,0,0);
        m_vParentSize = new Vector(1,1,1);
        
        m_fDimX = GameObject.GetScreenWidth();
        m_fDimY = GameObject.GetScreenHeight();
    }
    
    /**  aktywuje/deaktywuje okno oraz jego wszystkie dzieci*/
    void SetActive(boolean bActive)
    {
        m_bActive = bActive;		
        if(! m_bEditState)
        {
            UIWindow wnd;
            int cnt = m_vChildWindows.size();
            for(int i = 0; i < cnt; i++)
            {
                wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
                wnd.SetActive(bActive);
            }
        }
    }
    void SetData(Object cData)
    {
        m_cData = cData;
    }
    
    Object GetData()
    {
        return m_cData;
    }
    
    //=========== ODSWIEZANIE ===================
    //-----------------    czesc wolana co ramke, ktora mozna pokryc
    /** handler wolany co kazda ramke, w ktorym mozna zmieniac stan przycisku	 */
    public void OnFrame()
    {
        if(!m_bInited)
            return;		
        //        LogLine(this + " OnFrame ");
        UpdateEffect();
    }
    
    
    /** odswieza wszystkie parametry okna   */
    public void Reload()
    {
        OnSizeAndPos();
        OnTextureChange();
        OnFrame();
        
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.Reload();
        }
    }
    
    
    public void ReloadSizeAndPos()
    {
        OnSizeAndPos();
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.ReloadSizeAndPos();
        }
    }	

    public void OnTextureChange()
    {
        if(m_cNormalTexture!=null)
        {
            if(m_cNormalTexture.m_nId != 0)	
            {
                SetTexture(m_cNormalTexture);
            }
        }
        else
        {
            SetNoTexture();
        }
    }
    /** zwraca pozycje okna w zaleznosci od paramtrow pozycjonowania    */
    Vector CalculatePos()
    {
        Vector vNewPos = new Vector(0,0,0);
        m_fDimX = GetScreenWidth();
        m_fDimY = GetScreenHeight();        
        if(!m_bParentPositionig)
        {
            vNewPos.fX = m_vLogicPos.fX*m_fDimX;
            vNewPos.fY = m_vLogicPos.fY*m_fDimY;
            vNewPos.fZ = 0;                
        }
        else
        {
            UpdateParentPos();			
            vNewPos.fX = GetRealByParentX();
            vNewPos.fY = GetRealByParentY();
            vNewPos.fZ = 0;
        }		        
        return vNewPos;
    }
    /** zwraca rozmiar okna w zaleznosci od paramtrow ustalania rozmiaru*/    
    Vector CalculateSize()
    {
        m_fDimX = GetScreenWidth();
        m_fDimY = GetScreenHeight();        

        Vector vNewSize = new Vector(m_vLogicSize.fX*m_fDimX,
                                     m_vLogicSize.fY * m_fDimY, 0);
        if (m_bParentSizingX)
        {
            UpdateParentPos();
            vNewSize.fX = m_vLogicSize.fX*m_vParentSize.fX;
        }
        if (m_bParentSizingY)
        {
            UpdateParentPos();
            vNewSize.fY = m_vLogicSize.fY*m_vParentSize.fY;
        }       
        return vNewSize;
    }
    /** metoda odswiezania pozycji i rozmiaru, na podstawie logicznych danych (m_vLogicPos, m_vLogiSize)*/
    public void OnSizeAndPos()
    {
        // POZYCJA
        ((Sprite)this).SetPos(CalculatePos());

        // ROZMIAR
        ((Sprite)this).SetSize(CalculateSize());
        
        if(m_i<=0)
        {
            m_i++;
            OnSizeAndPos();
        }
    }
    
    //================= INICJACJA OKNA ============================
    //--------------------------- metoda wywolywana po zaladowaniu obiektu
    public void OnInit()
    {
        if (m_bLogging)
            LogLine("OnInit: "+m_sId);
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.OnInit();
        }
        if(m_bEditStateOnInit)
        {
            SetEditState();			
        }
        m_bInited = true;
        
        SetVisible(m_bVisible);
        OnSizeAndPos();
    }
    
    //==================   POZYCJA I ROZMIAR ============================
    /** uzyskanie logicznej pozycji okna <0..1>*/
    float GetLogicPosX()
    {
        return 	m_vLogicPos.fX;
    }
    
    float GetLogicPosY()
    {
        return  m_vLogicPos.fY;
    }
    
    Vector GetLogicPos()
    {
        return m_vLogicPos;
    }
    
    /** ustawieni logicznj pozycji okna <0..1> */
    void SetLogicPos(Vector vPos)
    {
        m_vLogicPos=vPos;
        OnSizeAndPos();
    }
    
    /** funkcje dla rozmiaru okna     */
    float GetLogicSizeX()
    {
        return m_vLogicSize.fX;
    }
    
    float GetLogicSizeY()
    {
        return  m_vLogicSize.fY;
    }
    
    void SetLogicSize(Vector vSize)
    {
        m_vLogicSize=vSize;
        OnSizeAndPos();
    }
    Vector GetLogicSize()
    {
        return m_vLogicSize;
    }    
    
    Vector vOrigS = new Vector();
    //funkcje obslugujace parametry fizyczne -  <0f..m_fDim>
    void SetRealPos(Vector vPos)
    {
        if(m_bParentPositionig)
        {
            float fFromParentBeginX = vPos.fX - m_vParentPos.fX;
            float fFromParentBeginY = vPos.fY - m_vParentPos.fY;		   
            
            if(m_vParentSize.fX != 0)
                m_vLogicPos.fX = fFromParentBeginX / m_vParentSize.fX;
            if(m_vParentSize.fY != 0)
                m_vLogicPos.fY = fFromParentBeginY / m_vParentSize.fY;			
        }
        else
        {
            m_vLogicPos.fX = vPos.fX / m_fDimX;
            m_vLogicPos.fY = vPos.fY /	m_fDimY;
        }		   
        if (vOrigS.equals(vPos))
            return;
        
        vOrigS.Set(vPos);
        
        /*if (vPos.fX < 0)
            vPos.fX = (float)((int)vPos.fX);
        else
        {
            if (vPos.fX - (float)((int)vPos.fX) >= 0.5f)
                vPos.fX = (float)((int)vPos.fX) + 1f;
            else
                vPos.fX = (float)((int)vPos.fX);
        }
        if (vPos.fY < 0)
            vPos.fY = (float)((int)vPos.fY);
        else
        {
            if (vPos.fY - (float)((int)vPos.fY) >= 0.5f)
                vPos.fY = (float)((int)vPos.fY) + 1f;
            else
                vPos.fY = (float)((int)vPos.fY);
        }*/
       
        vPos.Round();
        
        /*if (m_sId != null && m_sId.startsWith("ID_PROGRESS"))
            LogR(this + " SetPos " + vOrigS + " clamp " + vPos);*/
        
        super.SetPos(vPos);
    }

    void SetPosition(Vector vPos)
    {
        SetRealPos(vPos);
    }
    
    float GetRealX()
    {
        if(m_bParentPositionig)
            return m_vParentSize.fX * m_vLogicPos.fX + m_vParentPos.fX;
        else
            return m_fDimX * m_vLogicPos.fX;
    }
    
    float GetRealY()
    {
        if(m_bParentPositionig)
            return m_vParentSize.fY * m_vLogicPos.fY +  m_vParentPos.fY ;
        else		
            return 	m_fDimY * m_vLogicPos.fY;
    }
    
    Vector vOrig = new Vector();
    
    void SetRealSize(Vector vSize)
    {
        if (!m_bParentSizingX)
            m_vLogicSize.fX = vSize.fX / m_fDimX; 
        else
            m_vLogicSize.fX = vSize.fX / m_vParentSize.fX;
        if (!m_bParentSizingY)
            m_vLogicSize.fY = vSize.fY / m_fDimY;
        else
            m_vLogicSize.fY = vSize.fY / m_vParentSize.fY;
        
        if (vOrig.equals(vSize))
            return;
        
        vOrig.Set(vSize);
        
        /*if (vSize.fX - (float)((int)vSize.fX) >= 0.5f)
            vSize.fX = (float)((int)vSize.fX) + 1f;
        else
            vSize.fX = (float)((int)vSize.fX);
        
        if (vSize.fY - (float)((int)vSize.fY) >= 0.5f)
            vSize.fY = (float)((int)vSize.fY) + 1f;
        else
            vSize.fY = (float)((int)vSize.fY);
        */
        //Zaokraglamy do intow
        vSize.Round();
        
        /*if (m_sId != null && m_sId.startsWith("ID_PROGRESS"))
            LogR(this + " SetSize " + vOrig + " clamp " + vSize);*/
        super.SetSize(vSize);						 
    }
    
    public void SetSize(Vector vSize)
    {
        SetRealSize(vSize);
        UpdateMaskSizeAndPos();
    }
    
    Vector GetRealSize()
    {
        Vector vSize = new Vector(m_vLogicSize.fX*m_fDimX, m_vLogicSize.fY*m_fDimY,0);
        if (m_bParentSizingX)
            vSize.fX = m_vLogicSize.fX * m_vParentSize.fX;
        if (m_bParentSizingY)
            vSize.fY = m_vLogicSize.fY * m_vParentSize.fY;
        
        return vSize;	
    }
    
    /** ustawienie rzeczywistych pozycji rodzica	<0f..m_fDim> */
    void SetParentPos(Vector vPos)
    {
        m_vParentPos = vPos;
    }
    

    void SetParentSize(Vector vSize)
    {
        m_vParentSize = vSize;	 
    }	 

    void UpdateParentPos()
    {
        if(m_wndParent!=null)
        {
            if(m_wndParent.m_bParentPositionig)
            {
                m_wndParent.UpdateParentPos();
                m_vParentPos = new Vector(m_wndParent.GetRealByParentX(), m_wndParent.GetRealByParentY(), 0);				
            }
            else   
                m_vParentPos = new Vector(m_wndParent.GetRealX(), m_wndParent.GetRealY(), 0);
            m_vParentSize = new Vector(m_wndParent.GetRealSize().fX, m_wndParent.GetRealSize().fY, 0);	 	 
        }
        else
        {
            m_vParentPos = new Vector(0,0,0);
            m_vParentSize = new Vector(m_fDimX, m_fDimY, 0);
        }
    }
    
    /** wylicza rzeczywista pozycje w X na podstawie rodzica      */
    float GetRealByParentX()
    {
        float fX; 
        if(m_bParentCenteringX)  // srodkuje wzgledem rodzica
        {
            float fMyHalf = GetRealSize().fX / 2.0f;
            float fParentHalf = m_vParentSize.fX / 2.0f;			 
            fX = m_vParentPos.fX + fParentHalf - fMyHalf;
        }
        else	 // jesli wzgledne pozycje 
            fX = m_vParentPos.fX +(m_vParentSize.fX * m_vLogicPos.fX);
        return fX;
    }
    
    /** wylicza rzeczywista pozycje w Y na podstawie rodzica      */	 
    float GetRealByParentY()
    {
        float fY; 
        if(m_bParentCenteringY)  // srodkuje wzgledem rodzica
        {
            float fMyHalf = GetRealSize().fY / 2.0f;
            float fParentHalf = m_vParentSize.fY / 2.0f;			 
            fY = m_vParentPos.fY + fParentHalf - fMyHalf;
        }
        else	 // jesli wzgledne pozycje 
            fY = m_vParentPos.fY +(m_vParentSize.fY * m_vLogicPos.fY);
        return fY;
    }	 
    
    
    /** Sprawdzenie, czy punkt nalezy do okna*/
    boolean HitTest(Vector hitpoint)
    {
        // Sprawdzenie, czy punkt nalezy do okna
        Vector p = ((Sprite)this).GetPos();
        Vector s = ((Sprite)this).GetSize();
        
        if (p == null || s == null)
            return false;
        
        return (
                (hitpoint.fX >= p.fX) &&
                (hitpoint.fX <= p.fX + s.fX) &&
                (hitpoint.fY >= p.fY) &&
                (hitpoint.fY <= p.fY + s.fY)
                );
    }
    //----------------------------  koniec pozyci i rozmiarow-------------------------
    
    //================  OBSLUGA PARSERA =========================================
    /** wczytuje dan eokna z pliku skryptowego      */
    boolean Load(ParseKeyword wndKey)
    {
        ParseKeyword  paramKey;
        for(paramKey=wndKey.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
        {
            if(paramKey.Equals("Id"))			
            {
                m_sId =paramKey.GetSParam(0);
                SetName(m_sId);
            }
            if(paramKey.Equals("Window"))
            {
                if (m_bLogging)
                    LogLine("WYKRYLEM: Window ---");
                UIWindow cWnd;
                String sClassName = paramKey.GetSParam(0);
                cWnd = (UIWindow)CreateUIObject(sClassName); 
                cWnd.m_sClassName = sClassName;
                if(this instanceof UIControlObject)
                    cWnd.m_cSupervisor = (UIControlObject)this;					
                else
                    cWnd.m_cSupervisor = this.m_cSupervisor;					
                
                cWnd.m_sId = paramKey.GetSParam(1);
                cWnd.SetName(cWnd.m_sId);
                cWnd.m_sDefType = paramKey.GetSParam(2);
                if( LoadPatternableElem(paramKey, cWnd,EUIConst.sWINDOW))				
                {
                    if(cWnd.m_sId.equals(EUIConst.sWINDOW) || 
                       cWnd.m_sDefType.equals(EUIConst.strPATTERN))
                    {
                        if(this instanceof UIControlObject)
                            ((UIControlObject)this).AddPattern(cWnd);
                        else
                            m_cSupervisor.AddPattern(cWnd);
                    }
                    else
                        AddChild(cWnd);
                }
            }
            if(paramKey.Equals("Static"))
            {
                if (m_bLogging)
                    LogLine("Key: Static ---");
                UIWindow cStatic;
                
                String sClassName = paramKey.GetSParam(0);
                cStatic = (UIStatic)CreateUIObject(sClassName); 
                cStatic.m_sClassName = sClassName;
                
                if(this instanceof UIControlObject)
                    cStatic.m_cSupervisor = (UIControlObject)this;					
                else
                    cStatic.m_cSupervisor = this.m_cSupervisor;
                
                cStatic.m_sId = paramKey.GetSParam(1);
                cStatic.SetName(cStatic.m_sId);
                cStatic.m_sDefType = paramKey.GetSParam(2);
                
                if( LoadPatternableElem(paramKey, cStatic,EUIConst.sSTATIC))				
                {
                    if(cStatic.m_sId.equals(EUIConst.sSTATIC) || 
                       cStatic.m_sDefType.equals(EUIConst.strPATTERN))
                    {
                        if(this instanceof UIControlObject)
                            ((UIControlObject)this).AddPattern(cStatic);
                        else
                            m_cSupervisor.AddPattern(cStatic);
                    }
                    else
                        AddChild(cStatic);
                }
                else
                    LogLine("Zjebany static");
            }
            
            if(paramKey.Equals("ControlObject"))
            {
                if (m_bLogging)
                    LogLine("WYKRYLEM: ControlObject ---");
                UIControlObject cCtl;

                String sClassName = paramKey.GetSParam(0);
                cCtl = (UIControlObject)CreateUIObject(sClassName); 
                cCtl.m_sClassName = sClassName;
                
                if(this instanceof UIControlObject)
                    cCtl.m_cSupervisor = (UIControlObject)this;					
                else
                    cCtl.m_cSupervisor = this.m_cSupervisor;
                
                cCtl.m_sId = paramKey.GetSParam(1);
                cCtl.SetName(cCtl.m_sId);
                cCtl.m_sDefType = paramKey.GetSParam(2);
                
                if( LoadPatternableElem(paramKey, cCtl,EUIConst.sCONTROL_OBJECT))				
                {
                    if(cCtl.m_sId.equals(EUIConst.sCONTROL_OBJECT) ||
                       cCtl.m_sDefType.equals(EUIConst.strPATTERN))
                    {
                        if(this instanceof UIControlObject)
                            ((UIControlObject)this).AddPattern(cCtl);
                        else                        
                            m_cSupervisor.AddPattern(cCtl);
                    }
                    else
                        AddChild(cCtl);
                }
            }	
            
            if(paramKey.Equals("Button"))
            {
                if (m_bLogging)
                    LogLine("WYKRYLEM: Button ---");
                UIButton btn;

                String sClassName = paramKey.GetSParam(0);
                btn = (UIButton)CreateUIObject(sClassName); 
                btn.m_sClassName = sClassName;
                
                if(this instanceof UIControlObject)
                    btn.m_cSupervisor = (UIControlObject)this;					
                else
                    btn.m_cSupervisor = this.m_cSupervisor;
                
                btn.m_sId = paramKey.GetSParam(1);
                btn.SetName(btn.m_sId);
                btn.m_sText = paramKey.GetSParam(2);
                btn.m_sDefType = paramKey.GetSParam(3);
                //LogLine("Button prams: "+btn.m_sId+" "+btn.m_sText+" "+" "+sType);
                if( LoadPatternableElem(paramKey, btn, EUIConst.sBUTTON))				
                {
                    if(btn.m_sId.equals(EUIConst.sBUTTON) || 
                       btn.m_sDefType.equals(EUIConst.strPATTERN))
                    {
                        if(this instanceof UIControlObject)
                            ((UIControlObject)this).AddPattern(btn);
                        else                                                
                            m_cSupervisor.AddPattern(btn);
                    }
                    else
                        AddChild(btn);	
                }				
            }
            if(paramKey.Equals("Menu"))
            {
                if (m_bLogging)
                    LogLine("WYKRYLEM: Menu ---");
                UIMenu menu;
                
                String sClassName = paramKey.GetSParam(0);
                menu = (UIMenu)CreateUIObject(sClassName); 
                menu.m_sClassName = sClassName;				
                
                if(this instanceof UIControlObject)
                    menu.m_cSupervisor = (UIControlObject)this;					
                else
                    menu.m_cSupervisor = this.m_cSupervisor;
                
                menu.m_sId = paramKey.GetSParam(1);
                menu.SetName(menu.m_sId);
                menu.m_sDefType = paramKey.GetSParam(2);
                if( LoadPatternableElem(paramKey, menu,EUIConst.sMENU))				
                {
                    if(menu.m_sId.equals(EUIConst.sMENU) ||
                       menu.m_sDefType.equals(EUIConst.strPATTERN))
                    {
                        if(this instanceof UIControlObject)
                            ((UIControlObject)this).AddPattern(menu);
                        else
                            m_cSupervisor.AddPattern(menu); 
                    }
                    else
                        AddChild(menu);
                }				
            }			
            if(paramKey.Equals("Edit"))
            {
                if (m_bLogging)
                    LogLine("WYKRYLEM: Edit ---");
                UIEdit cEdit;

                String sClassName = paramKey.GetSParam(0);
                cEdit = (UIEdit)CreateUIObject(sClassName); 
                cEdit.m_sClassName = sClassName;

                if(this instanceof UIControlObject)
                    cEdit.m_cSupervisor = (UIControlObject)this;					
                else
                    cEdit.m_cSupervisor = this.m_cSupervisor;
                
                cEdit.m_sId = paramKey.GetSParam(1);
                cEdit.SetName(cEdit.m_sId);
                cEdit.m_sText = paramKey.GetSParam(2);
                cEdit.m_sDefType = paramKey.GetSParam(3);
                
                if(cEdit.m_sDefType.startsWith(EUIConst.strREGULAR))
                {
                    cEdit.m_sPatternName = ParsePatternName(cEdit);
                    UIButton pattWnd = (UIButton)m_cSupervisor.GetPattern(cEdit.m_sPatternName);
                    
                    if (pattWnd == null)
                        CrashLog(this + " couldn't find pattern " + cEdit.m_sPatternName);
                    
                    if(pattWnd==null)
                        pattWnd = (UIButton)m_cSupervisor.GetPattern(EUIConst.sBUTTON);
                    
                    if(pattWnd!=null)				   
                    {
                        pattWnd.Copy(cEdit, pattWnd);
                        cEdit.Load(paramKey);
                        if(cEdit.m_sId.equals(EUIConst.sEDIT) ||
                            cEdit.m_sDefType.equals(EUIConst.strPATTERN))
                        {
                            if(this instanceof UIControlObject)
                                ((UIControlObject)this).AddPattern(cEdit);
                            else                                                    
                                m_cSupervisor.AddPattern(cEdit);
                        }
                        else
                            AddChild(cEdit);					   
                    }
                }
                
                if(cEdit.m_sDefType.equals(EUIConst.strSPECIFIC)||
                    cEdit.m_sDefType.equals(EUIConst.strPATTERN))
                {
                    cEdit.Load(paramKey);
                    if( cEdit.m_sId.equals(EUIConst.sEDIT) ||
                        cEdit.m_sDefType.equals(EUIConst.strPATTERN))
                        m_cSupervisor.AddPattern(cEdit);
                    else
                        AddChild(cEdit);					   
                }	
            }			

            if(paramKey.Equals("LogicPos"))
            {	
                float fV0 = paramKey.GetFParam(0);
                float fV1 = paramKey.GetFParam(1);
                Vector vPos = new Vector(fV0, fV1, 0);
                SetLogicPos(vPos);
            }
            if(paramKey.Equals("LogicSize"))
            {
                float fV0 = paramKey.GetFParam(0);
                float fV1 = paramKey.GetFParam(1);
                Vector vSize = new Vector(fV0, fV1, 0);			  
                SetLogicSize(vSize);  
            }
            if(paramKey.Equals("Mouse"))
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    SetProcessMouse(true);
                else		 
                    SetProcessMouse(false);
            }
            if(paramKey.Equals("Keyboard"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    SetProcessKb(true);
                else		 
                    SetProcessKb(false);
            }			 
            if(paramKey.Equals("Joy"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    SetProcessJoy(true);
                else
                    SetProcessJoy(false);
            }					 		  
            if(paramKey.Equals("Texture"))						 
            {	
                m_cNormalTexture = new UITexture(this);
                m_cNormalTexture.m_sFileName = paramKey.GetSParam(0);
                m_cNormalTexture.m_rRect = null;
                LoadTexture(m_cNormalTexture);				
            }
            
            if(paramKey.Equals("SpriteMaterial"))						 
            {	
                m_sSpriteMaterial = paramKey.GetSParam(0);
                SetSpriteMaterial(m_sSpriteMaterial);				
            }
            
            if(paramKey.Equals("TextureAlpha"))
            {
                SetTextureAlpha(paramKey.GetFParam(0));   
            }
            if (paramKey.Equals("TextureRect"))  // tekstura wycieta 
            {
                m_cNormalTexture = new UITexture(this);
                m_cNormalTexture.m_sFileName = paramKey.GetSParam(0);
                m_cNormalTexture.SetRect(paramKey.GetFParam(1),
                                         paramKey.GetFParam(2),
                                         paramKey.GetFParam(3),
                                         paramKey.GetFParam(4),
                                         paramKey.GetFParam(5),
                                         paramKey.GetFParam(6));										 
                LoadTexture(m_cNormalTexture);				
            }
            if (paramKey.Equals("FrameCornerSize"))  // tekstura wycieta 
            {
                m_vFrameCornerSize = new Vector(paramKey.GetIParam(0), paramKey.GetIParam(1),0);
            }

            if(paramKey.Equals("EditStateOnInit"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                {
                    m_bEditStateOnInit = true;
                    //					LogLine("BEDZIE ON INIT EDITSTATE");
                }
                else		 
                    m_bEditStateOnInit = false;
            }					 		  				
            
            if(paramKey.Equals("Visible"))
            {
                int nVal = paramKey.GetIParam(0);			 
                if (nVal==1)
                    m_bVisible= true;
                else		 
                    m_bVisible= false;
            }
            if(paramKey.Equals("Hidden"))
            {
                m_bVisible = false;
            }		 
            if(paramKey.Equals("ParentPositioning"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    m_bParentPositionig = true;
                if (nVal==0)
                    m_bParentPositionig = false;
            }		
            if(paramKey.Equals("ParentCenteringX"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    m_bParentCenteringX = true;
                if (nVal==0)
                    m_bParentCenteringX = false;
            }
            
            if(paramKey.Equals("ParentCenteringY"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    m_bParentCenteringY = true;
                if (nVal==0)
                    m_bParentCenteringY = false;
            }
            if(paramKey.Equals("ParentSizingX"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    m_bParentSizingX = true;
                if (nVal==0)
                    m_bParentSizingX = false;
            }
            
            if(paramKey.Equals("ParentSizingY"))						 
            {
                int nVal = paramKey.GetIParam(0);
                if (nVal==1)
                    m_bParentSizingY = true;
                if (nVal==0)
                    m_bParentSizingY = false;
            }
            if(paramKey.Equals("MaskTexture"))
            {
                m_cMaskTexture = new UITexture( paramKey.GetSParam( 0 ),
                                                paramKey.GetFParam( 1 ),
                                                paramKey.GetFParam( 2 ),
                                                paramKey.GetFParam( 3 ),
                                                paramKey.GetFParam( 4 ),
                                                paramKey.GetFParam( 5 ),
                                                paramKey.GetFParam( 6 ) );
                AddMaskTexture();
            }
			
			if (paramKey.Equals("PatternFile"))
            {
				m_sPatternFile = paramKey.GetSParam(0);
            }
            
            //obiekt jest z pliku patterna, nie bedziemy go zapisywac
            if (paramKey.Equals("PatternFileElem"))
                m_bPatternFileElem = true;
			
        }
        
        
        OnTextureChange();
        OnSizeAndPos();
        return true;
    }
    
    void AddMaskTexture()
    {
        if( m_cMaskTexture == null )
            return;
        
        SetSpriteMaterial("Mask.mat");
                    
        m_cMaskTexture.m_nId = AddMask( m_cMaskTexture.m_sFileName );
        
        if( m_cMaskTexture.m_nId > -1 )
        {
            if( SetMask( m_cMaskTexture.m_nId, m_cMaskTexture.GetLogicRect() ) )
            {
                UpdateMaskSizeAndPos();
            }
        }
    }
    
    void UpdateMaskSizeAndPos()
    {
        if( m_cMaskTexture == null )
            return;
        
        MaskSetScale( GetSize().fX / m_cMaskTexture.m_fWidth,
                      GetSize().fY / m_cMaskTexture.m_fHeight );
        //Centrowanie maski
        MaskSetPosition( ( GetSize().fX - m_cMaskTexture.m_fWidth ) / 2,
                         ( GetSize().fY - m_cMaskTexture.m_fHeight ) / 2 );
    }
    
    void SetMaskPos(float fX, float fY)
    {
        SetMaskPos( new Vector( fX, fY, 0f ) );
    }
    
    void SetMaskPos( Vector vPos )
    {
        if( m_cMaskTexture != null )
        {
            MaskSetPosition( ( GetSize().fX - m_cMaskTexture.m_fWidth ) / 2 + vPos.fX,
                             ( GetSize().fY - m_cMaskTexture.m_fHeight ) / 2 + vPos.fY);
        }
    }
    void SetMaskLogicPos(float fX, float fY)
    {
        SetMaskLogicPos( new Vector( fX, fY, 0f ) );
    }
    
    void SetMaskLogicPos( Vector vPos )
    {
        if( m_cMaskTexture != null )
        {
            MaskSetPosition( ( GetSize().fX - m_cMaskTexture.m_fWidth ) / 2 + vPos.fX * GetSize().fX,
                             ( GetSize().fY - m_cMaskTexture.m_fHeight ) / 2 + vPos.fY * GetSize().fY);
        }
    }
    
    /** wczytuje z pliku element, ktory moze dziedziczyc wzorce */
    boolean LoadPatternableElem(ParseKeyword paramKey, UIWindow cWnd, String sClass)
    {
        if (m_bLogging)
            LogLine("Jestem w loadpatternable "+cWnd);				
        UIWindow pattWnd;			
        if(cWnd.m_sDefType.startsWith(EUIConst.strREGULAR))
        {
            cWnd.m_sPatternName = ParsePatternName(cWnd);
            if (this instanceof UIControlObject)
                pattWnd = ((UIControlObject)this).GetPattern(cWnd.m_sPatternName);
            else
                pattWnd = m_cSupervisor.GetPattern(cWnd.m_sPatternName);
            if(pattWnd!=null)
            {
                m_cPattern = pattWnd;
                cWnd.Copy(cWnd, pattWnd);
                cWnd.Load(paramKey);
                return true;
            }
            else
            {
                CrashLog(this + " couldn't find pattern " + cWnd.m_sPatternName);
            }
        }
        
        if(cWnd.m_sDefType.equals(EUIConst.strSPECIFIC))
        {
            if (m_bLogging)
                LogLine("bede ladowal  specifica "+cWnd);				
            if(cWnd.Load(paramKey))
            {
                if (m_bLogging)
                    LogLine("Zaladowalem specifica "+cWnd);				
                return true;
            }
            else
                LogLine("Nie moge zaladowac specifca "+cWnd);
        }			
        
        if (cWnd.m_sDefType.equals(EUIConst.strPATTERN))
        {
            if (m_bLogging)
                LogLine("bede ladowal  patterna "+cWnd);				
            if(cWnd.Load(paramKey))
            {
                if (m_bLogging)
                    LogLine("Zaladowalem patterna "+cWnd);				
                return true;
            }
            else
                LogLine("Nie moge zaladowac patterna "+cWnd);
        }
        
        return false;
    }

    UIWindow CreateUIObject(String sClassName)
    {
        UIWindow cNewWnd = (UIWindow)CreateObject(sClassName);
        cNewWnd.m_sClassName = sClassName;
        return cNewWnd;
    }

	void SetTextColorForAll( float r, float g, float b, float a )
    {
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.SetTextColorForAll( r, g, b, a );
        }
		SetTextColor( r, g, b, a );
    }
	
    /** dopisuje do wektora interfejsu wszystkie zagniezdzone elementy */
    void AddToInterface(java.util.Vector vElems)
    {
        vElems.addElement((Object)this);
        //ActivateOnModule();
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            AddMember(wnd);
            wnd.AddToInterface(vElems);
        }
    }
    
    void AddMember(UIWindow wnd)
    {
        if(this instanceof UIControlObject)
            wnd.m_cSupervisor = (UIControlObject)this; 
        else
            wnd.m_cSupervisor = m_cSupervisor; 
        
        if(m_currCursor!=null)
        {
            wnd.m_currCursor = m_currCursor;
            wnd.m_sCursorTex = m_sCursorTex;
        }
    }

    /** Ustala proces edycji dla potomka	 */
    void FixMemberEditParams(UIWindow wnd)
    {
        wnd.m_fEditBorderWidth = m_fEditBorderWidth;
        wnd.m_fEditBorderSens = m_fEditBorderSens;
        wnd.m_sCursorOutsideEditTex = m_sCursorOutsideEditTex;        
        wnd.m_sCursorSizeTex = m_sCursorSizeTex;        
        wnd.m_sCursorMoveTex = m_sCursorMoveTex;	        
        if(m_sEditTexName!=null)  
            if(wnd.m_sEditTexName==null) // byc moze dostalo z parsera 					
                wnd.CreateEditBorder(m_sEditTexName);     			 

    }

    /** ustawia stan editu dzieciom wraz z dziedziczeniem parametrow edycji	 */
    void SetMembersEditState()
    {
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            FixMemberEditParams(wnd);
            wnd.SetMembersEditState();
        }
    }

    /** ustawia teksture na kursorze 	 */
    String g_sCursor = null;
    void SetCursor(String sTex)
    {
        if (m_currCursor==null)
            return;
        if (sTex == null)
        {
            Tools.CrashLogError("Setting null cursor texture for " + this + " \n");
            return;
        }
        //g_sCursor = new String(sTex);
        m_currCursor.SetCursorTex(sTex);
        //CallMethodIn("ContinueSetCursor", 0);
    }
    
    UIWindow GetElem(String sId)
    {
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	 
            if(wnd.m_sId != null)
            {
                if(wnd.m_sId.equals(sId))
                    return wnd;
                else
                {
                    UIWindow found = wnd.GetElem(sId);
                    if (found != null)
                        return found;
                }
            }
        }
        return null;
    }	
    
    
    /** Ustawienie alfy dla okna oraz okien potomnych     //Abak - OK
     */	
    void SetAlphaForAll(float fAlpha)
    {
        SetAlpha(fAlpha);
        
        UIWindow wnd = null;
        
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);
            if (wnd != null)
                wnd.SetAlphaForAll(fAlpha);			
        }		        
    }
    
    /** ustwia alfe dla textury     */
    void SetTextureAlpha(float fTextureAlpha)
    {
        m_fTextureAlpha = fTextureAlpha;
        SetAlpha(m_fTextureAlpha);
    }
    /** zwraca alfe dla textury     */
    float GetTextureAlpha()
    {
        return m_fTextureAlpha;
    }    


    /**Dodaje okno potomne do wektora okien potomnych. Jesli 
     * okno ktore dodajemy mialo jakiegos rodzica to jest on zmieniany.
     * @param wndNew okno dodawane jako potomek*/
    void AddChild(UIWindow wndNew)   // Abak - OK
    {
        if (wndNew.m_sId.equalsIgnoreCase("ID_BELT"))
            wndNew.m_sId ="ID_BELT";
        
        if (wndNew.m_wndParent != null)//to okno mialo juz rodzica
            wndNew.m_wndParent.RemoveChild(wndNew);
        
        m_vChildWindows.addElement((Object)wndNew);
        super.AddChild(wndNew);
        
        wndNew.m_wndParent = this;
    }

    /**Usuwa okno potomne z wektora okien potomnych.
     * @param wnd usuwane okno
     */
    void RemoveChild(UIWindow wnd)   // Abak  - OK
    {
        wnd.DetachFromParent();
        m_vChildWindows.removeElement((Object)wnd);
    }

    /** przeszukiwana jest cala hierarchia w celu usuniecia elementu 
     * (przeciazona w controlObject)*/
    boolean SearchAndRemove(UIWindow cWndToDel)
    {
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i<cnt; i++)
        {
            wnd =(UIWindow) m_vChildWindows.elementAt(i);	   		
            if(cWndToDel == wnd)
            {
                //--usuniecie okna------
                wnd.ReleaseTextures();
                wnd.Remove();
                //----------------------
                RemoveChild(wnd);								
                wnd.delete();			
                wnd = null;							
                cWndToDel=null;
                return true;
            }
            else
            {
                boolean bDeleted = wnd.SearchAndRemove(cWndToDel);
                if(bDeleted)
                    return true;
            }
        }
        return false;
    }

    boolean IsChildOf(UIWindow cWnd)
    {
        return cWnd.IsParentFor(this);
    }
    
    boolean IsParentFor(UIWindow cChild)
    {
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i<cnt; i++)
        {
            wnd =(UIWindow) m_vChildWindows.elementAt(i);	   		
            if(cChild == wnd)
            {
                return true;
            }
            else
            {
                boolean bFound = wnd.IsParentFor(cChild);
                if(bFound)
                    return true;
            }
        }
        return false;
    }
    
    /** usuwa obiekt (przeciazona w controlObject)    */
    void Remove()
    {
        // kasuje dzieci
        UIWindow wnd;		
        int cnt = m_vChildWindows.size();
        while(m_vChildWindows.size()>0)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(0);	   				
            RemoveChild(wnd);
            wnd.Remove();
            wnd.DetachFromParent();
            wnd.delete();			
            wnd = null;			
        }
        DestroyEditBorder();
        m_cSupervisor = null;
        m_wndParent = null;
        RemoveMaskSprite();
        ReleaseTextures();
        RemoveSprite(this);
    }
    
    void CascadeShow(float fDelay, float fPeriod)
    {
        UIWindow wnd;	
        float fMyDelay = fDelay;
        int cnt = m_vChildWindows.size();
        for (int i = 0; i < cnt; i++)
        {
            fDelay += fPeriod;
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   				
            wnd.CascadeShow(fDelay, fPeriod);
            wnd.Hide();
        }
        CallMethodIn("Show", fMyDelay);
    }
    
    void RemoveMaskSprite()
    {
        if(m_cMaskTexture != null && m_cMaskTexture.m_nId > -1 )
        {
            ReleaseTexture( m_cMaskTexture );
        }
    }

    
    /**[native] Wywolywana gdy nacisnieto przycisk.
     * Wola metode OnButton(...)
     * @param btnSender wcisniety przycisk 
     */
    public native void CallOnUIButton(UIButton btnSender);
    
    /**[native] Wywolywana gdy byl doubleclick na przycisku.
     * Wola metode OnButtonDoubleClick(...)
     * @param btnSender wcisniety przycisk 
     */
    public native void CallOnUIButtonDoubleClick(UIButton btnSender);

    /**[native] Wywolywana gdy kliknieto przycisk prawym klawiszem myszy.
     * Przez klikniecie rozumiemy wcisniecie i puszczenie klawisza
     * nad oknem przycisku. Wola metode OnButtonRB(...).
     * @param btnSender klikniety przycisk
     */
    void OnButtonRB(Button btnSender)
    {
    }
    
    void OnButtonHighlight(Button btnSender)
    {
        
    }
    
    void OnButton(Button btnSender) 
    {
    }
    void OnButtonDoubleClick(Button btnSender) 
    {
    }
    
    void OnRBUp(float fMouseX, float fMouseY)
    {
        
    }
    
    public native void CallOnUICommand(UIWindow cSender, int nCommand);

    
    public native void CallOnUINotify(UIWindow cSender, int nEvent);


    /**Sprawdza, czy okno ma przetwarzac komunikaty o klawiszach myszy.
     * Nie moze, jesli aktywne jest inne okno modalne.*/
    boolean CanProcessMouse()  // Abak -  OK
    {
        if(!m_bActive)
            return false;
        return true;  //wyrzucic pozniej
    }

    /**Dane okno stanie sie modalnym, tylko ono dostanie komunikaty o
     * kliknieciach myszy.
     * @return poprzednio aktywne okno*/
    UIWindow SetModal()   //   Abak -- OK
    {
        return null;
    }

    /**Ustawia wndCurrentModal na null, tzn zadne okno nie jest modalne*/
    void ClearModal()    // Abak  -  OK
    {
        
    }
    
    
    void OnKeyReleased(int nKey, char nAsci)
    {
        if(!m_bActive)
            return;
    }

    /**Jesli kursor jest w obrebie okna to zwraca true, chyba ze inne okno jest modalne.*/
    boolean IsCursorInUIWindow()
    {
        if (!CanProcessMouse()) return false;
        Vector vPos = GetPos();
        Vector vSize = GetSize();
        Vector vMousePos = GetMousePos();
        if (((vMousePos.fX >= vPos.fX)&&(vMousePos.fX <= vPos.fX + vSize.fX))
            &&((vMousePos.fZ >= vPos.fY)&&(vMousePos.fZ <= vPos.fY + vSize.fY)))
        {
            return true;
        }
        else 
        {
            return false;
        }
    }
    
    /**Ukrywa okno i odcina komunikaty myszy, klawiatury i joysticka*/
    public void Hide()
    {
        m_bVisible = false;
		
        //if (!m_bEditState && !IsAnyChildEdited())        
            ProcessMouse(false);
		
        ProcessKb(false);
        ProcessJoy(false);
        
        if(m_cEditBorder!=null  && m_bEditState)
            HideEditBorder();
		
        super.Hide();				
    }
    
    /**Pokazuje okno i przywraca stan przetwarzania myszy i 
     * klawiatury sprzed ukrycia*/
    public void Show()
    {
        m_bVisible = true;

        if (m_cEditBorder!=null && m_bEditState)
            m_cEditBorder.Show();
        if (!m_bEditState && !IsAnyChildEdited())
            ProcessMouse(m_bProcessingMouse);
        ProcessKb(m_bProcessingKb);
        ProcessJoy(m_bProcessingJoy);
        
        SetAlpha(m_fTextureAlpha);
		
        super.Show();				
    }
    
    
    
    public void ProcessMouse(boolean bProcess)
    {
        super.ProcessMouse(bProcess);
    }
    
    /**Ustawia przetwarzanie myszy i zapamietuje jego stan*/
    void SetProcessMouse(boolean bProcess)
    {
        super.ProcessMouse(bProcess);
        m_bProcessingMouse = bProcess;
    }
    
    /**Ustawia przetwarzanie klawiatury i zapamietuje jego stan*/
    void SetProcessKb(boolean bProcess)
    {
        super.ProcessKb(bProcess);
        m_bProcessingKb = bProcess;
    }
    
    /**Ustawia przetwarzanie joya i zapamietuje jego stan*/
    void SetProcessJoy(boolean bProcess)
    {
        super.ProcessJoy(bProcess);
        m_bProcessingJoy = bProcess;
    }
    
    void OnMouseEnter(float fMouseX, float fMouseY)
    {	
        if(!m_bActive)
            return;		
    }		
    
    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
    {
        if(!m_bActive)
            return;
    }
    
    void OnMouseLeave(float fMouseX,float fMouseY)
    {
        if(!m_bActive)
            return;		
    }
    
    /** Ustawienie dziecka jako ostatniego do wyswietlania */
    public void MoveTopChild(UIWindow cWndToTop)
    {
        int nInd=-1;
        UIWindow cWnd;
        int cnt = m_vChildWindows.size();
        for(int i=0;i<cnt;i++)
        {
            cWnd = (UIWindow)m_vChildWindows.elementAt(i);	 
            if(cWnd== cWndToTop)
            {
                nInd = i;
                break;
            }
        }
        if(nInd>0)
        {
            //przesuniecie  elementu w wektorze dzieci
            m_vChildWindows.removeElementAt(nInd);
            m_vChildWindows.insertElementAt(cWndToTop, 0); // na poczatku
        }
    }
    
    /** laduje teksture 	 */
    void LoadTexture(UITexture cTex)
    {
        if(cTex != null)
        {
            if(cTex.m_sFileName != null)		   
            {
                if(cTex.m_nId != 0)
                    ReleaseTexture(cTex.m_nId);

                cTex.m_nId  = AddTexture(cTex.m_sFileName , true, true);	
            }
        }
        if( m_cMaskTexture != null )
        {
            if( m_cMaskTexture.m_nId > -1 )
            {
                AddMaskTexture();
            }
        }
    }	
    
    /**zwolnienie tekstury*/
    void ReleaseTexture(UITexture cTex)
    {
        //rozpoznanie ktora to tekstura
        if(cTex == m_cNormalTexture)
        {
            m_cNormalTexture = null;  // zerowanie zwyklej tekstury
        }
        if(cTex != null)
        {
            if(cTex.m_nId !=0 )
            {
                ReleaseTexture(cTex.m_nId);
                cTex.m_nId = 0;
            }
        }
    }

    /** Zwalnianie tekstur*/
    public void ReleaseTextures()
    {
		((Sprite)this).ReleaseBackground();
        ReleaseTexture(m_cNormalTexture);
    }
    
    void Copy(UIWindow cDest, UIWindow cSrc)
    {
        if (cDest.m_sId == null)
            if (cSrc.m_sId != null)
                cDest.m_sId = new String(cSrc.m_sId);
            else
                cDest.m_sId = "UNDEFINED";
        
        cDest.SetProcessMouse(cSrc.m_bProcessingMouse);
        cDest.SetProcessKb(cSrc.m_bProcessingKb);
        cDest.SetProcessJoy(cSrc.m_bProcessingJoy);			
        cDest.m_bVisible= cSrc.m_bVisible;
        cDest.m_bPatternFileElem = cSrc.m_bPatternFileElem;
        
        if (cSrc.m_vFrameCornerSize != null)
            cDest.m_vFrameCornerSize = new Vector(cSrc.m_vFrameCornerSize);
        else
            cDest.m_vFrameCornerSize = null;
        
        if(cSrc.m_cNormalTexture !=null)
        {
            cDest.m_cNormalTexture = new UITexture(cDest);
            cDest.m_cNormalTexture.CopyTexture(cSrc.m_cNormalTexture);
            cDest.SetTexture(cDest.m_cNormalTexture);
        }
        else
            cDest.m_cNormalTexture=null;			

        cDest.SetTextureAlpha(cSrc.m_fTextureAlpha);
        //parametry edycji
        if(cSrc.m_sEditTexName!=null)
            cDest.CreateEditBorder(cSrc.m_sEditTexName);  
        if( cSrc.m_sCursorOutsideEditTex != null)
            cDest.m_sCursorOutsideEditTex = cSrc.m_sCursorOutsideEditTex;        
        if( cSrc.m_sCursorSizeTex != null)
            cDest.m_sCursorSizeTex = cSrc.m_sCursorSizeTex;
        if( cSrc.m_sCursorMoveTex != null)
            cDest.m_sCursorMoveTex = cSrc.m_sCursorMoveTex;			
        cDest.m_fEditBorderWidth = cSrc.m_fEditBorderWidth;
        cDest.m_fEditBorderSens = cSrc.m_fEditBorderSens;		

        
        cDest.m_vLogicPos= new Vector(cSrc.m_vLogicPos);
        cDest.m_vLogicSize= new Vector(cSrc.m_vLogicSize);
        cDest.m_bParentPositionig = cSrc.m_bParentPositionig;	
        cDest.m_bParentCenteringX = cSrc.m_bParentCenteringX;
        cDest.m_bParentCenteringY = cSrc.m_bParentCenteringY;		          
        cDest.m_bParentSizingX = cSrc.m_bParentSizingX;
        cDest.m_bParentSizingY = cSrc.m_bParentSizingY;
        // kopiowanie dzieci
        int cnt = cSrc.m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow cSrcChild = (UIWindow)(cSrc.m_vChildWindows).elementAt(i);	   
            UIWindow cWndNew = (UIWindow)CreateObject(cSrcChild.m_sClassName);
            cWndNew.m_sClassName = cSrcChild.m_sClassName;
            cWndNew.m_sId = cSrcChild.m_sId;//+"_copy";
            cSrcChild.Copy(cWndNew,cSrcChild);
            cDest.AddChild(cWndNew);		  
        }
    }
    
    /** Tworzy ramke edycji     */	
    void CreateEditBorder(String sEditTexFileName)
    {
        if(m_cEditBorder!=null && m_sEditTexName.equals(sEditTexFileName) || 
           !UserInterface.s_bInEditor)
            return;
        if(m_cEditBorder!=null)
            DestroyEditBorder();

        if(sEditTexFileName!=null)
        {
            //BlockGameRendering();
            m_cEditBorder = (Sprite)CreateObject("Sprite");
            m_cEditBorder.SetName("EDITBORDER_FOR_" + m_sId);
            m_nEditTexture = m_cEditBorder.AddTexture(sEditTexFileName, true, true);
			m_cEditBorder.SetAlpha(0.5f);
            m_sEditTexName = sEditTexFileName;
            //UnblockGameRendering();
        } 
    }
    
    void InitBorder()
    {
        if(m_bInitBorder)
            return;
        else		
            m_bInitBorder=true;
        if(m_wndParent!=null)
        {
            ((Sprite)m_wndParent).AddChild(m_cEditBorder);
        }
        else
        {
            if(GetModule() != null)
            {
                GetModule().AddSprite(m_cEditBorder);
            }
        }
        m_cEditBorder.Hide();		
    }

    void ShowEditBorder()
    {
        if ((m_bInitBorder) && (m_cEditBorder != null))
        {
            m_cEditBorder.Show();
        }
    }
    
    void HideEditBorder()
    {
        if ((m_bInitBorder) && (m_cEditBorder != null))
            m_cEditBorder.Hide();		
    }
    
    void DisplayEditBorder()
    {
        if(m_cEditBorder!=null && m_nEditTexture!=EUIConst.NO_DEFINED)
        {
            if(!m_bInitBorder)
                InitBorder();
            m_cEditBorder.SetTexture(m_nEditTexture, new Rect (0,0,1,1));
            // ustawienie pozycji i rozmiaru o grubosc ramki
            // wiekszego od okna
            Vector vWndPos = ((Sprite)this).GetPos();
            Vector vWndSize = ((Sprite)this).GetSize();
            Vector vBorderPos = new Vector(vWndPos.fX-m_fEditBorderWidth,
                                           vWndPos.fY-m_fEditBorderWidth, 0 );
            Vector vBorderSize = new Vector(vWndSize.fX+m_fEditBorderWidth*2,
                                            vWndSize.fY+m_fEditBorderWidth*2, 0 );
            
            m_cEditBorder.SetPos(vBorderPos);
            m_cEditBorder.SetSize(vBorderSize);
            m_cEditBorder.Show();
        }
    }
    
    void DestroyEditBorder()
    {
        if(m_cEditBorder==null)
            return;
        if(m_nEditTexture!=EUIConst.NO_DEFINED)
        {
            m_cEditBorder.ReleaseTexture(m_nEditTexture);
            m_nEditTexture=EUIConst.NO_DEFINED;
        }
        m_cEditBorder.DetachFromParent();	   
        m_cEditBorder.delete();
        m_cEditBorder = null;
    }
    
    public void SetEditState()
    {
        LogLine("SetEditState");
        //STATEif(CurrentState!=null)
            //STATEm_cOldStateName = CurrentState.getClass().getName();
        SetState("EditState");
    }
    
    boolean IsEditState()
    {
        return m_bEditState;	
    }
    
    void ExitEditState()
    {
        /*if(m_cOldStateName!=null)  
        { 
            LogLine("ExitEditState.m_cOldStateName " + m_cOldStateName);
            SetState(m_cOldStateName);	
            m_cOldStateName = null;
            return;
        }*/
        SetState("NoEditState");
    }
    
    /** zaznaczenie ze dane okna zostaly zmienione     */
    void MarkDataUpdated()
    {
        m_bWasDataUpdate = true;		
    }
    
    void DismissDataUpdate()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.DismissDataUpdate();
        }		
        m_bWasDataUpdate = false;		
    }
    
    /** test czy dane okna zostaly zmienione */
    boolean AreDataUpdated()
    {
        if(m_bWasDataUpdate)
            return true;
        //jesli nie
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            if(wnd.AreDataUpdated())
                return true;
        }
        return false;
    }
    
    void EditUpdated()
    {
        if(m_bEditState)
            if(IsVisible())
                DisplayEditBorder();		  
    }
    
    public class EditState extends State
    {
        /** znacznik przechwycenia faktu wejscia kursora  do srodkowej strefy 	   */
        boolean bIsInnerFlag = false;
        
        /** znacznik wcisniecia klawisza myszy  */ 
        boolean bLBDown = false;
        boolean bKeyProcessingOnEnter = false;
        
        
        
        public void OnEnter()
        {
            LogR("[EditState.OnEnter]\n");
            
            bKeyProcessingOnEnter = IsRegisteredKeyRequest();
            RegisterKeyRequest();
            
            m_bEditState = true;
            EditUpdated();
            ShowEditBorder();
            SetEditMouseProcess();

            //deaktywuje wsyzstkie dzieci
            UIWindow wnd = null;			
            int nSize = m_vChildWindows.size();
			
            for (int i = 0; i < nSize; i++)
            {
                wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
                wnd.SetActive(false);
            }			
            
            // zmiana kursora jesli jest w srodku
            if (m_currCursor!=null)
            {
                m_currCursor.InitToolTip(GetModule(), "data/interface/er_t_blue.png", new Rect(0,0,1,1), Fonts.FONT_MSSANSSERIF_12, 0.5f,0.5f,0.5f,1);
                m_currCursor.DisplayToolTip("");
				
                if (m_sCursorTex==null)
                    m_currCursor.Show();
				
                if (HitTest(m_currCursor.GetPos()))
                {
                    if (IsCursorInner())
                        m_sEditCursorTex = m_sCursorMoveTex;
                    else
                        m_sEditCursorTex = m_sCursorSizeTex;
                }
                else
                    m_sEditCursorTex = m_sCursorOutsideEditTex;
                
                SetCursor(m_sEditCursorTex);
            }
        }
        
        void OnMouseEnter(float fMouseX, float fMouseY)
        {	
            m_sEditCursorTex = m_sCursorSizeTex;
            SetCursor(m_sEditCursorTex);
            m_nEditMode = EUIConst.EDIT_RESIZE;
            bIsInnerFlag = false;		  
        }

        void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
        {
            boolean bIsInner = IsCursorInner();
            if(!bLBDown)
            {
                if( bIsInner && !bIsInnerFlag)
                {
                    m_sEditCursorTex = m_sCursorMoveTex;
                    SetCursor(m_sEditCursorTex);
                    bIsInnerFlag = true;
                    
                    m_nEditMode = EUIConst.EDIT_MOVE;
                }
                if(!bIsInner && bIsInnerFlag)		
                {
                    m_sEditCursorTex= m_sCursorSizeTex;
                    SetCursor(m_sEditCursorTex);
                    bIsInnerFlag = false;
                    
                    m_nEditMode = EUIConst.EDIT_RESIZE;			   
                }
            }
        }
        
        void OnMouseLeave(float fMouseX,float fMouseY)	  
        {
            if(m_currCursor==null)
                return;
            //SetCursor(m_sEditCursorTex);
            SetCursor(m_sCursorOutsideEditTex);
            bIsInnerFlag = false;
            m_nEditMode = EUIConst.EDIT_NONE;		  
            bLBDown=false;		 
        }
        
        void OnLBDown(float fMouseX, float fMouseY)
        {
            bLBDown = true;
            
            if(m_nEditMode == EUIConst.EDIT_RESIZE)
                SetState("EditResizeState");
            if(m_nEditMode == EUIConst.EDIT_MOVE)
                SetState("EditMoveState");

        }
        void OnLBUp(float fMouseX, float fMouseY)
        {
            bLBDown = false;		 
        }	  
        
        /** sprawdza czy kursor jest wewnatrz okna, przez co powinien byc tryb przenoszenia    */
        boolean IsCursorInner()
        {
            Vector vCursorPos = m_currCursor.GetPos();  
            Vector vWndPos =  GetPos();
            Vector vWndSize = GetSize();
            
            float fInnerTop = vWndPos.fY + m_fEditBorderSens  ,
                fInnerBottom = vWndPos.fY + vWndSize.fY - m_fEditBorderSens,  
                fInnerLeft = vWndPos.fX + m_fEditBorderSens ,
                fInnerRight = vWndPos.fX + vWndSize.fX - m_fEditBorderSens; 
            
            m_nResizeEdge = -1;
            if(vCursorPos.fY < fInnerTop  )             // ktora krawedz najblizej
                m_nResizeEdge = EUIConst.RESIZE_UP;
            else
                if(vCursorPos.fY > fInnerBottom)
                    m_nResizeEdge = EUIConst.RESIZE_BOTTOM;			
                else
                    if(vCursorPos.fX < fInnerLeft)
                        m_nResizeEdge = EUIConst.RESIZE_LEFT;
                    else
                        if(vCursorPos.fX > fInnerRight)
                            m_nResizeEdge = EUIConst.RESIZE_RIGHT;			
            
            return ( vCursorPos.fY > fInnerTop && vCursorPos.fY < fInnerBottom &&
                     vCursorPos.fX > fInnerLeft && vCursorPos.fX < fInnerRight);
        }		
        boolean bResize = false;
        
        int _nKeyCode;
        boolean _bKeyState;
        char _nKeyAscii;
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            Vector vSize = GetSize();
            Vector vPos = GetPos();
            
            if (bKeyState)
            {
                boolean bRatio = false;
                int nStep = 1;
                if (GetKeyState(EKey._LSHIFT))
                    nStep = 5;
                if (GetKeyState(EKey._LCONTROL))
                    bRatio = true;
                switch (nKeyCode)
                {
                    
                case EKey._UP:
                    vSize.fY -= nStep;
                    vPos.fY -= nStep;
                    if (bRatio)
                        vSize.fX -= nStep;
                    break;
                case EKey._DOWN:
                    vSize.fY += nStep;
                    vPos.fY += nStep;
                    if (bRatio)
                        vSize.fX += nStep;
                    break;
                case EKey._LEFT:
                    vSize.fX -= nStep;
                    vPos.fX -= nStep;
                    if (bRatio)
                        vSize.fY -= nStep;
                    break;
                case EKey._RIGHT:
                    vSize.fX += nStep;
                    vPos.fX += nStep;
                    if (bRatio)
                        vSize.fY += nStep;
                    break;
                case EKey._SPACE:
                    bResize = !bResize;
                    break;
                    
                }
                
                if (bResize)
                {
                    if (vSize.fX > 0 && vSize.fY > 0)
                        SetSize(vSize);
                }
                else
                {
                    SetPos(vPos);
                }
                
                
                ConfirmEdit();
                DisplayEditBorder();
                if (bResize)
                    m_currCursor.DisplayToolTip("[RESIZE] S:(" + (int)GetSize().fX + "," + (int)GetSize().fY + ") P:("+ (int)GetPos().fX +"," + (int)GetPos().fY + ")");  
                else
                    m_currCursor.DisplayToolTip("[MOVE] S:(" + (int)GetSize().fX + "," + (int)GetSize().fY + ") P:("+ (int)GetPos().fX +"," + (int)GetPos().fY + ")");  
                
                _nKeyCode = nKeyCode;
                _bKeyState = bKeyState;
                _nKeyAscii = nKeyAscii;
                if (nKeyCode != EKey._SPACE)
                    CallMethodIn("_OnInputKey", 0.1f);
            }
            else
            {
                DisableCallMethod("_OnInputKey");
            }
        }   
        
        void _OnInputKey()
        {
            OnInputKey(_nKeyCode, _bKeyState, _nKeyAscii);
        }
    }
    
    public class EditResizeState extends State
    {
        Vector vSizeOnEnter = null,vMousePosOnEnter = null, vPosOnEnter = null;
        
        public void OnEnter()
        {
            vSizeOnEnter = GetSize();
            vPosOnEnter = GetPos();
            vMousePosOnEnter = m_currCursor.GetPos();
            m_currCursor.DisplayToolTip("S:(" + (int)vSizeOnEnter.fX + "," + (int)vSizeOnEnter.fY + ") P:("+ (int)vPosOnEnter.fX +"," + (int)vPosOnEnter.fY + ")");  
        }
        
        void OnLBDown(float fMouseX, float fMouseY)
        {
            //            LogLine("OnLBDOWN");
            SetEditState();
        }
        void OnLBUp(float fMouseX, float fMouseY)
        {
            ConfirmEdit();
            //            LogLine("OnLBUp");
            // zeby ustalil kursor dopiero po zaktualizowaniu pozycji
            CallMethodIn("SetEditState",0); 
        }
        void OnLBDownOut(float fMouseX, float fMouseY)
        {
            //            LogLine("OnLBDOWN_out");
            SetEditState();
        }
        void OnLBUpOut(float fMouseX, float fMouseY)
        {
            ConfirmEdit();
            //            LogLine("OnLBUp_out");            
            CallMethodIn("SetEditState",0);
        }
        void OnMouseEnter(float fMouseX, float fMouseY)
        {	
            
        }

        void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
        {
            float fMouseDiffX = vMousePosOnEnter.fX - fMouseX ;
            float fMouseDiffY = vMousePosOnEnter.fY - fMouseY ;		  
            
            float fNewSizeX = vSizeOnEnter.fX;
            float fNewSizeY = vSizeOnEnter.fY;		  
            float fPosDeltaX = 0, fPosDeltaY = 0;
            
            switch(m_nResizeEdge)
            {
            case EUIConst.RESIZE_UP:
                fNewSizeY += fMouseDiffY;
                fPosDeltaY -= fMouseDiffY;
                break;
            case EUIConst.RESIZE_BOTTOM:
                fNewSizeY -= fMouseDiffY;
                break;
            case EUIConst.RESIZE_LEFT:
                fNewSizeX += fMouseDiffX;			   
                fPosDeltaX -= fMouseDiffX;
                break;
            case EUIConst.RESIZE_RIGHT:
                fNewSizeX -= fMouseDiffX;
                break;			  
            }
            SetSize(new Vector(fNewSizeX, fNewSizeY,0));
            SetPos(new Vector(vPosOnEnter.fX + fPosDeltaX, vPosOnEnter.fY + fPosDeltaY, 0));
            m_currCursor.DisplayToolTip("S:(" + (int)GetSize().fX + "," + (int)GetSize().fY + ") P:("+ (int)GetPos().fX +"," + (int)GetPos().fY + ")");  
            DisplayEditBorder();
        }
        
        void OnMouseMoveOut(float fMouseX, float fMouseY, int iButtonsFlags)
        {
            OnMouseMove(fMouseX, fMouseY, iButtonsFlags);
        }
        
        void OnMouseLeave(float fMouseX,float fMouseY)	  
        {
            
        }
        
            
    }
    
    public class EditMoveState extends State
    {
        Vector vMousePosOnEnter = null, vPosOnEnter = null;
        public void OnEnter()
        {
            vPosOnEnter = GetPos();
            vMousePosOnEnter = m_currCursor.GetPos();
            m_currCursor.DisplayToolTip("S:(" + (int)GetSize().fX + "," + (int)GetSize().fY + ") P:("+ (int)GetPos().fX +"," + (int)GetPos().fY + ")");  
        }
        
        void OnLBDown(float fMouseX, float fMouseY)
        {
            SetState("EditState");
        }
        void OnLBUp(float fMouseX, float fMouseY)
        {
            ConfirmEdit();
            CallMethodIn("SetEditState",0);
            
        }
        void OnLBDownOut(float fMouseX, float fMouseY)
        {
            SetEditState();
            
        }
        void OnLBUpOut(float fMouseX, float fMouseY)
        {
            ConfirmEdit();
            CallMethodIn("SetEditState",0);
        }
        void OnMouseEnter(float fMouseX, float fMouseY)
        {	
            
        }

        void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
        {
            float fMouseDiffX = vMousePosOnEnter.fX - fMouseX ;
            float fMouseDiffY = vMousePosOnEnter.fY - fMouseY ;		  
            
            SetPos(new Vector(vPosOnEnter.fX - fMouseDiffX, vPosOnEnter.fY - fMouseDiffY, 0));
            m_currCursor.DisplayToolTip("S:(" + (int)GetSize().fX + "," + (int)GetSize().fY + ") P:("+ (int)GetPos().fX +"," + (int)GetPos().fY + ")");  
            DisplayEditBorder();
        }
        
        void OnMouseMoveOut(float fMouseX, float fMouseY, int iButtonsFlags)
        {
            OnMouseMove(fMouseX, fMouseY, iButtonsFlags);
        }
        
        void OnMouseLeave(float fMouseX,float fMouseY)	  
        {
            
        }
        
        
    }
    
    /** stan po wyjsciu ze stanu edycji*/
    public class NoEditState extends State 
    {
        public void OnEnter()
        {
            LogR("[NoEditState.OnEnter] \n");
			
            //aktywuje wszystkie dzieci
            UIWindow wnd = null;
			
            int nSize = m_vChildWindows.size();
			
            for(int i = 0; i < nSize; i++)
            {
                wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
                wnd.SetActive(true);
                
            }			
			
            if (m_currCursor!=null)
            {
                if (HitTest(m_currCursor.GetPos()))
                {
                    // What's that ????????????
                }
				
                if (m_sEditCursorTex!=null)
                    m_sEditCursorTex=null;

                if (m_sCursorTex!=null)
                    SetCursor(m_sCursorTex);	
                else
                {
                    m_currCursor.ClearTexture();
                    m_currCursor.Hide();            
                }
            }
            
            m_bEditState = false;
			
            if (m_currCursor != null)
                m_currCursor.DisplayToolTip("");
            HideEditBorder();
        }
    }	
    
    /** zatwierdza nowy rozmiar i pozycje aktualizujac je jako zmienne logiczne, wolane
     * po edycji*/
    void ConfirmEdit()
    {
        if(m_bParentPositionig)
            UpdateParentPos();		  
        
        float fX=0.0f, fY=0.0f, fZ=0.0f;
        
        if(m_bParentCenteringX)
            fX = GetRealX();
        else
            fX = GetPos().fX;

        if(m_bParentCenteringY)
            fY = GetRealY();
        else
            fY = GetPos().fY;            
        
        fZ = GetPos().fZ;
        SetRealPos(new Vector(fX, fY, fZ)); 
        
        SetRealSize(GetSize());
        ReloadSizeAndPos();
        MarkDataUpdated();
    }
    
    void ConfirmSizeAndPos()
    {
        if(m_bParentPositionig)
            UpdateParentPos();		  
        
        float fX=0.0f, fY=0.0f, fZ=0.0f;
        
        if(m_bParentCenteringX)
            fX = GetRealX();
        else
            fX = GetPos().fX;

        if(m_bParentCenteringY)
            fY = GetRealY();
        else
            fY = GetPos().fY;            
        
        fZ = GetPos().fZ;
        
        SetRealPos(new Vector(fX, fY, fZ)); 
        
        SetRealSize(GetSize());
    }
    
    public String toString()
    {
        if (m_sId != null)
            return new String(m_sId) + " [" + super.toString() + "]";	
        else
            return "<noname> [" + super.toString() + "]";	
    }
    
    
    public void SetNoTexture()
    {
        m_cCurTexture = null;
        super.SetNoTexture();
    }
    
    /**Gdy nie uda sie ustawienie tekstury, to probujemy ja jeszcze raz zaladowac, ta zmienna
     * uchroni nas przed zapetleniem*/
    boolean m_bReloadingTexture = false;

    void SetNormalTexture(UITexture cTexture)
    {
        if (cTexture == m_cCurTexture)
            return;
        ReleaseTexture(m_cCurTexture);
        if (cTexture.m_nId == 0)
            LoadTexture(cTexture);
        SetTexture(cTexture);
        m_cNormalTexture = cTexture;
    }
    
    void ReleaseNormalTexture()
    {
        if (m_cCurTexture == m_cNormalTexture)
            SetNoTexture();
        ReleaseTexture(m_cNormalTexture);
        
    }
    
    void SetTexture(UITexture cTexture)
    {
        m_cCurTexture = cTexture;
        if(cTexture!=null)
        {
            if(cTexture.m_nId != 0)	
            {
                Rect cRect = cTexture.GetLogicRect();
                if (cRect == null)
                {
                    cRect = new Rect(0,0,1,1);
                }

                if (m_vFrameCornerSize != null && (m_vFrameCornerSize.fX != 0 || m_vFrameCornerSize.fY != 0))
                {
                    //jesli sie nie uda, probujemy zaladowac teksture od nowa
                    if (!SetFrameTexture(cTexture.m_nId, cRect, (int)m_vFrameCornerSize.fX, (int)m_vFrameCornerSize.fY) && !m_bReloadingTexture)
                    {
                        Tools.CrashLogError("Unable to set texture " + cTexture.m_sFileName + " [id " + cTexture.m_nId + "], reloading...");
                        
                        m_bReloadingTexture = true;
                        LoadTexture(cTexture);
                        SetTexture(cTexture);
                        return;
                    }
                }
                else
                {
                    //LogR("Setting nonframetex " + this);
                    //jesli sie nie uda, probujemy zaladowac teksture od nowa
                    if (!SetTexture(cTexture.m_nId, cRect) && !m_bReloadingTexture)
                    {
                        Tools.CrashLogError("Unable to set texture " + cTexture.m_sFileName + " [id " + cTexture.m_nId + "], reloading...");
                        
                        m_bReloadingTexture = true;
                        LoadTexture(cTexture);
                        SetTexture(cTexture);
                        return;
                    }
                }
                
            }
            else
                LogLine("UIWindow: SetTexture: id==0");

            m_bReloadingTexture = false;

        }
        else//brak tekstury
        {
            SetNoTexture();
        }
    }
    
    /*public boolean SetTexture(int texNum, Rect coords)
    {
        LogR("Setting texture " + this);
        return super.SetTexture(texNum, coords);
    }

    int nPrevTex = -1, cW = -1, cH = -1;
    Rect cRect = new Rect();*/
    
    public boolean SetFrameTexture( int texNum, Rect texRect, int cornerWidth, int cornerHeight )
    {
        /*LogR("Setting frame texture " + this);
        if (texNum == nPrevTex &&
            cW == cornerWidth &&
            cH == cornerHeight &&
            texRect.fBottom == cRect.fBottom &&
            texRect.fLeft  == cRect.fLeft &&
            texRect.fRight == cRect.fRight &&
            texRect.fTop  == cRect.fTop)
        {
            return true;
        }
        else
        {
            nPrevTex = texNum;
            cW = cornerWidth;
            cH = cornerHeight;
            texRect.fBottom = cRect.fBottom;
            texRect.fLeft  = cRect.fLeft;
            texRect.fRight = cRect.fRight;
            texRect.fTop  = cRect.fTop;*/
            //Thread.dumpStack();
            return super.SetFrameTexture( texNum, texRect, cornerWidth, cornerHeight );
        //}
    }
    
    
    public void SetPos(Vector vPos)
    {
        SetRealPos(vPos);
    }

    
    public void MoveTop()
    {
        super.MoveTop();
        if (m_currCursor != null)
            m_currCursor.MoveTop();
    }
    
    /**Przesuwa na wierzch dane okno, a potem wszystkie jego dzieci*/
    public void MoveTopWithChildren()
    {
        MoveTop();
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.MoveTopWithChildren();
        }
    }
    
    void SetVisible(boolean bVisible)
    {
        m_bVisible = bVisible;
        if (bVisible)
        {
            if(!IsAPattern())
                Show();
        }
        else
        {
            Hide();
        }
    }
    
    /**Odswieza zapamietane dane o logicznym polozeniu i rozmiarze okna na podstawie
     * pozycji i rozmiaru rzeczywistego*/
    void UpdateLogicSizeAndPos(Vector vRealSize, Vector vRealPos)
    {
        UpdateParentPos();
        
        if (!m_bParentSizingX)
            m_vLogicSize.fX = vRealSize.fX / m_fDimX; 
        else
            m_vLogicSize.fX = vRealSize.fX / m_vParentSize.fX;
        if (!m_bParentSizingY)
            m_vLogicSize.fY = vRealSize.fY / m_fDimY;
        else
            m_vLogicSize.fY = vRealSize.fY / m_vParentSize.fY;
        
        if(m_bParentPositionig)
        {
            float fFromParentBeginX = vRealPos.fX - m_vParentPos.fX;
            float fFromParentBeginY = vRealPos.fY - m_vParentPos.fY;		   
            
            m_vLogicPos.fX = fFromParentBeginX / m_vParentSize.fX;
            m_vLogicPos.fY = fFromParentBeginY / m_vParentSize.fY;			
        }
        else
        {
            m_vLogicPos.fX = vRealPos.fX / m_fDimX;
            m_vLogicPos.fY = vRealPos.fY /	m_fDimY;
        }
    }
    
    void ShowEditParams()
    {
        CrashLog("\n "+" Wnd: "+this+ "\n "+
                 " -- " + this + " m_fEditBorderWidth " + m_fEditBorderWidth+ "\n " + " -- " + this + " m_fEditBorderSens " + m_fEditBorderSens+ "\n " + 
                 " -- " + this + " m_sCursorSizeTex " + m_sCursorSizeTex+ "\n " + 
                 " -- " + this + " m_sCursorMoveTex " + m_sCursorMoveTex+ "\n " + 
                 " -- " + this + " m_sEditTexName " + m_sEditTexName+ "\n " + 
                 " -- " + this + " m_nEditTexture " + m_nEditTexture+ "\n " + 
                 " -- " + this + " m_cEditBorder "+m_cEditBorder+ "\n ");

        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.ShowEditParams();
        }
    }
    
    
    boolean IsAnyChildEdited()
    {
        if(m_bEditState)
            return true;
        
        UIWindow wnd;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            if(wnd.IsAnyChildEdited())
                return true;
        }        
        return false;
    }
    
    void SetCursorForMembers(String sCurTex)
    {
        UIWindow wnd;
        m_sCursorTex = sCurTex;
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.SetCursorForMembers(sCurTex);
        }        
    }
    
    public String GetPosString()
    {
        return GetPos().toString();
    }
    
    public String GetSizeString()
    {
        return GetSize().toString();
    }
    
    void UpdateGSObjectName()
    {
        if (m_sId != null)
            SetName(m_sId);
    }
    /** ustawia przetwarzanie myszy dla edycji w oknie oraz w rodzicu (-ach)    */
    void SetEditMouseProcess()
    {
        /*       if(m_bProcessingMouse)
        m_bMouseProcBeforeEdit = true;*/
        
        if(m_wndParent!=null)
            m_wndParent.SetEditMouseProcess();
        ProcessMouse(true);        

        //PrcessMouse();

    }    
    ///////////////////////////////////////////////////////////////
    ///////////////////////////// MASKI ///////////////////////////
    ///////////////////////////////////////////////////////////////
    
    
    ////////////////////////////////////////////////////////////////
    ///////////////////////// KONIEC MASEK /////////////////////////
    ////////////////////////////////////////////////////////////////
    
    //-------------------------------------------------------------------
    //pt:.----------------  EFEKTY  Effect ------------------------------
//    boolean m_test_ef = false; 
    public void UpdateEffect()
    {
        float fTimeDiff = GetTime() - m_fLastEffectTime;
/*        if(m_test_ef)
            Tools.ShowInfo(" > "+" was last ", GetModule(),Tools._INFO_POS_TOP);        
        else
            Tools.ShowInfo(" > "+" . ", GetModule(),Tools._INFO_POS_TOP);        */
//        if(this instanceof UIFlyText)
            //LogLine(" update: "+fTimeDiff+" get time "+GetTime()+" m_fLastEffectTime "+m_fLastEffectTime);
        if(fTimeDiff < m_fEffectGrain)  // zeby nie za czesto
            return;
        if(m_bEffectPos)
        {
            OnEffectPos(fTimeDiff);
            CheckEffectPos();
        }
        if(m_bEffectSize)
        {
            OnEffectSize(fTimeDiff);
            CheckEffectSize();
        }
        if(m_bEffectAlpha)
        {
            LogLine(" Update Effect Alpha ");
            OnEffectAlpha(fTimeDiff);
            CheckEffectAlpha();
        }
        if(m_bEffectAngle)
        {
            OnEffectAngle(fTimeDiff);
            if( !m_bContinuous )
                CheckEffectAngle();
        }       
        m_fLastEffectTime = GetTime();             
    }
    
    /** docelowa pozycja  okna Effect    */
    void SetEffectDestPos(Vector vEffectDestPos, float fTime)
    {
        SetEffectDestPos( vEffectDestPos, fTime, false );
        /*
        LogLine(" SetEffectDestPos() ");
        m_vEffectDestPos = new Vector(vEffectDestPos);  
        m_bEffectPos = true;
        m_bEffectFirstPos = true;        
        m_fEffectPosTime = fTime;
        m_vEffectPosDiff = new Vector(vEffectDestPos);
        m_vEffectPosDiff.Sub(GetLogicPos());        
        m_fEffectPosSpeed = m_vEffectPosDiff.Len() / fTime;
        m_vEffectPosDiff.Normalize();
        OnEffectPosStart();        
        */
    }
    /** docelowa pozycja  okna Effect    */
    void SetEffectDestPos(Vector vEffectDestPos, float fTime, boolean bMask)
    {
        SetEffectDestPos( GetLogicPos(), vEffectDestPos, fTime, 0.0f, bMask );
    }
    
    void SetEffectDestPos(Vector cDestPos, float fTime, float fPauseTime, boolean bMask)
    {
        SetEffectDestPos(GetLogicPos(), cDestPos, fTime, fPauseTime, bMask);
    }
    void SetEffectDestPos(Vector cStartPos, Vector cDestPos, float fTime, float fPauseTime)
    {
        SetEffectDestPos(GetLogicPos(), cDestPos, fTime, fPauseTime, false);
    }
    Vector temp3 = new Vector();
    void SetEffectDestPos(Vector cStartPos, Vector cDestPos, float fTime, float fPauseTime, boolean bMask)
    {
        if( m_cMaskTexture != null )
        {
            m_bDoNotMoveMask = ( m_cMaskTexture.m_nId > -1 ) ;//&& bMask;
            m_vMaskMovePos = new Vector();
        }
        
        
        if(fPauseTime > 0.0f)
        {
            //sm_fPauseEffectTime = fPauseTime;
            //sm_bPauseEffect = true;
            //sm_bPauseEffectFirstUpdate = true;
            //sOnPauseEffectStart();
        }
        
        if( m_vEffectStartPos == null || !m_bEffectPos )
        {
            m_vEffectStartPos = new Vector(cStartPos);  //ustalenie pozycji startowej
        }
        else
        {
            temp3 = new Vector( m_vEffectStartPos );
            m_vEffectStartPos = new Vector(m_vEffectDestPos);
    }

        if( m_vEffectDestPos == null || !m_bEffectPos )
        {
            m_vEffectDestPos = new Vector(cDestPos);    //ustalenie pozycji docelowej
        }
        else
        {
            m_vEffectDestPos = new Vector(temp3);
        }
        
        m_vEffectPosDiff = new Vector(m_vEffectDestPos);   //obliczenie roznicy pomiedzy poczatkiem
        m_vEffectPosDiff.Sub(m_vEffectStartPos);             //a koncem
        m_fEffectPosSpeed = m_vEffectPosDiff.Len() / fTime; //obliczenie predkosci przesuwania efektu
        m_vEffectPosDiff.Normalize();                       //normalizacja wektora
        
        m_fPosEffectLastDiff = m_vEffectStartPos.Distance(m_vEffectDestPos);
        
        m_vPosEffectOut = new Vector(m_vEffectStartPos);
        
        m_bEffectPos = true;
        m_bEffectFirstPos = true;
        OnEffectPosStart();             //wywolanie handlera
        
        //m_vEffectStartPos = new Vector( GetLogicPos() );
        
        SetLogicPos(cStartPos);
        OnSizeAndPos();
    }
    
    /** powrot elementu do pozycji z ktorej 'przybyl' */
    void SetEffectPosOut(float fTime)
    {
        SetEffectPosOut(fTime, false);
    }
    /** powrot elementu do pozycji z ktorej 'przybyl' */
    void SetEffectPosOut(float fTime, float fPauseTime)
    {
        SetEffectPosOut(fTime, fPauseTime, false);
    }
    /** powrot elementu do pozycji z ktorej 'przybyl' */
    void SetEffectPosOut(float fTime, boolean bMask)
    {
        SetEffectPosOut(fTime, 0.0f, bMask);
    }
    /** powrot elementu do pozycji z ktorej 'przybyl' */
    void SetEffectPosOut(float fTime, float fPauseTime, boolean bMask)
    {
        if(m_vPosEffectOut == null)
            return;
        
        SetEffectDestPos(GetLogicPos(), m_vPosEffectOut, fTime, fPauseTime, bMask);
    }



    /** docelowy rozmiar  okna Effect    */    
    void SetEffectDestSize(Vector vEffectDestSize, float fTime, int nReferPoint)            
    {
        SetEffectDestSize(vEffectDestSize, fTime,nReferPoint, true);
    }
    void SetEffectDestSize(Vector vEffectDestSize, float fTime, int nReferPoint, boolean bKeepPos)    
    {
//        m_test_ef = false;
        m_vEffectDestSize = new Vector(vEffectDestSize);          
        m_bEffectSize = true;        
        m_bEffectFirstSize = true;                
        m_fEffectSizeTime = fTime;        
        m_vEffectSizeDiff = new Vector(vEffectDestSize);
        m_vEffectSizeDiff.Sub(GetLogicSize());        
        m_fEffectSizeSpeed = m_vEffectSizeDiff.Len() / fTime;
        m_vEffectSizeDiff.Normalize();
        m_nReferPoint = nReferPoint;
        
        // jesli po rozwinieciu ma zachowac pozycje
        if(bKeepPos)
        {
            Vector vOldSize = GetRealSize();  // aktualny rozmiar
            SetLogicSize(new Vector(vEffectDestSize));
            FittPosToSize(vOldSize, true); // ustalenie pozycji by po rozwinieciu okno bylo w tym samym miejscu
            SetRealSize(vOldSize);
        }
        OnEffectSizeStart();                
    }
    /** docelowa alpha     */
    void SetEffectDestAlpha(float fEffectDestAlpha, float fTime)    
    {
        m_fEffectDestAlpha = fEffectDestAlpha;         
        m_bEffectAlpha = true;                
        m_bEffectFirstAlpha = true;                
        m_fEffectAlphaTime = fTime;                
        float fDiff = fEffectDestAlpha - m_fTextureAlpha;
        m_fEffectAlphaSpeed = fDiff / fTime;       
        OnEffectAlphaStart();                
    }
    
    /** docelowy kat     */
    boolean m_bRotateRightLeft = false;
    /** w ktora strone obracac maske */
    boolean m_bMaskDirection = false; //false - lewo, true - prawo
    
    void SetEffectDestAngle(float fEffectDestAngle, float fTime, boolean bContinuous)
    {
        SetEffectDestAngle(fEffectDestAngle, fTime, bContinuous, false, false );
    }
    
    void SetEffectDestAngle(float fEffectDestAngle, float fTime, boolean bContinuous, boolean bMask, boolean bMaskDir)
    {
        float fCurrRot = GetRotation();
        //jezeli mamy zaladowana maske i chcemy zeby 'stala' w miejscu przy
        //obrocie sprite'a
        if( m_cMaskTexture != null )
        {
            m_bDoNotRotateMask = ( m_cMaskTexture.m_nId > -1 ) && bMask;
        }
        
        m_bMaskDirection = bMaskDir;
        
        if(fCurrRot < 0)
        {
            if( fEffectDestAngle < 0 && fEffectDestAngle < fCurrRot )
            {
                m_bRotateRightLeft = false;
            }
            else
            {
                m_bRotateRightLeft = true;
            }
        }
        else if(fCurrRot >= 0)
        {
            if( fEffectDestAngle > 0 && fEffectDestAngle > fCurrRot )
            {
                m_bRotateRightLeft = true;
            }
            else
            {
                m_bRotateRightLeft = false;
            }
        }
       
        m_bContinuous = bContinuous;
        m_fEffectDestAngle = fEffectDestAngle;// % 360;         
        m_bEffectAngle = true;                
        m_bEffectFirstAngle = true;                
        m_fEffectAngleTime = fTime;                      
        float fDiff = fEffectDestAngle - GetRotation();  
        if (fTime > 0)
        {
            m_fEffectAngleSpeed = fDiff / fTime;        
            OnEffectAngleStart();        
        }
        else
        {
            
        }
    }
    
    /** sprawdzanie warunkow konca efektow     */
    void CheckEffectPos()
    {
        if(m_bEffectFirstPos)
        {
            m_bEffectFirstPos = false;
            return;
        }
        
        float fDiff = m_vEffectDestPos.Distance(GetLogicPos());        
        if(fDiff > m_fPosEffectLastDiff)
        {
            SetLogicPos(m_vEffectDestPos);
            if( m_bDoNotMoveMask )
            {
                if( m_bMaskOut )
                {
                    SetMaskLogicPos( 1f , 1f );
                    m_bMaskOut = false;
                }
                else
                {
                    SetMaskLogicPos( 0f , 0f );
                    m_bMaskOut = true;
                }
            }
            OnSizeAndPos();
            OnEffectPosEnd();
            m_bEffectPos = false;
            if(!m_bEffectSize)
            {
                if(m_bChildToEffectShow) // pokazanie dzieci
                {
                    m_bChildToEffectShow = false;
                    ShowEffectChilds();                
                }
                else
                    ShowChilds();
            }
        }
        m_fPosEffectLastDiff = fDiff;

        /*
        if(fDiff<m_fEffectPosTolerance)
        {
            SetLogicPos(m_vEffectDestPos);
            OnSizeAndPos();
            m_bEffectPos = false;                
            OnEffectPosEnd();
            if(!m_bEffectSize)
            {
                if(m_bChildToEffectShow) // pokazanie dzieci
                {
                    m_bChildToEffectShow = false;
                    ShowEffectChilds();                
                }
                else
                    ShowChilds();
            }
        }
        */
    }
    void CheckEffectSize()
    {
        float fDiff = m_vEffectDestSize.Distance(GetLogicSize());                
        //LogLine(this + " CheckEffectSize() fDiff: "+fDiff+" tolerance "+m_fEffectPosTolerance);                        
        if(fDiff<m_fEffectPosTolerance)
        {
//            m_test_ef = true;
            //LogLine(this+" check size end ");
            Vector vOldSize = GetRealSize();  // stary rzeczywisty rozmiar by odpowiednio ustawic pozycje           
            SetLogicSize(m_vEffectDestSize);
            FittPosToSize(vOldSize, false); // dopasowanie pozycji do nowego rozmiaru           
            OnSizeAndPos();        
            if(!m_bEffectPos)
            {
                if(m_bChildToEffectShow)
                {
                    m_bChildToEffectShow = false;
                    ShowEffectChilds();
                }
                else
                    ShowChilds();
            }
            if(m_bRollingState)  // operacje po zwinieciu okna
            {
                SetLogicPos(m_vRollEndPos);
                SetLogicSize(m_vRollEndSize);
                OnSizeAndPos();
                m_bRollingState = false;
                Hide();
            }
            m_bEffectSize = false;                
            OnEffectSizeEnd();
        }        
    }
    void CheckEffectAlpha()
    {
        float fDiff = Math.abs(m_fTextureAlpha - m_fEffectDestAlpha);        
        //LogLine(" chaeck Alpha: fDiff: "+fDiff+" tolerance "+m_fEffectAlphaTolerance);                
        if(fDiff<m_fEffectAlphaTolerance)
        {
            SetTextureAlpha(m_fTextureAlpha);
            m_bEffectAlpha = false;                
            OnEffectAlphaEnd();
        }        
    }
    float lastdiff;
    void CheckEffectAngle()
    {
        float fDiff = Math.abs(GetRotation() - m_fEffectDestAngle);
        
        if( (fDiff >= lastdiff && lastdiff != 0) || fDiff == 0 )    
        {
            SetRotation(m_fEffectDestAngle);
            if( m_bDoNotRotateMask )
            {
                if( !m_bMaskDirection )
                {
                    MaskSetRotation( m_fEffectDestAngle );
                }
                else
                {
                    MaskSetRotation( -m_fEffectDestAngle );
                }
            }
            m_bEffectAngle = false;                
            OnEffectAngleEnd();
        }                
        lastdiff = fDiff;
    }    

    Vector m_vMaskMovePos = null;
    boolean m_bMaskOut = false;
    
    /** zmiana rozmiaru w ramce */
    void OnEffectPos(float fTimeDiff)
    {
        //LogLine(this + " OnEffectPos() "+GetModule().GetTime());       
        if(m_bEffectFirstPos)
        {
            return;
        }
        
        
        
        float fS = fTimeDiff * m_fEffectPosSpeed;
        Vector vMove = new Vector(m_vEffectPosDiff);
        
        vMove.Mul(fS);
        Vector vLogicPos = new Vector(m_vLogicPos);
        vLogicPos.Add(vMove);
        SetLogicPos(vLogicPos);
        
        OnSizeAndPos(); 
        
        if( m_bDoNotMoveMask )
        {
            float fPosX = m_vEffectDestPos.Distance(GetLogicPos())/m_vEffectDestPos.Distance(m_vEffectStartPos);
            if( m_bMaskOut )
            {
                fPosX = 1f - fPosX;
            }
            SetMaskLogicPos( fPosX, 0f );
            
        }
    }   
    /** zmiana rozmiaru w ramce */
    void OnEffectSize(float fTimeDiff)
    {
        //LogLine(this + " OnEffectSize() "+GetModule().GetTime());
        if(m_bEffectFirstSize)
        {
            m_bEffectFirstSize = false;
            return;
        }        
        float fS = fTimeDiff * m_fEffectSizeSpeed;
        Vector vMove = new Vector(m_vEffectSizeDiff);
        vMove.Mul(fS);
        Vector vLogicSize = new Vector(m_vLogicSize);
        vLogicSize.Add(vMove);
        
        Vector vOldSize = GetRealSize();  // stary rzeczywisty rozmiar
        
        SetLogicSize(vLogicSize);
        FittPosToSize(vOldSize, false);

        OnSizeAndPos();       
    }
    /** dostosowuje pozycje do zmiany rozmiaru w zaleznosci od sposobu rozwijania okna
     * parametr to stary rzeczywisty rozmiar okna, bInitPos - czy ustawienie pozycji przed rozwijaniem
     */
    void FittPosToSize(Vector vOldSize, boolean bInitPos)
    {
        // odpowiednie ustawienie okna
        Vector vNewSize = GetRealSize();
        
        float fSizeDiffX = vNewSize.fX - vOldSize.fX;
        float fSizeDiffY = vNewSize.fY - vOldSize.fY;
        
        Vector vNewPos = null;
        int nReferPoint = m_nReferPoint;
        
        if(m_bRolling)                  // TODO : jeszcze cos sie psuje przy rozwijaniu
           m_nReferPoint = m_nRollHideMode;  // z wyborem trybu skalowania
        if(m_bUnrolling)
           m_nReferPoint = m_nRollShowMode;        
        
        switch(m_nReferPoint)
        {
        case _CENTER:
            if(bInitPos)
                vNewPos = new Vector(GetRealX() + fSizeDiffX/2, GetRealY() + fSizeDiffY/2, 0);               
            else
                vNewPos = new Vector(GetRealX() - fSizeDiffX/2, GetRealY() - fSizeDiffY/2, 0);
            SetRealPos(vNewPos);
            break;
        case _BOTTOM_RIGHT:
            if(bInitPos)
                vNewPos = new Vector(GetRealX() + fSizeDiffX, GetRealY() + fSizeDiffY, 0);
            else
                vNewPos = new Vector(GetRealX() - fSizeDiffX, GetRealY() - fSizeDiffY, 0);                      
            SetRealPos(vNewPos);
            break;
        case _BOTTOM_LEFT:
            if(bInitPos)
                vNewPos = new Vector(GetRealX(), GetRealY() + fSizeDiffY, 0);
            else
                vNewPos = new Vector(GetRealX(), GetRealY() - fSizeDiffY, 0);                      
            SetRealPos(vNewPos);
            break;
        case _TOP_RIGHT:
            if(bInitPos)
                vNewPos = new Vector(GetRealX() + fSizeDiffX, GetRealY(), 0);
            else
                vNewPos = new Vector(GetRealX() - fSizeDiffX, GetRealY(), 0);                      
            SetRealPos(vNewPos);
            break;
        case -1:
        case _TOP_LEFT:  // nic nie robi
            
            break;
        }       
    }
    /** zmiana rozmiaru w ramce */
    void OnEffectAlpha(float fTimeDiff)
    {
        //LogLine(this + " OnEffectAlpha() "+GetModule().GetTime());
        if(m_bEffectFirstAlpha)
        {
            m_bEffectFirstAlpha = false;
            return;
        }        
        
        float fS = fTimeDiff * m_fEffectAlphaSpeed;       
        //LogLine(" ALPHA: fS: "+fS);               
        
        float fAlpha = m_fTextureAlpha + fS;

        //LogLine(" ALPHA: new Alpha : "+fAlpha);                      
        SetTextureAlpha(fAlpha);
    }
    
    void SetAngleNoEffect(float fDestAngle, boolean bDontRotateMask, boolean bMaskDir)
    {
        float fCurrRot = GetRotation();

        float fAngle = fDestAngle;
        
        if( fAngle >= 360  || fAngle < -360 )
        {
            SetRotation( 0 );
            if( m_bDoNotRotateMask )
            {
                MaskSetRotation( 0 );
            }
            fAngle %= 360;
            m_fEffectDestAngle %= 360;
        }
        
        if( bDontRotateMask )
        {
            if( !bMaskDir )
            {
                MaskSetRotation( fAngle );
            }
            else
            {
                MaskSetRotation( -fAngle );
            }
        }        
        SetRotation(fAngle);
    }
    
    /** zmiana rozmiaru w ramce */
    void OnEffectAngle(float fTimeDiff)
    {
        float fCurrRot = GetRotation();
        if(m_bEffectFirstAngle)
        {
            m_bEffectFirstAngle = false;
            lastdiff = 0;
            return;
        }        
        float fS = fTimeDiff * m_fEffectAngleSpeed;       
        float fAngle = GetRotation()+fS;
        
        if( fAngle >= 360  || fAngle < -360 )
        {
            SetRotation( 0 );
            if( m_bDoNotRotateMask )
            {
                MaskSetRotation( 0 );
            }
            fAngle %= 360;
            m_fEffectDestAngle %= 360;
        }
        
        if( m_fEffectDestAngle >= 0 )
        {
            if( fCurrRot < m_fEffectDestAngle
                && fCurrRot + fS >= m_fEffectDestAngle 
                && m_bRotateRightLeft)
            {
                fAngle = m_fEffectDestAngle;
            }
            else if( fCurrRot > m_fEffectDestAngle
                     && fCurrRot + fS < m_fEffectDestAngle
                     && !m_bRotateRightLeft)
            {
                fAngle = m_fEffectDestAngle;
            }
        }
        else
        {
            if( fCurrRot > m_fEffectDestAngle
                && fCurrRot + fS <= m_fEffectDestAngle
                && !m_bRotateRightLeft)
            {
                fAngle = m_fEffectDestAngle;
            }
            else if( fCurrRot < m_fEffectDestAngle
                     && fCurrRot + fS >= m_fEffectDestAngle
                     && m_bRotateRightLeft )
            {
                fAngle = m_fEffectDestAngle;
            }
        }
        
        if( fAngle >= 360 )//|| fAngle < -360 )
        {
            SetRotation( 0 );
            if( m_bDoNotRotateMask )
            {
                MaskSetRotation( 0 );
            }
            fAngle %= 360;
        }
        if( m_bDoNotRotateMask )
        {
            if( !m_bMaskDirection )
            {
                MaskSetRotation( fAngle );
            }
            else
            {
                MaskSetRotation( -fAngle );
            }
        }        
        SetRotation(fAngle);
        
    }   
    //----------- handlery przy rozpoczeciu efektow   
    public void OnEffectPosStart()
    {
    }
    public void OnEffectSizeStart()
    {
    }
    public void OnEffectAlphaStart()
    {
    }
    public void OnEffectAngleStart()
    {
    }      
    //----------- handlery po zakoczeniu efektow
    public void OnEffectPosEnd()
    {
    }
    public void OnEffectSizeEnd()
    {
    }
    public void OnEffectAlphaEnd()
    {
        if(m_bAlphaHidingState)
        {
            Hide();
            SetTextureAlpha(m_fEffectHideAlphaAfter);
            m_bAlphaHidingState = false;
        }
    }
    public void OnEffectAngleEnd()
    {
    }   
    
    /*   float  m_fRollShowTime = 0.0f;
    int m_nRollShowMode = -1;
    int m_fRollShowChildTime = 0.1;  // w jakich odstepach maja pojawiac sie dzieci
    boolean m_bRollHide = false; // czy okno ma sie zwjac w trybie Effect
    int m_nRollHideMode = -1;*/
    
    // -----------  Rozwijanie okien  
    public void ShowWithEffect()
    {
        Show(); 
        if(m_bEffectShowStartPos || m_bUnrolling)
        {
                int cnt = m_vChildWindows.size();
                for(int i = 0; i < cnt; i++)
                {
                    UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
                    wnd.Hide();
                }
                if(m_bUnrollingChild)
                    m_bChildToEffectShow = true;
        }      
        else
        {
            if(m_bUnrollingChild)
                ShowEffectChilds();            
        }
        if(m_bEffectShowStartPos)//&& m_vEffectShowStartPos!=null)
        {
            m_bEffectStartPosState = true;
            Vector vDestPos  = new Vector(m_vLogicPos);
            SetLogicPos(new Vector(m_vEffectShowStartPos));//m_vEffectShowStartPos);
            OnSizeAndPos();
            SetEffectDestPos(vDestPos, m_fEffectShowStartPosTime);
        }
        
        if(m_bUnrolling)
        {
            Vector vDestSize = new Vector(m_vLogicSize);
            SetRealSize(new Vector(0,0,0));
            
            //LogLine("ShowEffect in time "+m_fRollShowTime);
            SetEffectDestSize(vDestSize, m_fRollShowTime, m_nRollShowMode, true);
        }
        /*else
            if(m_bUnrollingChild)
            {
                ShowEffectChilds();
            }*/
        
        if(m_fEffectAlphaShowTime>0)
        {
            float m_fDestAlpha = m_fTextureAlpha;
            SetTextureAlpha(0);
            SetEffectDestAlpha(m_fDestAlpha, m_fEffectAlphaShowTime);            
        }
    }
    /** pokazuje dzieci z efektami     */
    public void ShowEffectChilds()
    {
        m_fRollShowChildCount = 0;
        CallMethodIn("ShowEffectNextChild", 0);           
    }
    public void ShowEffectNextChild()
    {
        if(m_fRollShowChildCount < m_vChildWindows.size())
        {
            ((UIWindow)(m_vChildWindows.elementAt(m_fRollShowChildCount))).ShowWithEffect();
            m_fRollShowChildCount++;
            CallMethodIn("ShowEffectNextChild",m_fRollShowChildTime);
        }
    }   
    /** pokazuje dzieci bez efektow     */
    public void ShowChilds()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.Show();
        }    
    }
    /** ukrywa okno w sposob Effect      */
    public void HideWithEffect()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.Hide();
        }        
        
        if(!m_bRolling && m_fEffectAlphaHideTime<=0)
        {
            Hide();
            return;
        }
        if(m_fEffectAlphaHideTime>0)  // ukrywanie okna przez zmiane alphy
        {
            m_bAlphaHidingState = true;
            m_fEffectHideAlphaAfter = m_fTextureAlpha;
            SetEffectDestAlpha(0, m_fEffectAlphaHideTime);
        }
        if(m_bRolling) // ukrywanie okna przez zwijanie
        {
            m_vRollEndPos = new Vector(GetLogicPos());
            m_vRollEndSize = new Vector(GetLogicSize());
            m_bRollingState = true;
            //LogLine("ShowEffect in time "+m_fRollShowTime);
            SetEffectDestSize(new Vector(0,0,0), m_fRollHideTime, m_nRollShowMode, false);                            
        }

    }   
    // pt:.-------------------  Interfejs ustawiania parametrow dla efektow 
    /** globalne parametry odswiezania efektow     */
    void SetEffectsParam(float fGrain)
    {
        m_fEffectGrain = fGrain;       
    }
    /** parametry dla przesuwania okna     */
    void SetEffectPosParam(float fTolerance)
    {
        m_fEffectPosTolerance = fTolerance;
    }
    /** parametry dla skalowania okna     
     * fTolerance - tolerancja dla waurnku stopu
     * nReferPoint - wzgledem ktorego rogu ma byc skalowane okno :
     *         - stale: _CENTER, _BOTTOM_RIGHT itd....
     * */
    void SetEffectSizeParam(float fTolerance, int nReferPoint)
    {
        m_fEffectSizeTolerance = fTolerance;
        m_nReferPoint = nReferPoint;
    }
    /** parametry dla blendowania     
     * fTolerance - tolerancja dla waurnku stopu
     * */
    void SetEffectAlphaParam(float fTolerance)
    {
        m_fEffectAlphaTolerance = fTolerance;        
    }    
    /** parametry dla obracania okna     
     * fTolerance - tolerancja dla waurnku stopu
     * */
    void SetEffectAngleParam(float fTolerance)
    {
        m_fEffectAngleTolerance = fTolerance;        
    }
    /** ustawia zwijanie okna dla metody HideWithEffect()
     */
    void SetEffectRolling(boolean bSet)
    {
        m_bRolling = bSet;
    }    
    /** ustawia rozwijanie okna dla metody ShowWithEffect()
     */    
    void SetEffectUnrolling(boolean bSet)
    {
        m_bUnrolling = bSet;
    }
    /** Ustawia  parametry pokazywania sie okna metoda ShowEffect()
     *  fRollShowTime - czas rozwijania
        nRollShowMode - tryb rozwijania (jak w przypadku skalowania)
        fRollShowChildTime - czas pokazywania kolejnych dzieci po rozwinieciu
        fEffectAlphaShowTime -  czas blendowania przy pokazywaniu okna
     */
    void SetEffectShowParam(int nRollShowMode, float fRollShowTime, 
                            float fRollShowChildTime, float fEffectAlphaShowTime)
    {
        m_fRollShowTime = fRollShowTime;
        m_nRollShowMode = nRollShowMode;
        m_fRollShowChildTime = fRollShowChildTime;
        m_fEffectAlphaShowTime = fEffectAlphaShowTime;
    }

    /** Ustawia  parametry chowania sie okna metoda HideEffect()
     * nRollHideMode - tryb rozwijania (jak w przypadku skalowania)
     * fEffectAlphaHideTime - czas blendowania przy pokazywaniu okna
     */
    void SetEffectHideParam(int nRollHideMode, float fEffectAlphaHideTime)
    {    
        m_nRollHideMode = nRollHideMode;
        m_fEffectAlphaHideTime = fEffectAlphaHideTime;
     }
    //------------------------------------------------------------------------
    
    
    public void TestAction()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.TestAction();
        }
    }
    public void TestAction1()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.TestAction1();
        }
    }
    public void TestAction2()
    {
        int cnt = m_vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            UIWindow wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
            wnd.TestAction2();
        }
    }   

    /**metoda resetuje ostatni czas updejtu efektow, przydatne przy loadowaniu gry*/
    public void ResetEffectTimeRecursive()
    {
        UIWindow wnd;	
        int cnt = m_vChildWindows.size();
        for (int i = 0; i < cnt; i++)
        {
            wnd = (UIWindow)m_vChildWindows.elementAt(i);	   				
            wnd.ResetEffectTimeRecursive();
        }
        m_fLastEffectTime = GetTime();
    }

    public boolean BlockGameRendering()
    {
        while(!super.BlockGameRendering())
        {
            //Log("Waiting for OnPaint to end");
        }
        return true;
    }
    
    boolean IsAPattern()
    {
        if (m_sId != null)
        {
            return m_sId.equals(EUIConst.sWINDOW) ||
                   m_sId.equals(EUIConst.sBUTTON) ||
                   m_sId.equals(EUIConst.sCONTROL_OBJECT) ||
                   m_sId.equals(EUIConst.sEDIT) ||
                   m_sId.equals(EUIConst.sMENU) ||
                   m_sId.equals(EUIConst.sMENUBUTTON) ||
                   m_sId.equals(EUIConst.sSTATIC) ||
                   m_sDefType.equals(EUIConst.strPATTERN);
        }
        else
        {
            if (m_sDefType != null)
                return m_sDefType.equals(EUIConst.strPATTERN);
            else
                return false;
        }
    }
    
    /**czy okno jest potomkiem patterna zapisanego w osobnym pliku*/
    boolean IsAnExternalPatternChild()
    {
        UIWindow cParent = m_wndParent;
        while (cParent != null)
        {
            if (cParent.IsAPattern())
            {
                if (cParent.m_sPatternFile != null)
                    return true;
                else
                    return false;
            }
            else
                cParent = cParent.m_wndParent;
        }
        return false;
    }
    
    String ParsePatternName(UIWindow cWnd)
    {
        String sId = cWnd.m_sId;
        String sDefType = cWnd.m_sDefType;

        String sPattern = null;
        if (sDefType.equals(EUIConst.strREGULAR))
        {
            sPattern = GetStandardPatternName(cWnd);
            return sPattern;
        }
        
        int nComma = sDefType.indexOf(".");
        sPattern = sDefType.substring(nComma + 1, sDefType.length());
        return sPattern;
        
        
    }
    
    String GetStandardPatternName(UIWindow cWnd)
    {
        if (cWnd instanceof UIEdit)
            return EUIConst.sEDIT;
        if (cWnd instanceof UIMenuButton)
            return EUIConst.sMENUBUTTON;
        if (cWnd instanceof UIButton)
            return EUIConst.sBUTTON;
        if (cWnd instanceof UIMenu)
            return EUIConst.sMENU;
        if (cWnd instanceof UIControlObject)
            return EUIConst.sCONTROL_OBJECT;
        if (cWnd instanceof UIStatic)
            return EUIConst.sSTATIC;
        if (cWnd instanceof UIWindow)
            return EUIConst.sWINDOW;
        
        CrashLog("UIWindow.GetStandardPatternName UNKNOWN CLASS " + cWnd.getClass().getName() + "\n");
        return null;
    }
}
