public class UserInterface extends UIControlObject
{
	//Fonts cFonts;   TODO
	/** nazwa pliku skryptowego  */
	String m_sFileName;
	
    UIEdAppInterface m_cEdInterface = null;
    
    static boolean s_bInEditor = false;
    
	void OnCreate()
	{
	   super.OnCreate();
	   m_nFocusSelectorUp = EUIConst.NO_DEFINED;
       m_nFocusSelectorDown = EKey._TAB;	   
	   m_cSupervisor = this;	
	   m_bFocus=true;
	   
       //standardowe kursory i tekstura do edycji, musza znajdowac sie na sciezce szukania tekstur
       //obecnie sa w data\interface
       m_sCursorMoveTex        = "c_move.png";
       m_sCursorOutsideEditTex = "c_arrow.png";
       m_sCursorSizeTex        = "c_resize.png";
       m_sEditTexName          = "er_t_red.png";
       m_bUnrolling = false;      
	}

	void SetFileName(String sFileName)
	{
		m_sFileName=sFileName;
	}
	
    void SetEditorInterface(UIEdAppInterface cI)
    {
        m_cEdInterface = cI;
    }
    
	String GetFileName()
	{
	  return m_sFileName;	
	}
	void UpdateParentPos()
	{
	}
	/** laduje pusty interface */
	boolean LoadEmpty(Module mod)
    {
        s_bInEditor = true;
        mod.AddSprite((Sprite)this);				
		m_sClassName = "UserInterface";		
		this.AddToInterface();
		this.OnInit();
		return true;
	}
	
    void EditorLoad()
    {
        s_bInEditor = true;
    	Load(GetModule());
        SetActive(false);
		Reload();
        
        MoveTop();
        Hide();
        m_cEdInterface.LoadFinished();
    }
        
	boolean Load(Module mod)
	{
        //CrashLog("UserInterface.Load() " + m_sFileName);
        return Load(mod, null, true);
	 }

	boolean Load(Module mod, String sName)
	{
	  return Load(mod, sName, true);
	}
	
    boolean Load(Module mod, String sName, boolean bShow)
    {
        if (sName != null)
            SetFileName(sName);        
        ParseKeyword elemKey;
		ParseKeyword root=GameObject.ParseFile(m_sFileName);
	    mod.AddSprite((Sprite)this);		
		m_sClassName = "UserInterface";
		
        //CrashLog("Loading UserInterface <"+sName+">\n");
        
        if(root==null)
        {
			LogLine("Glowny Key z parsera == null !!!");
            Tools.CrashLogError("UserInterface:: No file " + sName + "!");
			return false;
        }
        else 
		{
		   //LogLine("Parser zaladowany");	
  		   ParseKeyword key;
		   for(key=root; key!=null; key=key.GetNext())
		   {
 		     if(key.Equals("Interface"))
			 {  
				 m_sId = key.GetSParam(0);
                 /** parametry interfejsu
                  */
                 for(ParseKeyword keyPar=key.GetChild(); keyPar!=null; keyPar=keyPar.GetNext())                 
                 {
                    if(keyPar.Equals("EditTexture"))						 
                    {
				       CreateEditBorder(keyPar.GetSParam(0));     			 
                    }

                    if(keyPar.Equals("EditBorderWidth"))						 
                    {
		    		    m_fEditBorderWidth = keyPar.GetFParam(0);
                    }

                    if(keyPar.Equals("EditBorderSens"))						 
                    {
    	    			m_fEditBorderSens = keyPar.GetFParam(0);
                    }
                    if(keyPar.Equals("EditCursor"))						 
                    {
    			    	m_sCursorOutsideEditTex = keyPar.GetSParam(0);
                    }
                    if(keyPar.Equals("EditCursorSize"))						 
                    {
    			    	m_sCursorSizeTex = keyPar.GetSParam(0);
                    }

                    if(keyPar.Equals("EditCursorMove"))						 
                    {
    		    		m_sCursorMoveTex = keyPar.GetSParam(0);
                    }
			        if(keyPar.Equals("Cursor"))						 
			        {		
				        m_sCursorTex = keyPar.GetSParam(0);
			        }                    
                 }
        		 Load(key);  // parametry dla UIControlObject
			 }
		   }
           root.delete();
		 }

        SetVisible(bShow);
        
        //LogLine("Przed SetMembersEditState");
		this.SetMembersEditState();
        //LogLine("Przed AddToInterface");		
		
        this.AddToInterface();
        
        
        
		//LogLine("==========================  ON INIT =========================");	
        this.ReloadSizeAndPos();    
		this.OnInit();
		this.Reload();

	    return true;        
    }
    
	/** dopisuje do wektora interfejsu wszystkie zagniezdzone elementy */
	void AddToInterface()
	{
       m_cSupervisor = this;
       RemoveCursor();
	   m_currCursor = CreateCursor();
       if (Game._bDbg)
           CrashLog("Creating cursor for " + this);
	   m_currCursor.Init(GetModule());
	   if(m_sCursorTex!=null)
		       SetCursor(m_sCursorTex);	
	   m_currCursor.Show();
	   
	   super.AddToInterface(m_vMembers);
	
    }
    
    /**Tworzy kursor, zeby korzystac z innych kursorow niz UICursor trzeba przeciazyc te funkcje
     */
    UICursor CreateCursor()
    {
        UICursor cCursor = (UICursor)CreateObject("UICursor");
        cCursor.SetName("CursorFor" + getClass().getName());
        return cCursor;
    }
    
	void RemoveCursor()
	{
		if(m_currCursor!=null)
		{
			m_currCursor.Destroy();
			m_currCursor.GetModule().RemoveSprite(m_currCursor);  
			//WARNING moze sie wywalac, jesli Remove jest wolane z petli przetwarzania 
			//klawiatury lub myszy
			m_currCursor.CallMethodIn("delete", 0);
			m_currCursor = null;
		}
	}
	
	void Remove()
	{
		RemoveCursor();
        ReleaseTextures();
		super.Remove();
	}
	
   void ShowElems()
   {
	   
    	UIWindow wnd;
		int cnt = m_vMembers.size();
		//LogLine("Pokazuje elementy interfejsu: "+cnt);
		for(int i = 0; i < cnt; i++)
		{
			wnd = (UIWindow)m_vMembers.elementAt(i);	   
			//LogLine("Id: "+wnd.m_sId);
		}			   
   }
	
	

	void ShowElem(String sId)
	{
          UIWindow wnd;
		  wnd = GetElem(sId);
		  if(wnd!=null)
			  wnd.Show();
	}
	

	void HideElem(String sId)
	{
          UIWindow wnd;
		  wnd = GetElem(sId);
		  if(wnd!=null)
			  wnd.Hide();
	}
	
    boolean m_bProcessedMouse = true;
    boolean m_bProcessedKb = true;
    
    public void Hide()
    {
        //CrashLog("Hide " +this);
        super.Hide();
        if (m_currCursor != null)
            m_currCursor.Hide();
    }
    
    public void Show()
    {
        //TODO dodac rozsadniejsze pokazywanie kursora
        //CrashLog("Show " +this);
        super.Show();
        if ((m_currCursor != null) && m_bCursorVisible)
            m_currCursor.Show();
    }
    
    
	void ChangeState()
	{
		
	}
	
	void ChangeCursor()
	{
		
	}
	
	/** sprawdza czy dany element podrzedny moze przyjac focusa */
	boolean CanFocus(UIWindow wnd)
	{
	  if(wnd!=this)
	      return super.CanFocus(wnd);
	  else
		  return false;
	}
	
	
	void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);	
        //CrashLog("OnUICommand " + cSender);
		/*if(nCommand == EUIConst.CM_DBCLICK)
			LogLine("-i-- Double Click -----"+cSender.m_sId);
		if(nCommand == EUIConst.CM_CLICK)
			LogLine("-i--  Click -----"+cSender.m_sId);
		if(nCommand == EUIConst.CM_SEL)
			LogLine("-i--  Sel -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		
		if(nCommand == EUIConst.CM_SEL_DBCLICK)
						LogLine("-i--  Sel_dbClick -----"+ cSender.m_sId+" z menu "
					+(((UIMenuButton)cSender).GetMenu()).m_sId);		
        */
		
	}
	void OnUINotify(UIWindow cSender, int nEvent)
	{
		super.OnUINotify(cSender,nEvent);
		/*if(nEvent == EUIConst.EV_FOCUS)
			LogLine("-i-- Focus -----"+cSender.m_sId);
		if(nEvent == EUIConst.EV_FOCUSOFF)
			LogLine("-i--  Focus_off -----"+cSender.m_sId); 
        */
	}		 
        
    void Copy(UIWindow cWndDest, UIWindow cWndSrc)
	{
      UserInterface cDest = (UserInterface)cWndDest;
	  UserInterface cSrc = (UserInterface)cWndSrc;
	  super.Copy(cDest,cSrc);
	  //LogLine("Copy of intefaces !!!!!!!!!!!!!!");
	}
    
    void OnChangeResolution()
    {
        Reload();        
        if (m_currCursor != null)
            m_currCursor.OnChangeResolution();
    }
    
    void ShowCursor(boolean bShow)
    {
        if ((m_currCursor != null) && m_bCursorVisible)
        {
            if (bShow)
                m_currCursor.Show();
            else
                m_currCursor.Hide();
        }
    }
 
    
    public void SGUpdate()
	{
        ResetEffectTimeRecursive();
		super.SGUpdate();
	}
    
}
