/** Warunek sprawdza odleglosc dwoch obiektow.
 * Gdy ktorykolwiek z obiektow jest null to zwraca false.
 * Gdy nie podany typ relacji rowniez zwraca false.
 */
public class cnd_ObjectsDistance extends Condition
{
    // pierwszy obiekt brany do liczenia odleglosci
    public ControlObject cObject1 = null;//#
    
    // drugi obiekt brany do liczenia odleglosci
    public ControlObject cObject2 = null;//#
    
    // odleglosc miedzy obiektami
    public float fDistance = 0;//#
    
    // relacja podanego progu wartosci i odleglosci obiektow
    public EnumRelation cRelation = null;//#
    
    // kwadrat odleglosci dla przyspieszenia obliczen
    float fDist2 = 0;

    boolean bDebug = false;
    
    void OnCreate()
    {
        fDist2 = fDistance*fDistance;
    }
    
    boolean EvaluateInternal()
    {
        if(cObject1 == null || cObject2 == null) return false;
        
        float fCurrDist2 = cObject1.GetDistance2To(cObject2);
        
        if(bDebug)
            CrashLog("[cnd_ObjectsDisance] cObject1='"+cObject1.GetName()+"':"+cObject1.GetUniqueID()+" cObject2='"+cObject2.GetName()+"':"+cObject2.GetUniqueID()+" fCurrDist2="+fCurrDist2+"\n");
        
        if( cRelation.GetValue() == EnumRelation._LESS )
            return fCurrDist2 < fDist2;
        
        if( cRelation.GetValue() == EnumRelation._GREATER )
            return fCurrDist2 > fDist2;
        
        if( cRelation.GetValue() == EnumRelation._EQUAL )
            return fCurrDist2 == fDist2;
        
        // relacja nie rozpoznana to warunek nie prawdziwy
        return false;
    }   	
}
