
/** Warunek bedzie prawdziwy po podanym czasie od pierwszego sprawdzenia warunku
 */
public class cnd_TimePassed extends Condition
{
	cnd_TimePassed()
	{
		bSG = true;
	}
	
    // komentarz pokazywany w edytorze
    {sEditorComment = "Becomes true when specified time expires";}
    
    // czas po jakim warunek bedzie prawdziwy
    public float fInterval = 0.0f;//#;Time interval 
	
	public boolean bRestartAfterTimePassed = false; //#;Whether to restart the timer once the condition becomes true 
    
    // czas pierwszego sprawdzenia warunku
    float fStartTime = -1.0f;

    boolean EvaluateInternal()
    {
        if(fStartTime == -1.0f)
        {
            fStartTime = GetTime();
            return false;
        }
        else
        {
			if (GetTime() - fStartTime > fInterval)
			{
				if (bRestartAfterTimePassed)
					fStartTime = -1.0f;
				
				return true;
			}
			else
				return false;
        }
    }
	
    void Clear()
    {
        // odswiezamy liczenie warunku
        fStartTime = GetTime();
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[cnd_TimePassed.SGSaveChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunks._CHK_CND_TIME_PASSED)
        {
			super.SGLoadChunk(cFC);
			// czas po jakim warunek bedzie prawdziwy
			fInterval = cFC.LoadFloat();
			// czas pierwszego sprawdzenia warunku
			fStartTime = cFC.LoadFloat();			
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[cnd_TimePassed.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunks._CHK_CND_TIME_PASSED, cFCParent);

		super.SGSaveChunk(cFC);
		
		// czas po jakim warunek bedzie prawdziwy
		 cFC.SaveFloat( fInterval );
		// czas pierwszego sprawdzenia warunku
		 cFC.SaveFloat( fStartTime );			
			
		cFC.delete();
	}				
}
