abstract public class Sensor extends EditorRenderableObject	implements iact_EnableDisable, IEnterLeave
{
    Sensor()
    {
        EditorMeshName = "data\\interface\\dot.3da";
        iRenderType = EEditorRenderType._MESH;
    }
    
    /** Czas co jaki bedzie sprawdzany sensor */
    //TODO wywalic cos takiego i inaczej sprawdzac sensory
    public float fCheckInterval = 0.1f; //#SENSOR
    
    /** Promien dzialania sensora pobierany ze skali obiektu */
    public float fRadius = 0;
    
    /** Kwadrat promienia dzialania sensora - do optymalizacji sprawdzania odleglosci */
    public float fRadius2 = 0;
    
    /** Oresla czy sensor jest aktywny/nieaktywny */
    public boolean bEnabled = true;//#\SENSOR

    /** Flaga ustawiana po pierwszym wejsciu w sensor.
     * Uzywana do sprawdzania w cnd_Sensor */
    boolean bEnteredOnce = false;
    
    /** Flaga ustawiana po pierwszym wyjsciu z sensora.
     * Uzywana do sprawdzania w cnd_Sensor */
    boolean bLeftOnce = false;

    public void OnCreate()
    {
		bSG = true;
		
        // uruchamiamy wolanie checka z losowym opozinieniem
        CallMethodEvery("Check", fCheckInterval, RandomFloat(fCheckInterval));
        
        // wyciagamy skale obiektu
        Vector vScale = GetScale();

        if(vScale == null)
        {
            fRadius = 0;
            fRadius2 = 0;
        }
        else
        {
            if(vScale.fX > vScale.fY)
                fRadius = vScale.fX;
            else
                fRadius = vScale.fY;
        
            fRadius *= 100.0f;
            fRadius2 = fRadius*fRadius;
        }
    }
    
    void Check()
    {
    }
    
    // updejtowanie danych na podstawie macierzy - do edytora
	public boolean UpdateDataByMatrix(){ return false;}
    
    // updejtowanie macierzy na podstawie danych - do edytora
	public boolean UpdateMatrixByData(){ return false;}
    
    public void Enable()
    {
        bEnabled = true;
    }
    
    public void Disable()
    {
        bEnabled = false;
    }
    
    public boolean IsEnabled()
    {
        return bEnabled;
    }
    
    public boolean IsAlreadyEntered()
    {
        return bEnteredOnce;
    }
    
    public boolean IsAlreadyLeft()
    {
        return bLeftOnce;
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[Sensor.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunks._CHK_SENSOR)
        {
			super.SGLoadChunk(cFC);

			// Okresla czy sensor jest aktywny/nieaktywny.		
			bEnabled = cFC.LoadBool();
			// Flaga ustawiana po pierwszym wejsciu w sensor.
			bEnteredOnce = cFC.LoadBool(); 
			// Flaga ustawiana po pierwszym wyjsciu z sensora.
			bLeftOnce = cFC.LoadBool(); 
        }
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Sensor.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunks._CHK_SENSOR, cFCParent);
		
		super.SGSaveChunk(cFC);

		// Okresla czy sensor jest aktywny/nieaktywny.		
		cFC.SaveBool( bEnabled );
		// Flaga ustawiana po pierwszym wejsciu w sensor.
		cFC.SaveBool( bEnteredOnce ); 
		// Flaga ustawiana po pierwszym wyjsciu z sensora.
		cFC.SaveBool( bLeftOnce ); 		
			
		cFC.delete();
	}		
}
