/** Punkt nalezacy do sciezki
 */
public class PathPoint
{
    final static int _PPF_NOPATHFINDER  = 1;
	
	/** wektor flag */
	public int nFlags = 0;
	
    /** pozycja punkt w swiecie */
	public Vector vPosition = null;
    
    /** promien punktu wedlug ktorego ustala sie czy AI jest w tym punkcie */
    float fRadius = 100.0f;
    
    /** string oznaczajacy cokolwiek (np. nazwe metody) */
    String sTextField = null;
    
	/** odczytanie pozycji ze strumienia - uzywane zarowno przez AI jak i przez
	 * sciezki w module
	 */
	PathPoint(MapInputStream cStream) throws java.io.IOException
	{
		vPosition = new Vector(cStream);
	}

	PathPoint(Vector vPos)
	{
		vPosition = new Vector(vPos);
	}
	
	PathPoint(Vector vPos, float radius, int nFlags)
	{
		vPosition = new Vector(vPos);
		fRadius = radius;
		this.nFlags = nFlags;
	}
	
	PathPoint(PathPoint point)
	{
		nFlags = point.nFlags;
		vPosition = new Vector(point.vPosition);
		fRadius = point.fRadius;
		if ( (point.sTextField != null) && (point.sTextField.length() != 0) )
			sTextField = new String(point.sTextField);
		else
			sTextField = null;
	}
	
	/** zaladowanie dodatkowych danych ze strumienia (tylko do sciezek dla modulu)
	 */
    void LoadPathPointData(MapInputStream cStream) throws java.io.IOException
	{
		nFlags = cStream.readInt();
		fRadius = cStream.readFloat();
		sTextField = new String(cStream.readString());
		if ( (sTextField != null) && (sTextField.length() == 0) )
			sTextField = null;
	}
}
