/** Manager sciezek - zawiera informacje o sciezkach.
 */
public class PathsManager
{
	/** wektor wszystkich sciezek */
	java.util.Vector cPaths = new java.util.Vector();

	/** zwraca sciezke po identyfikatorze, jezeli nie ma
	 * takiej sciezki, zwraca null.
	 */
    public Path GetPathById(int nPathID)
	{
		Path path = null;
		for (int i = 0; i < cPaths.size(); i++)
		{
			path = (Path) cPaths.elementAt(i);
			if (path.nPathID == nPathID)
				return path;
		}
		return null;
	}
	
	/** ladowanie sciezek ze strumienia
	 */
	public void LoadPath(MapInputStream cStream)
	{
		Path path = new Path(cStream);
		cPaths.addElement(path);			
	}
	
	/** pobranie sciezki po numerze (od 0 do n - 1)
	 */
	public Path GetPathByNo(int nPathNo)
	{
		if ( (nPathNo < 0) || (nPathNo > cPaths.size()) )
			return null;
		return (Path) cPaths.elementAt(nPathNo);
	}

    
    /** pobranie sciezki po nazwie
	 */
	public Path GetPathByName(String sPathName)
	{
		for (int i = 0; i < cPaths.size(); i++)
		{
			Path path = (Path) cPaths.elementAt(i);
			if ( path.GetPathName().equals(sPathName) )
				return path;
		}
		return null;
	}
	
	
	/** pobranie liczby wszystkich sciezek
	 */
	public int GetPathsNum()
	{
		return cPaths.size();
	}
}
