import java.io.*;
public class ScriptWriter
{
    BufferedWriter m_cWriter = null;
    
    //ilosc tabulatorow ktora ma wejsc w Write
    int m_nIndentCnt = 0;
    
    static String sm_sIndent = "    ";
    
    void Open(String sFileName)
    {
        try
        {
            m_cWriter = new BufferedWriter( new FileWriter( sFileName ));
            m_nIndentCnt = 0;
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
    }
    
    void Close()
    {
        try
        {
            if ( m_cWriter != null )
            {
                m_cWriter.close();
                m_cWriter = null;
            }
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
    }
    
    void Write(String sBuffer)
    {
        Write( sBuffer, true );
    }
    
    void Write(String sBuffer,boolean bNewLine)
    {
        try
        {
            if ( m_cWriter != null )
            {
                for ( int i=0; i<m_nIndentCnt; i++ )
                    m_cWriter.write( sm_sIndent, 0, sm_sIndent.length() );
                
                m_cWriter.write( sBuffer, 0, sBuffer.length() );
                if ( bNewLine )
                    m_cWriter.newLine();
            }
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
    }
    void NewLine()
    {
        try
        {
            if ( m_cWriter != null )
                m_cWriter.newLine();
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
    }
    
    
    void IncIndent()
    {
        m_nIndentCnt ++;
    }
    
    void DecIndent()
    {
        if ( m_nIndentCnt > 0 )
            m_nIndentCnt --;
    }
}
